-- Global Variables

TrinityActionButtons = 120;
TrinityMaxDockShapes = 7;
TrinityKeyBindButton = 0;
TrinityKeyBindSpell = nil;
TrinityButtonStyle = 1;
TrinitySelfCastOption = 1;
TrinityXPTextIndex = 1;
TrinityReputationMonitor = 0;
TrinityReputationSelect = 0;

TrinityFirstRun = true;
TrinityDockBarsHide = false;
TrinityButtonsHide = false;
TrinityDockingUpdated = false;
TrinityBindingsUpdated = false;
TrinityPlayerEnteredWorld = false;
TrinityVariablesLoaded = false;
TrinityCombatLockdown = false;
TrinityDockLockdown = false;
TrinityButtonLock = false;
TrinityShiftButtonLock = false;
TrinityProwlBarActive = false;
TrinityKeyBindingTextHidden = false;
TrinityShowButtonTooltips = true;
TrinityDocksStored = false;
TrinityCoolDown = false;
TrinityChangeBarTypes = false;
TrinityAdaptivePagingEnabled = true;
TrinityGlobalTooltipEnabled = true;
TrinityDebugActive = false;

TrinitySavedVersion = "unknown";
TrinityCurrentVersion = "20003.13";
TrinityUnitSet = "Default";

TrinityDebug = {}
TrinityDockFrames = {};
TrinityReputationIndex = {};
TrinityXPFrameInfo = {};
TrinityTemplates = {};
TrinityTemplateList = {};
TrinitySpellBindings = {};
TrinityBarsSavedState = {};
TrinityBarsSavedState["docks"] = {};
TrinityBarsSavedState["buttons"] = {};
TrinityBarsSavedState["anchors"] = {};
TrinityBarsSavedState["storage"] = {};
TrinityForms = {}
TrinityFormsTransition = {}
TrinityBarsButtonLoc = { 12.63545630201, -121.64504791763 };
TrinityMiscBars = {
	["menu"] = 0,
	["bags"] = 0,
	["pet"] = 0,
	["form"] = 0,
	["cast"] = 0,
	["XP"] = 0,
}
TrinityTargets = {
	[1] = "none",
	[2] = "player",
	[3] = "pet",
	[4] = "target",
	[5] = "targettarget",
	[6] = "focus",
	[7] = "mouseover",	
	[8] = "party1",
	[9] = "partypet1",
	[10] = "party2",
	[11] = "partypet2",
	[12] = "party3",
	[13] = "partypet3",
	[14] = "party4",
	[15] = "partypet4",	
}

-- Main on load funtion, creates frames and initializes them
function TrinityBars_OnLoad()

	TrinityFunctionCounter("TrinityBars_OnLoad")

	MainMenuBar:Hide();
	
	UIParent.state = 0;

	local stowageFrame = CreateFrame("Frame", "TrinityStorageHeader", UIParent, "SecureStateDriverTemplate");
		stowageFrame:SetPoint("BOTTOM", 0, -200);
		stowageFrame:SetAttribute("state", "99");		
		stowageFrame.data = {
			["buttonIndex"] = {},
			["anchorIndex"]	= {},
			["buttonList"] = {},	
			["anchorList"] = {},			
			["buttonCount"] = 0,
			["anchorCount"] = 0,
			["class"] = UnitClass("player"),
		}
	
	local dockFrame = TrinityCreateDockFrame(0)
		dockFrame:SetUserPlaced(false);
		dockFrame:ClearAllPoints();			
		dockFrame:SetPoint("CENTER", "TrinityStorageHeader", "CENTER", 0, 0);
	
	local actionButton = TrinityCreateActionButton(0, 0, 0, TrinityStorageHeader)
		actionButton:SetPoint("CENTER", "TrinityStorageHeader", "CENTER", 0, 0);
		
	SlashCmdList["TRINITYSLASH"] = TrinitySlashHandler;
	SLASH_TRINITYSLASH1 = "/trinity";	
		
	DEFAULT_CHAT_FRAME:AddMessage("Trinity Bars Loaded");
end



-- Functions to create headers as needed
function TrinityCreateActionbarHeader(dockFrame)

	TrinityFunctionCounter("TrinityCreateActionbarHeader")

	local actionbarHeader = CreateFrame("Frame", dockFrame.headers["Actionbar"]["name"], UIParent, "SecureStateDriverTemplate");		
	actionbarHeader:UnregisterEvent("MODIFIER_STATE_CHANGED");
	actionbarHeader:UnregisterEvent("UPDATE_SHAPESHIFT_FORM");
	actionbarHeader:UnregisterEvent("UPDATE_STEALTH");	
	actionbarHeader:SetAttribute("statemap-actionbar", "$input");
	actionbarHeader:SetAttribute("statebindings","1:one;2:two;3:three;4:four;5:five;6:six");	
	dockFrame.headers["Actionbar"]["active"] = true;	
	
	return actionbarHeader;
end

function TrinityCreateStanceHeader(dockFrame)

	TrinityFunctionCounter("TrinityCreateStanceHeader")

	local stanceHeader = CreateFrame("Frame", dockFrame.headers["Stance"]["name"], UIParent, "SecureStateDriverTemplate");
	stanceHeader:UnregisterEvent("MODIFIER_STATE_CHANGED");
	stanceHeader:UnregisterEvent("ACTIONBAR_PAGE_CHANGED");
	stanceHeader:UnregisterEvent("UPDATE_STEALTH");	
	stanceHeader:SetAttribute("statemap-stance", "$input");		
	stanceHeader:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");
	dockFrame.headers["Stance"]["active"] = true;	

	return stanceHeader;		
end

function TrinityCreateStealthHeader(dockFrame)

	TrinityFunctionCounter("TrinityCreateStealthHeader")

	local stealthHeader = CreateFrame("Frame", dockFrame.headers["Stealth"]["name"], UIParent, "SecureStateDriverTemplate");		
	stealthHeader:UnregisterEvent("MODIFIER_STATE_CHANGED");
	stealthHeader:UnregisterEvent("ACTIONBAR_PAGE_CHANGED");
	stealthHeader:UnregisterEvent("UPDATE_SHAPESHIFT_FORM");
	stealthHeader:SetAttribute("statemap-stealth", "$input");
	stealthHeader:SetAttribute("statebindings","0:zero;1:one");	
	dockFrame.headers["Stealth"]["active"] = true;	
	
	return stealthHeader;
end

function TrinityCreateAltHeader(dockFrame)

	TrinityFunctionCounter("TrinityCreateAltHeader")

	local modifierAltHeader = CreateFrame("Frame", dockFrame.headers["Alt"]["name"], UIParent, "SecureStateDriverTemplate");		
	modifierAltHeader:UnregisterEvent("ACTIONBAR_PAGE_CHANGED");
	modifierAltHeader:UnregisterEvent("UPDATE_SHAPESHIFT_FORM");
	modifierAltHeader:UnregisterEvent("UPDATE_STEALTH");	
	modifierAltHeader:SetAttribute("statemap-alt", "$input");
	modifierAltHeader:SetAttribute("statebindings","0:zero;1:one");	
	dockFrame.headers["Alt"]["active"] = true;	
	
	return modifierAltHeader;
end

function TrinityCreateCtrlHeader(dockFrame)

	TrinityFunctionCounter("TrinityCreateCtrlHeader")
		
	local modifierCtrlHeader = CreateFrame("Frame", dockFrame.headers["Ctrl"]["name"], UIParent, "SecureStateDriverTemplate");		
	modifierCtrlHeader:UnregisterEvent("ACTIONBAR_PAGE_CHANGED");
	modifierCtrlHeader:UnregisterEvent("UPDATE_SHAPESHIFT_FORM");
	modifierCtrlHeader:UnregisterEvent("UPDATE_STEALTH");	
	modifierCtrlHeader:SetAttribute("statemap-ctrl", "$input");
	modifierCtrlHeader:SetAttribute("statebindings","0:zero;1:one");	
	dockFrame.headers["Ctrl"]["active"] = true;	
	
	return modifierCtrlHeader;
end

function TrinityCreateShiftHeader(dockFrame)

	TrinityFunctionCounter("TrinityCreateShiftHeader")

	local modifierShiftHeader = CreateFrame("Frame", dockFrame.headers["Shift"]["name"], UIParent, "SecureStateDriverTemplate");		
	modifierShiftHeader:UnregisterEvent("ACTIONBAR_PAGE_CHANGED");
	modifierShiftHeader:UnregisterEvent("UPDATE_SHAPESHIFT_FORM");
	modifierShiftHeader:UnregisterEvent("UPDATE_STEALTH");	
	modifierShiftHeader:SetAttribute("statemap-shift", "$input");
	modifierShiftHeader:SetAttribute("statebindings","0:zero;1:one");	
	dockFrame.headers["Shift"]["active"] = true;	
	
	return modifierShiftHeader;
end

function TrinityCreateNormalHeader(dockFrame)

	TrinityFunctionCounter("TrinityCreateNormalHeader")

	local normalHeader = CreateFrame("Frame", dockFrame.headers["Normal"]["name"], UIParent, "SecureStateDriverTemplate");		
	normalHeader:UnregisterEvent("MODIFIER_STATE_CHANGED");
	normalHeader:UnregisterEvent("ACTIONBAR_PAGE_CHANGED");
	normalHeader:UnregisterEvent("UPDATE_SHAPESHIFT_FORM");
	normalHeader:UnregisterEvent("UPDATE_STEALTH");	
	normalHeader:SetAttribute("state-normal", 0);
	normalHeader:SetAttribute("statemap-normal", "0:0");
	normalHeader:SetAttribute("statebindings","0:zero");	
	dockFrame.headers["Normal"]["active"] = true;
	
	return normalHeader;
end

function TrinityCreateAnchorHeader(dockFrame)

	TrinityFunctionCounter("TrinityCreateAnchorHeader")

	dockFrame.headers["Anchor"] = {
			["name"] = "TrinityAnchorHeader"..dockFrame:GetID(),
			["parent"] = nil,
			["showstate"] = "",			
			["active"] = false,
			["order"] = 99,
			["start"] = 0,
			["end"] = 0,
			["list"] = {
				[0] = ",",
			},
			["currState"] = 0,
		}	
	normalHeader = getglobal(dockFrame.headers["Normal"]["name"])	
		
	local anchorHeader = CreateFrame("Frame", dockFrame.headers["Anchor"]["name"], dockFrame, "SecureAnchorEnterTemplate");	
	anchorHeader:SetAttribute("anchorchild", normalHeader);
	anchorHeader:SetAttribute("*childraise-OnEnter", true);
	anchorHeader:SetAttribute("*childstate-OnEnter", "enter");
	anchorHeader:SetAttribute("*childstate-OnLeave", "leave");
	
	normalHeader:SetAttribute("statemap-anchor-enter", "0:1");
	normalHeader:SetAttribute("statemap-anchor-leave", "1:0");	
	normalHeader:SetPoint("TOPLEFT", dockFrame, "TOPLEFT", 0, 0)
	normalHeader:SetPoint("BOTTOMRIGHT", dockFrame, "BOTTOMRIGHT", 0, 0)
	dockFrame.headers["Anchor"]["active"] = true;	
	return anchorHeader;
end

function TrinityCreateHeaderEditorElements(editor)

	TrinityFunctionCounter("TrinityCreateHeaderEditorElements")

	local check, string, edit1, edit2, edit3, edit4;	
	local offset = 1;

	for i=0,6 do
		check = CreateFrame("CheckButton", "$parentActive"..i, editor, "TrinityCheckButtonTemplate");
		check:SetID(i)
		check:SetPoint("TOPLEFT", 1,-(offset))
		check:SetToplevel(true)
		check:SetScript("OnClick", function() local frame = editor:GetParent()
			if (not this:GetChecked()) then
				getglobal(this:GetParent():GetName().."Message"):Show()
				getglobal(this:GetParent():GetName().."Options"):Show()
				getglobal(this:GetParent():GetName().."Options").id = this:GetID()
				getglobal(this:GetParent():GetName().."Options").editor = editor
				getglobal(this:GetParent():GetName().."Options").frame = frame				
				getglobal(this:GetParent():GetName().."MessageMessageText"):SetText("Deactivating this header will remove all\nit's buttons and place them into storage") 
				getglobal(this:GetParent():GetName().."MessageMessageText"):SetTextColor(1,0.2,0.2)				
			else
				TrinityActivateHeader(this:GetID(), editor, frame)
			end end);
		check:SetScript("OnEnter", function()
				TrinityActionButton_SetTooltip()			
				GameTooltip:SetText("Click to activate/deactivate a state header\nDeactivating a state header with buttons\nplaces buttons into storage", 1.0, 1.0, 1.0);
				GameTooltip:Show(); end)
		check:SetScript("OnLeave", function()
				this.updateTooltip = nil;
				GameTooltip:Hide(); end)							
			
		string = editor:CreateFontString("$parentHeader"..i, "ARTWORK", "GameFontNormalSmall");
		string:SetPoint("TOPLEFT", 25,-(offset+4))
		string:SetText("TEST");
		
		edit1 = CreateFrame("EditBox", "$parentOrder"..i, editor, "TrinityEditBoxTemplate");
		edit1:SetID(i)
		edit1:SetPoint("TOPLEFT", 120,-(offset+1))
		edit1:SetScript("OnEnterPressed", function() local frame = editor:GetParent() TrinitySetHeaderValue(editor, frame, "order") end);
		edit1:SetScript("OnEnter", function()
				TrinityActionButton_SetTooltip()			
				GameTooltip:SetText("Set this number to the order\ninwhich the headers will cascade\nThe states of a header controls when\nheaders below it will show", 1.0, 1.0, 1.0);
				GameTooltip:Show(); end)
		edit1:SetScript("OnLeave", function()
				this.updateTooltip = nil;
				GameTooltip:Hide(); end)									
				
		string = editor:CreateFontString("$parentHeaderState"..i, "ARTWORK", "NumberFontNormalSmall");
		string:SetPoint("TOPLEFT", 155,-(offset+4))
		string:SetText("0");																	
		
		edit4 = CreateFrame("EditBox", "$parentShowstate"..i, editor, "TrinityEditBoxTemplate");
		edit4:SetID(i)
		edit4:SetPoint("TOPLEFT", 175,-(offset+1))
		edit4:SetScript("OnEnterPressed", function() local frame = editor:GetParent() TrinitySetHeaderValue(editor, frame, "showstate") end);
		edit4:SetScript("OnEnter", function()
				TrinityActionButton_SetTooltip()			
				GameTooltip:SetText("This is the showstate of this header\nThis number directly correlates to\nshowstates of the header directly above", 1.0, 1.0, 1.0);
				GameTooltip:Show(); end)
		edit4:SetScript("OnLeave", function()
				this.updateTooltip = nil;
				GameTooltip:Hide(); end)									
		
		offset = offset + 15;
	end
end

function TrinityHeaderEditorInitialize(editor, frame)

	TrinityFunctionCounter("TrinityHeaderEditorInitialize")

	local headers = {}		
	
	TrinityRefreshOrderList(frame)	
	
	for i=0,6 do
	
		frame.headers[frame.orderList[i]]["stateRef"] = i;
	
		if (frame.orderList[i] == "Actionbar") then
			getglobal(editor:GetName().."Header"..i):SetText("Paged Header")
		else
			getglobal(editor:GetName().."Header"..i):SetText(frame.orderList[i].." Header")
		end
		getglobal(editor:GetName().."Active"..i):SetChecked(frame.headers[frame.orderList[i]]["active"])
		if (frame.headers[frame.orderList[i]]["order"] == 99) then
			getglobal(editor:GetName().."Order"..i):SetText("")
		else
			getglobal(editor:GetName().."Order"..i):SetText(frame.headers[frame.orderList[i]]["order"])
		end
		
		getglobal(editor:GetName().."HeaderState"..i):SetText(frame.headers[frame.orderList[i]]["currState"])
		getglobal(editor:GetName().."HeaderState"..i):SetTextColor(0.1, 0.8, 0.1);
		
		if (frame.headers[frame.orderList[i]]["active"]) then
		
			if (i~=0) then
				if (tonumber(frame.headers[frame.orderList[i]]["showstate"]) > tonumber(frame.headers[frame.orderList[i-1]]["end"])) then
					getglobal(editor:GetName().."Showstate"..i):SetText("")			
					getglobal(editor:GetName().."Showstate"..i):SetBackdropColor(0.8,0,0);
				else
					getglobal(editor:GetName().."Showstate"..i):SetText(frame.headers[frame.orderList[i]]["showstate"])			
					getglobal(editor:GetName().."Showstate"..i):SetBackdropColor(0,0,0);
				end
			end		
		
			headers[i] = getglobal(frame.headers[frame.orderList[i]]["name"])			
			
			if (i==0) then
				getglobal(editor:GetName().."Active"..i):Hide();
				getglobal(editor:GetName().."Showstate"..i):SetText("0")			
				frame.headers[frame.orderList[i]]["parent"] = "UIParent"
				headers[i]:SetParent("UIParent");
				getglobal(editor:GetName().."Order"..i):SetBackdropColor(0,0,0,0);
				getglobal(editor:GetName().."Order"..i):SetBackdropBorderColor(0,0,0,0);				
				getglobal(editor:GetName().."Showstate"..i):SetBackdropColor(0,0,0,0);
				getglobal(editor:GetName().."Showstate"..i):SetBackdropBorderColor(0,0,0,0);								
			else
				frame.headers[frame.orderList[i]]["parent"] = frame.headers[frame.orderList[i-1]]["name"]
				getglobal(frame.headers[frame.orderList[i-1]]["name"]):SetAttribute("addchild", headers[i]);
				headers[i]:SetAttribute("useparent-unit*", true);
			end			
	
			headers[i]:SetAttribute("showstates", tostring(frame.headers[frame.orderList[i]]["showstate"]));		
		
			for j=frame.headers[frame.orderList[i]]["start"],frame.headers[frame.orderList[i]]["end"] do
				if (not frame.headers[frame.orderList[i]]["list"][j]) then
					frame.headers[frame.orderList[i]]["list"][j] = ",";
				end
			end
		end		
	end
	
	TrinityRefreshHeaders();
	
	TrinityUpdateDocking(frame)
end

function TrinityRefreshOrderList(frame)
	
	TrinityFunctionCounter("TrinityRefreshOrderList")

	frame.orderList = {}
	local count = 0;
	
	for key,value in pairs(frame.headers) do			
		if (frame.headers[key]["order"] ~= 99) then
			frame.orderList[frame.headers[key]["order"]] = key									
			frame.headers[key]["stateRef"] = frame.headers[key]["order"];
			if (key == "Normal") then	
				frame.headers["Normal"]["currState"] = 0;
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..frame.headers[key]["stateRef"]):SetText(frame.headers["Normal"]["currState"])		
				end
			end
			if (key == "Actionbar") then	
				frame.headers["Actionbar"]["currState"] = GetActionBarPage();
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..frame.headers[key]["stateRef"]):SetText(frame.headers["Actionbar"]["currState"])		
				end
			end
			if (key == "Stance") then	
				frame.headers["Stance"]["currState"] = GetShapeshiftForm();		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..frame.headers[key]["stateRef"]):SetText(frame.headers["Stance"]["currState"])		
				end
			end
			if (key == "Stealth") then	
				frame.headers["Stealth"]["currState"] = IsStealthed() or 0;		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..frame.headers[key]["stateRef"]):SetText(frame.headers["Stealth"]["currState"])	
				end
			end
			if (key == "Alt") then	
				frame.headers["Alt"]["currState"] = IsAltKeyDown() or 0;		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..frame.headers[key]["stateRef"]):SetText(frame.headers["Alt"]["currState"])		
				end
			end
			if (key == "Ctrl") then	
				frame.headers["Ctrl"]["currState"] = IsControlKeyDown() or 0;		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..frame.headers[key]["stateRef"]):SetText(frame.headers["Ctrl"]["currState"])		
				end
			end
			if (key == "Shift") then	
				frame.headers["Shift"]["currState"] = IsShiftKeyDown() or 0;		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..frame.headers[key]["stateRef"]):SetText(frame.headers["Shift"]["currState"])		
				end
			end			
			count = count + 1;
		end
	end
	
	frame.orderCount = count;
	
	for key,value in pairs(frame.headers) do			
		if (frame.headers[key]["order"] == 99) then			
			frame.orderList[count] = key				
			frame.headers[key]["stateRef"] = count;			
			if (key == "Normal") then	
				frame.headers["Normal"]["currState"] = 0;
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..count):SetText(frame.headers["Normal"]["currState"])		
				end
			end
			if (key == "Actionbar") then	
				frame.headers["Actionbar"]["currState"] = GetActionBarPage();				
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..count):SetText(frame.headers["Actionbar"]["currState"])		
				end
			end
			if (key == "Stance") then	
				frame.headers["Stance"]["currState"] = GetShapeshiftForm();		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then					
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..count):SetText(frame.headers["Stance"]["currState"])		
				end
			end
			if (key == "Stealth") then	
				frame.headers["Stealth"]["currState"] = IsStealthed() or 0;		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..count):SetText(frame.headers["Stealth"]["currState"])	
				end
			end
			if (key == "Alt") then	
				frame.headers["Alt"]["currState"] = IsAltKeyDown() or 0;		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..count):SetText(frame.headers["Alt"]["currState"])		
				end
			end
			if (key == "Ctrl") then	
				frame.headers["Ctrl"]["currState"] = IsControlKeyDown() or 0;		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..count):SetText(frame.headers["Ctrl"]["currState"])		
				end
			end
			if (key == "Shift") then	
				frame.headers["Shift"]["currState"] = IsShiftKeyDown() or 0;		
				if (TrinityHeaderEditor:GetID() == frame:GetID()) then	
					getglobal(TrinityHeaderEditor:GetName().."HeaderState"..count):SetText(frame.headers["Shift"]["currState"])		
				end
			end				
			count = count + 1;
		end
	end
end

function TrinitySetHeaderValue(editor, frame, field)

	TrinityFunctionCounter("TrinitySetHeaderValue")

	if (field == "order") then
		if (tonumber(this:GetText()) > 6 or tonumber(this:GetText()) == 0 or tonumber(this:GetID()) == 0) then
			TrinityHeaderEditorInitialize(editor, frame)
			return;
		end
		if (frame.orderList[tonumber(this:GetText())]) then
			frame.headers[frame.orderList[tonumber(this:GetText())]][field] = frame.headers[frame.orderList[tonumber(this:GetID())]][field]
		end
	end
	
	frame.headers[frame.orderList[tonumber(this:GetID())]][field] = tonumber(this:GetText())
	this:ClearFocus();
	TrinityHeaderEditorInitialize(editor, frame)
end

function TrinityActivateHeader(id, editor, frame)

	TrinityFunctionCounter("TrinityActivateHeader")

	local header
	
	check = getglobal(editor:GetName().."Active"..id)
	
	if (frame.headers[frame.orderList[id]]["active"]) then	
	
	
		for key,value in pairs(frame.headers) do
			if ((frame.headers[frame.orderList[id]]["order"] + 1) == frame.headers[key]["order"]) then
				frame.headers[key]["showstate"] = frame.headers[frame.orderList[id]]["showstate"]				
			end
		end	
	
		for key,value in pairs(frame.headers) do
			if (frame.headers[frame.orderList[id]]["order"] < frame.headers[key]["order"] and frame.headers[key]["order"] ~= 99) then
				frame.headers[key]["order"] = frame.headers[key]["order"] - 1;				
			end
		end
	
		frame.headers[frame.orderList[id]]["active"] = false
		frame.headers[frame.orderList[id]]["parent"] = "UIParent"
		frame.headers[frame.orderList[id]]["showstate"] = ""
		frame.headers[frame.orderList[id]]["order"] = 99
		getglobal(editor:GetName().."Showstate"..id):SetBackdropColor(0,0,0);		
		local count = 0;
		for showstate=frame.headers[frame.orderList[id]]["start"],frame.headers[frame.orderList[id]]["end"] do						
			if (frame.headers[frame.orderList[id]]["list"][showstate]) then			
				local buttonList = {};						
				string.gsub(frame.headers[frame.orderList[id]]["list"][showstate], "%d+", function (btn) table.insert(buttonList, btn) end);					
				for k,v in pairs(buttonList) do					
					local actionButton = getglobal(frame.config["btnType"]..v);		
					actionButton:ClearAllPoints();
					actionButton:SetPoint("CENTER", "TrinityStorageHeader", "CENTER");
					actionButton.config["dock"] = 0;
					actionButton.config["dockpos"] = 0;
					actionButton.config["showstate"] = "STORED";
					actionButton.config["header"] = "TrinityStorageHeader";
					actionButton:SetAttribute("showstates", "STORED");		
					TrinityStorageHeader:SetAttribute("addchild", actionButton);						
					frame.headers[frame.orderList[id]]["list"][showstate] = string.gsub(frame.headers[frame.orderList[id]]["list"][showstate], "(%D)"..v..",", "%1")				
					TrinityStorageHeader.data["buttonIndex"][tonumber(v)] = 1;
					TrinityStorageHeader.data["buttonCount"] = TrinityStorageHeader.data["buttonCount"] + 1;					
					count = count + 1;
				end
			end
		end
		
		if (count ~= 0) then
			UIErrorsFrame:AddMessage(count.." buttons placed into storage", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		end
		
		frame.headers[frame.orderList[id]]["list"] = { [0] = "," }	
		check:SetChecked(frame.headers[frame.orderList[id]]["active"])
	else
		

		frame.headers[frame.orderList[id]]["active"] = true		
		frame.headers[frame.orderList[id]]["showstate"] = tostring(frame.headers[frame.orderList[frame.orderCount-1]]["currState"]);	
		frame.headers[frame.orderList[id]]["order"] = frame.orderCount;
		frame.headers[frame.orderList[id]]["list"] = { [0] = "," }	
		check:SetChecked(frame.headers[frame.orderList[id]]["active"])
		if (not getglobal(frame.headers[frame.orderList[id]]["name"])) then		
			if (frame.orderList[id] == "Normal") then	
				header = TrinityCreateNormalHeader(frame)
			elseif (frame.orderList[id] == "Actionbar") then
				header = TrinityCreateActionbarHeader(frame)
			elseif (frame.orderList[id] == "Stance") then
				header = TrinityCreateStanceHeader(frame)
				frame.headers[frame.orderList[id]]["end"] = GetNumShapeshiftForms()
			elseif (frame.orderList[id] == "Stealth") then
				header = TrinityCreateStealthHeader(frame)
			elseif (frame.orderList[id] == "Alt") then
				header = TrinityCreateAltHeader(frame)
			elseif (frame.orderList[id] == "Ctrl") then
				header = TrinityCreateCtrlHeader(frame)
			elseif (frame.orderList[id] == "Shift") then
				header = TrinityCreateShiftHeader(frame)
			end			
		end	

		currState1 = frame.headers[frame.orderList[frame.orderCount-1]]["currState"]
		currState2 = frame.headers[frame.orderList[id]]["currState"]		
		if (frame.headers[frame.orderList[frame.orderCount-1]]["list"][currState1]) then			
			local buttonList = {};						
			string.gsub(frame.headers[frame.orderList[frame.orderCount-1]]["list"][currState1], "%d+", function (btn) table.insert(buttonList, btn) end);					
			for k,v in pairs(buttonList) do					
				local actionButton = getglobal(frame.config["btnType"]..v);														
				actionButton.config["showstate"] = currState2;
				actionButton.config["header"] = frame.headers[frame.orderList[id]]["name"]
				actionButton:SetAttribute("showstates", tostring(currState2));		
				getglobal(frame.headers[frame.orderList[id]]["name"]):SetAttribute("addchild", actionButton);
				frame.headers[frame.orderList[frame.orderCount-1]]["list"][currState1] = ",";
				if (not frame.headers[frame.orderList[id]]["list"][currState2]) then
					frame.headers[frame.orderList[id]]["list"][currState2] = ","
				end
				frame.headers[frame.orderList[id]]["list"][currState2] = frame.headers[frame.orderList[id]]["list"][currState2]..actionButton:GetID()..",";
			end
		end		
	end
	
	TrinityHeaderEditorInitialize(editor, frame)
end


function TrinityHeaderEditorDropDown_OnLoad()	

	TrinityFunctionCounter("TrinityHeaderEditorDropDown_OnLoad")
	
	UIDropDownMenu_Initialize(TrinityHeaderEditorPresets, TrinityHeaderEditorDropDown_Initialize, "MENU");	
end

function TrinityHeaderEditorDropDown_Initialize()

	TrinityFunctionCounter("TrinityHeaderEditorDropDown_Initialize")
	
	local info = UIDropDownMenu_CreateInfo();
	local checked;
	
	info.text = "Presets";
	--info.func = TrinitySelectRepFaction;
	info.value = 1
	info.checked = nil
	UIDropDownMenu_AddButton(info);	
end

function TrinityUpdateDockConfig(dockFrame)

	TrinityFunctionCounter("TrinityUpdateDockConfig")

	if (TrinityDockFrameEditorLeft:GetParent() == dockFrame) then
		if (TrinityDockFrameEditorLeft:IsVisible()) then
			TrinityDockFrameEditorLeft:Hide()
		else
			TrinityDockFrameEditorLeft:Show()						
		end				
	else
		TrinityDockFrameEditorLeft:Show()						
	end			
	TrinityDockFrameEditorLeft:SetParent(dockFrame:GetName())				
	TrinityDockFrameEditorLeft:SetPoint("TOPRIGHT", dockFrame:GetName(), "TOPLEFT",2,0)
	TrinityDockFrameEditorLeft:SetPoint("BOTTOMRIGHT", dockFrame, "BOTTOMLEFT",2,-0.25)	
	if (dockFrame:GetFrameLevel() > 0) then
		TrinityDockFrameEditorLeft:SetFrameLevel(dockFrame:GetFrameLevel()-1)												
	else
		TrinityDockFrameEditorLeft:SetFrameLevel(0)												
	end
	local leftChildren = { TrinityDockFrameEditorLeft:GetChildren() };
	for k,v in pairs(leftChildren) do
		leftChildren[k]:SetFrameLevel(dockFrame:GetFrameLevel()+1)
	end	
	
	if (TrinityDockFrameEditorRight:GetParent() == dockFrame) then
		if (TrinityDockFrameEditorRight:IsVisible()) then
			TrinityDockFrameEditorRight:Hide()
		else
			TrinityDockFrameEditorRight:Show()
		end			
	else
		TrinityDockFrameEditorRight:Show()						
	end				
	TrinityDockFrameEditorRight:SetParent(dockFrame:GetName())				
	TrinityDockFrameEditorRight:SetPoint("TOPLEFT", dockFrame, "TOPRIGHT",-2,0)
	TrinityDockFrameEditorRight:SetPoint("BOTTOMLEFT", dockFrame:GetName(), "BOTTOMRIGHT",-2,-0.23)								
	if (dockFrame:GetFrameLevel() > 0) then
		TrinityDockFrameEditorRight:SetFrameLevel(dockFrame:GetFrameLevel()-1)												
	else
		TrinityDockFrameEditorRight:SetFrameLevel(0)												
	end
	TrinityDockFrameEditorRightRows:SetText(dockFrame.config["columns"]);
	local rightChildren = { TrinityDockFrameEditorRight:GetChildren() };
	for k,v in pairs(rightChildren) do
		rightChildren[k]:SetFrameLevel(dockFrame:GetFrameLevel()+1)
	end	
	
	if (dockFrame.config["shape"] ~= 2) then
		TrinityDockFrameEditorRightIncreaseRows:Hide();
		TrinityDockFrameEditorRightDecreaseRows:Hide();
		TrinityDockFrameEditorRightColumns:Hide();
		TrinityDockFrameEditorRightRows:Hide();
	else
		TrinityDockFrameEditorRightIncreaseRows:Show();
		TrinityDockFrameEditorRightDecreaseRows:Show();
		TrinityDockFrameEditorRightColumns:Show();
		TrinityDockFrameEditorRightRows:Show();	
	end		
	
	if (dockFrame:GetID() == TrinityMiscBars["bags"]) then
		TrinityDockFrameEditorLeftShowGrid:Hide()
		TrinityDockFrameEditorLeftButtonTypes:Show()
		TrinityDockFrameEditorLeftSpacingUp:Show();
		TrinityDockFrameEditorLeftSpacingDown:Show();				
		TrinityDockFrameEditorLeftClose:Show()
		TrinityDockFrameEditorLeftClose:SetPoint("TOPLEFT",49,0)
		TrinityDockFrameEditorLeftButtonRight:Hide()
		TrinityDockFrameEditorLeftButtonLeft:Hide()		
		TrinityDockFrameEditorRightBarType:Hide()
		TrinityDockFrameEditorRightBarNumber:SetText("BagBar")
		TrinityDockFrameEditorRightBarNumber:Show()
	elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
		TrinityDockFrameEditorLeftShowGrid:Hide()
		TrinityDockFrameEditorLeftButtonTypes:Hide()
		TrinityDockFrameEditorLeftSpacingUp:Show();
		TrinityDockFrameEditorLeftSpacingDown:Show();				
		TrinityDockFrameEditorLeftClose:Hide()	
		TrinityDockFrameEditorLeftButtonRight:Show()
		TrinityDockFrameEditorLeftButtonLeft:Show()		
		TrinityDockFrameEditorRightBarType:Hide()
		TrinityDockFrameEditorRightBarNumber:SetText("MenuBar")
		TrinityDockFrameEditorRightBarNumber:Show()
		TrinityDockFrameEditorLeftMenuHighlight:SetFrameStrata("HIGH")
	elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then
		TrinityDockFrameEditorLeftShowGrid:Show()
		TrinityDockFrameEditorLeftButtonTypes:Show()
		TrinityDockFrameEditorLeftSpacingUp:Show();
		TrinityDockFrameEditorLeftSpacingDown:Show();				
		TrinityDockFrameEditorLeftClose:Hide()			
		TrinityDockFrameEditorLeftButtonRight:Hide()
		TrinityDockFrameEditorLeftButtonLeft:Hide()		
		TrinityDockFrameEditorRightBarType:Hide()
		TrinityDockFrameEditorRightBarNumber:SetText("PetBar")
		TrinityDockFrameEditorRightBarNumber:Show()
	elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then
		TrinityDockFrameEditorLeftShowGrid:Show()
		TrinityDockFrameEditorLeftButtonTypes:Show()
		TrinityDockFrameEditorLeftSpacingUp:Show();
		TrinityDockFrameEditorLeftSpacingDown:Show();				
		TrinityDockFrameEditorLeftClose:Hide()			
		TrinityDockFrameEditorLeftButtonRight:Hide()
		TrinityDockFrameEditorLeftButtonLeft:Hide()		
		TrinityDockFrameEditorRightBarType:Hide()
		TrinityDockFrameEditorRightBarNumber:SetText("FormBar")
		TrinityDockFrameEditorRightBarNumber:Show()
	elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
		TrinityDockFrameEditorLeftShowGrid:Hide()
		TrinityDockFrameEditorLeftButtonTypes:Hide()
		TrinityDockFrameEditorLeftSpacingUp:Hide();
		TrinityDockFrameEditorLeftSpacingDown:Hide();
		TrinityDockFrameEditorLeftClose:Show()			
		TrinityDockFrameEditorLeftClose:SetPoint("TOPLEFT",32,0)
		TrinityDockFrameEditorLeftButtonRight:Hide()
		TrinityDockFrameEditorLeftButtonLeft:Hide()		
		TrinityDockFrameEditorRightBarType:Hide()
		TrinityDockFrameEditorRightBarNumber:SetText("CastBar")
		TrinityDockFrameEditorRightBarNumber:Show()
	elseif (dockFrame:GetID() == TrinityMiscBars["XP"]) then
		TrinityDockFrameEditorLeftShowGrid:Hide()
		TrinityDockFrameEditorLeftButtonTypes:Hide()
		TrinityDockFrameEditorLeftSpacingUp:Hide();
		TrinityDockFrameEditorLeftSpacingDown:Hide();		
		TrinityDockFrameEditorLeftClose:Show()
		TrinityDockFrameEditorLeftClose:SetPoint("TOPLEFT",32,0)
		TrinityDockFrameEditorLeftButtonRight:Hide()
		TrinityDockFrameEditorLeftButtonLeft:Hide()		
		TrinityDockFrameEditorRightBarType:Hide()
		TrinityDockFrameEditorRightBarNumber:SetText("XPBar")
		TrinityDockFrameEditorRightBarNumber:Show()
	else
		TrinityDockFrameEditorLeftShowGrid:Show()
		TrinityDockFrameEditorLeftButtonTypes:Show()
		TrinityDockFrameEditorLeftSpacingUp:Show();
		TrinityDockFrameEditorLeftSpacingDown:Show();		
		TrinityDockFrameEditorLeftClose:Hide()
		TrinityDockFrameEditorLeftButtonRight:Hide()
		TrinityDockFrameEditorLeftButtonLeft:Hide()
		TrinityDockFrameEditorRightBarType:Show()
		TrinityDockFrameEditorRightBarNumber:Hide()
	end

	if (TrinityPlayerEnteredWorld) then
		for k,v in pairs(TrinityDockFrames) do
			getglobal("TrinityDockFrame"..k):SetBackdropColor(0, 0, 0, 0.5);
			getglobal("TrinityDockFrame"..k):SetBackdropBorderColor(0,0,0,0)
			getglobal("TrinityDockFrame"..k):SetFrameStrata("BACKGROUND");			
			if (k ~= this:GetID()) then				
				getglobal("TrinityDockFrame"..k):EnableKeyboard(false);					
				getglobal("TrinityDockFrame"..k).adjusting = false;					
				getglobal("TrinityDockFrame"..k).selected = false;			
			end
		end				
		if (dockFrame.selected) then
			if (IsShiftKeyDown()) then
				UIErrorsFrame:AddMessage("Keyboard enabled", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);												
			end
			dockFrame:SetFrameStrata("LOW");				
			dockFrame.selected= false;
			dockFrame:EnableKeyboard(false);		
		else
			if (IsShiftKeyDown()) then
				UIErrorsFrame:AddMessage("Keyboard disabled for frame mico-adjustment\nUse UP, DOWN, LEFT, RIGHT arrows\nto make micro position adjustments", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);												
				dockFrame:EnableKeyboard(true);
				dockFrame:SetBackdropColor(1, 0, 0, 0.5)											
				dockFrame:SetFrameStrata("DIALOG");
			else
				dockFrame:SetFrameStrata("LOW");			
				dockFrame:SetBackdropColor(0, 0, 0, 0.5);			
				dockFrame:SetBackdropBorderColor(0,0,0,0)				
				dockFrame.adjusting = true;		
				dockFrame.selected = true;
				dockFrame:EnableKeyboard(false)
			end
			
			local dockID = dockFrame:GetID();				
			if (dockID == TrinityMiscBars["bags"]) then		
				dockID = "B"
			elseif (dockID == TrinityMiscBars["menu"]) then
				dockID = "M"
			elseif (dockID == TrinityMiscBars["pet"]) then
				dockID = "P"
			elseif (dockID == TrinityMiscBars["form"]) then
				dockID = "F"
			elseif (dockID == TrinityMiscBars["cast"]) then
				dockID = "C"
			elseif (dockID == TrinityMiscBars["XP"]) then
				dockID = "XP"							
			end				
			TrinityBarsMinimapButtonOption5.dockID = dockFrame:GetID();
			getglobal(TrinityBarsMinimapButtonOption5Sub1:GetName().."DockID"):SetText(dockID);									
			dockFrame.selected = true;						
		end
		TrinitySaveButtonState();
	end
	
	TrinityDockFrameEditorLeftShowGrid:SetChecked(dockFrame.config["showgrid"])
	TrinityDockFrameEditorRightGhost:SetChecked(dockFrame.config["ghost"])
	TrinityDockFrameEditorRightBattle:SetChecked(dockFrame.config["battle"])
	TrinityDockFrameEditorRightStore:SetChecked(dockFrame.config["stored"])
	
	TrinitySetupDockFrameUpdate(dockFrame)
end

function TrinityCreateDockFrame(index)

	TrinityFunctionCounter("TrinityCreateDockFrame")

	local dockFrame = CreateFrame("Button", "TrinityDockFrame"..index, UIParent, "TrinityDockFrameTemplate");	
	
	TrinityDockFrameDefaults(index, dockFrame);
	
	if (index ~= 0) then
		TrinityDockFrames[index] = dockFrame:GetName();
	end
	
	return dockFrame;
end

function TrinityDockFrameDefaults(index, dockFrame)

	TrinityFunctionCounter("TrinityDockFrameDefaults")
	
	dockFrame:SetID(index);
	dockFrame.orderList = {}
	dockFrame.headers = {
		["Stance"] = {
			["name"] = "TrinityStanceHeader"..index,
			["parent"] = nil,
			["showstate"] = "",			
			["active"] = false,
			["order"] = 99,
			["start"] = 0,
			["end"] = 0,
			["list"] = {
				[0] = ",",
			},
			["currState"] = 0,
			["stateRef"] = 0,
		},
		["Actionbar"] = {
			["name"] ="TrinityActionbarHeader"..index,
			["parent"] = nil,
			["showstate"] = "",			
			["active"] = false,
			["order"] = 99,
			["start"] = 1,
			["end"] = 6,
			["list"] = {
				[1] = ",",
				[2] = ",",
				[3] = ",",
				[4] = ",",
				[5] = ",",
				[6] = ",",				
			},
			["currState"] = 0,			
			["stateRef"] = 0,
		},
		["Stealth"] = {
			["name"] ="TrinityStealthHeader"..index,
			["parent"] = nil,
			["showstate"] = "",			
			["active"] = false,
			["order"] = 99,
			["start"] = 0,
			["end"] = 1,
			["list"] = {
				[0] = ",",
				[1] = ",",				
			},
			["currState"] = 0,			
			["stateRef"] = 0,
		},
		["Alt"] = {
			["name"] ="TrinityAltHeader"..index,
			["parent"] = nil,
			["showstate"] = "",			
			["active"] = false,
			["order"] = 99,
			["start"] = 0,
			["end"] = 1,			
			["list"] = {
				[0] = ",",
				[1] = ",",				
			},
			["currState"] = 0,			
			["stateRef"] = 0,
		},
		["Ctrl"] = {
			["name"] ="TrinityCtrlHeader"..index,
			["parent"] = nil,
			["showstate"] = "",			
			["active"] = false,
			["order"] = 99,
			["start"] = 0,
			["end"] = 1,
			["list"] = {
				[0] = ",",
				[1] = ",",				
			},
			["currState"] = 0,			
			["stateRef"] = 0,
		},
		["Shift"] = {
			["name"] ="TrinityShiftHeader"..index,
			["parent"] = nil,
			["showstate"] = "",			
			["active"] = false,
			["order"] = 99,
			["start"] = 0,
			["end"] = 1,
			["list"] = {
				[0] = ",",
				[1] = ",",				
			},
			["currState"] = 0,			
			["stateRef"] = 0,
		},
		["Normal"] = {
			["name"] ="TrinityNormalHeader"..index,
			["parent"] = nil,
			["showstate"] = "",			
			["active"] = false,
			["order"] = 99,
			["start"] = 0,
			["end"] = 0,
			["list"] = {
				[0] = ",",
			},
			["currState"] = 0,			
			["stateRef"] = 0,
		},
	}
	dockFrame.config = {
		["btnType"] = "",
		["scale"] = 1,
		["alpha"] = 1,
		["shape"] = 0,
		["hide"] = 0,
		["columns"] = 6,
		["ghost"] = nil,	
		["prowl"] = nil,
		["vis"] = 1,
		["showgrid"] = nil,
		["buttonSpaceH"] = 3,
		["buttonSpaceV"] = 3,
		["style"] = 1,
		["target"] = "none",
		["hybrid"] = nil,
		["battle"] = nil,
		["stored"] = false,
		["storedbuttons"] = false,
	}	
	dockFrame.centerx = (UIParent:GetWidth()/2)*UIParent:GetEffectiveScale();
	dockFrame.centery = (UIParent:GetHeight()/2)*UIParent:GetEffectiveScale();
	dockFrame.elapsed = 3;
	dockFrame.update = false;			
	
	if (TrinityFirstRun) then
		TrinityBarsSavedState["docks"][index] = { dockFrame.headers, dockFrame.config, dockFrame:GetCenter() }
	end	
end	

function TrinityCreateActionButton(index, dock, showstate, header)	

	TrinityFunctionCounter("TrinityCreateActionButton")

	local actionButton = CreateFrame("CheckButton", "TrinityActionButton"..index, TrinityStorageHeader, "TrinityActionButtonTemplate");
	
	actionButton:SetID(index);
	actionButton:SetAttribute("useparent-unit*", true);				
	actionButton:SetAttribute("type", "action");				
	actionButton:SetAttribute("*action*", index);						
	actionButton.config = {
		["dock"] = dock,
		["dockpos"] = 0,
		["header"] = header:GetName(),
		["showstate"] = showstate,		
		["laststate"] = "",
		["HotKey1"] = "",
		["HotKeyText1"] = "",
		["HotKey2"] = "",
		["HotKeyText2"] = "",
		["style"] = 1,
	}
	actionButton:SetAttribute("showstates", tostring(showstate))
	header:SetAttribute("addchild", actionButton)
	
	if (TrinityFirstRun) then
		TrinityBarsSavedState["buttons"][index] = { actionButton.config }
	end
	
	getglobal("TrinityActionButton"..index.."BindFrame"):SetID(index);		
	TrinityStorageHeader.data["buttonIndex"][index] = 0;
	
	return actionButton;
end

function TrinityCreateAnchorButton(index, dock, showstate, header)	
		
	TrinityFunctionCounter("TrinityCreateAnchorButton")

	local anchorButton = CreateFrame("CheckButton", "TrinityAnchorButton"..index, TrinityStorageHeader, "TrinityAnchorButtonTemplate");
	
	anchorButton:SetID(index);	
	anchorButton:SetAttribute("useparent-unit", true);				
	anchorButton:SetAttribute("type", "spell");				
	anchorButton.config = {
		["dock"] = dock,
		["dockpos"] = 0,
		["homedock"] = dock,
		["header"] = header:GetName(),
		["showstate"] = showstate,		
		["laststate"] = "",
		["HotKey1"] = "",
		["HotKeyText1"] = "",
		["HotKey2"] = "",
		["HotKeyText2"] = "",
		["element"] = "",
	}
	anchorButton:SetAttribute("showstates", tostring(showstate))
	header:SetAttribute("addchild", anchorButton)
	
	if (TrinityFirstRun) then
		TrinityBarsSavedState["anchors"][index] = { anchorButton.config }
	end
	
	getglobal("TrinityAnchorButton"..index.."BindFrame"):SetID(index);		
	TrinityStorageHeader.data["anchorIndex"][index] = 0;
	
	return anchorButton;
end

function TrinityCreateBagsDock()

	TrinityFunctionCounter("TrinityCreateBagsDock")

	local dockFrame, anchorButton;
	local pos = 0;
	local defaultElement = {}	
	local dockNum = 1;	
	
	while (TrinityDockFrames[dockNum]) do
		dockNum = dockNum + 1;
		if (dockNum > 100) then
			break;
		end
	end	
	
	dockFrame = TrinityCreateDockFrame(dockNum)	
	TrinityMiscBars["bags"] = dockFrame:GetID()
	
	dockFrame.config["btnType"] = "TrinityAnchorButton"
	local normalHeader = TrinityCreateNormalHeader(dockFrame)
		normalHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Normal"]["parent"] = "UIParent"
		dockFrame.headers["Normal"]["showstate"] = 0;		
		dockFrame.headers["Normal"]["order"] = 0;	 	
	for index=1,5 do
		anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame:GetID(), 0, normalHeader)
		if (not dockFrame.headers["Normal"]["list"][0]) then
			dockFrame.headers["Normal"]["list"][0] = ","..anchorButton:GetID()..",";
		else
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end		
	end
	
	return dockFrame;	
end

function TrinityCreateMenuDock()

	TrinityFunctionCounter("TrinityCreateMenuDock")

	local dockFrame, anchorButton;
	local pos = 5;
	local defaultElement = {}
	local dockNum = 1;	
	
	while (TrinityDockFrames[dockNum]) do
		dockNum = dockNum + 1;
		if (dockNum > 100) then
			break;
		end
	end	
	
	dockFrame = TrinityCreateDockFrame(dockNum)	
	TrinityMiscBars["menu"] = dockFrame:GetID()
	
	dockFrame.config["btnType"] = "TrinityAnchorButton"
	local normalHeader = TrinityCreateNormalHeader(dockFrame)				
		normalHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Normal"]["parent"] = "UIParent"
		dockFrame.headers["Normal"]["showstate"] = 0;		
		dockFrame.headers["Normal"]["order"] = 0;	
	for index=1,10 do
		anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame:GetID(), 0, normalHeader)
		if (not dockFrame.headers["Normal"]["list"][0]) then
			dockFrame.headers["Normal"]["list"][0] = ","..anchorButton:GetID()..",";
		else
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end			
	end	

	return dockFrame;	
end

function TrinityCreatePetDock()

	TrinityFunctionCounter("TrinityCreatePetDock")

	local dockFrame, anchorButton;
	local pos = 15;
	local defaultElement = {}	
	local dockNum = 1;	
	
	while (TrinityDockFrames[dockNum]) do
		dockNum = dockNum + 1;
		if (dockNum > 100) then
			break;
		end
	end	
	
	dockFrame = TrinityCreateDockFrame(dockNum)	
	TrinityMiscBars["pet"] = dockFrame:GetID()
	
	dockFrame.config["btnType"] = "TrinityAnchorButton"
	local normalHeader = TrinityCreateNormalHeader(dockFrame)				
		normalHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Normal"]["parent"] = "UIParent"
		dockFrame.headers["Normal"]["showstate"] = 0;		
		dockFrame.headers["Normal"]["order"] = 0;		
	for index=1,10 do
		anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame:GetID(), 0, normalHeader)
		if (not dockFrame.headers["Normal"]["list"][0]) then
			dockFrame.headers["Normal"]["list"][0] = ","..anchorButton:GetID()..",";
		else
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end					
	end	
	
	return dockFrame;		
end

function TrinityCreateFormDock()

	TrinityFunctionCounter("TrinityCreateFormDock")

	local dockFrame, anchorButton;
	local pos = 25;
	local defaultElement = {}	
	local dockNum = 1;	
	
	while (TrinityDockFrames[dockNum]) do
		dockNum = dockNum + 1;
		if (dockNum > 100) then
			break;
		end
	end	
	
	dockFrame = TrinityCreateDockFrame(dockNum)	
	TrinityMiscBars["form"] = dockFrame:GetID()
	
	dockFrame.config["btnType"] = "TrinityAnchorButton"
	local normalHeader = TrinityCreateNormalHeader(dockFrame)				
		normalHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Normal"]["parent"] = "UIParent"
		dockFrame.headers["Normal"]["showstate"] = 0;		
		dockFrame.headers["Normal"]["order"] = 0;				
	for index=1,10 do
		anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame:GetID(), 0, normalHeader)		
		if (not dockFrame.headers["Normal"]["list"][0]) then
			dockFrame.headers["Normal"]["list"][0] = ","..anchorButton:GetID()..",";
		else
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end					
	end
	
	return dockFrame;	
end

function TrinityCreateCastDock()

	TrinityFunctionCounter("TrinityCreateCastDock")

	local dockFrame, anchorButton;
	local pos = 35;
	local defaultElement = {}	
	local dockNum = 1;	
	
	while (TrinityDockFrames[dockNum]) do
		dockNum = dockNum + 1;
		if (dockNum > 100) then
			break;
		end
	end	
	
	dockFrame = TrinityCreateDockFrame(dockNum)	
	TrinityMiscBars["cast"] = dockFrame:GetID()
	
	dockFrame.config["btnType"] = "TrinityAnchorButton"
	local normalHeader = TrinityCreateNormalHeader(dockFrame)				
		normalHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Normal"]["parent"] = "UIParent"
		dockFrame.headers["Normal"]["showstate"] = 0;		
		dockFrame.headers["Normal"]["order"] = 0;	
	for index=1,1 do
		anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame:GetID(), 0, normalHeader)
		if (not dockFrame.headers["Normal"]["list"][0]) then
			dockFrame.headers["Normal"]["list"][0] = ","..anchorButton:GetID()..",";
		else
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end		
	end
	
	return dockFrame;	
end

function TrinityCreateXPDock()

	TrinityFunctionCounter("TrinityCreateXPDock")

	local dockFrame, anchorButton;
	local pos = 36;
	local defaultElement = {}	
	local dockNum = 1;	
	
	while (TrinityDockFrames[dockNum]) do
		dockNum = dockNum + 1;
		if (dockNum > 100) then
			break;
		end
	end	
	
	dockFrame = TrinityCreateDockFrame(dockNum)	
	TrinityMiscBars["XP"] = dockFrame:GetID()
	
	dockFrame.config["btnType"] = "TrinityAnchorButton"
	local normalHeader = TrinityCreateNormalHeader(dockFrame)				
		normalHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Normal"]["parent"] = "UIParent"
		dockFrame.headers["Normal"]["showstate"] = 0;		
		dockFrame.headers["Normal"]["order"] = 0;	
	for index=1,1 do
		anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame:GetID(), 0, normalHeader)
		if (not dockFrame.headers["Normal"]["list"][0]) then
			dockFrame.headers["Normal"]["list"][0] = ","..anchorButton:GetID()..",";
		else
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end		
	end
	
	return dockFrame;	
end

function TrinityInitializeClassDefaults()

	TrinityFunctionCounter("TrinityInitializeClassDefaults")

	TrinityUpdateFormNames();
	
	local pos, showstate, actionButton, dockFrame, normalHeader, actionbarHeader, stanceHeader, stealthHeader;
	local makebtns = true		

	if (UnitClass("player") == TRINITY_DRUID) then
	
		dockFrame = TrinityCreateDockFrame(getn(TrinityDockFrames)+1)		
		dockFrame.config["btnType"] = "TrinityActionButton"
		
		normalHeader = TrinityCreateNormalHeader(dockFrame)				
			normalHeader:SetAttribute("showstates", "0");		
			dockFrame.headers["Normal"]["parent"] = "UIParent"
			dockFrame.headers["Normal"]["showstate"] = 0;		
			dockFrame.headers["Normal"]["order"] = 0;
			dockFrame.headers["Normal"]["list"][0] = ",";
		
		pos=12
		actionbarHeader = TrinityCreateActionbarHeader(dockFrame)				
			dockFrame.headers["Actionbar"]["order"] = 1
			dockFrame.headers["Actionbar"]["start"] = 2;
		normalHeader:SetAttribute("addchild", actionbarHeader);
		actionbarHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Actionbar"]["parent"] = normalHeader:GetName()
		dockFrame.headers["Actionbar"]["showstate"] = 0;		
		
		pos=0
		stanceHeader = TrinityCreateStanceHeader(dockFrame)		
			dockFrame.headers["Stance"]["order"] = 2
			dockFrame.headers["Stance"]["end"] = GetNumShapeshiftForms()
			for showstate=dockFrame.headers["Stance"]["start"],dockFrame.headers["Stance"]["end"] do			
				dockFrame.headers["Stance"]["list"][showstate] = ",";
 				if (showstate == TrinityForms["Bear Form"]) then
					pos=96
					makebtns = true
 				elseif (showstate == TrinityForms["Dire Bear Form"]) then
 					pos=96
 					makebtns = true
 				elseif (showstate == TrinityForms["Moonkin Form"]) then
 					pos=84
 					makebtns = true
 				elseif (showstate == TrinityForms["Tree of Life"]) then
 					pos=84		
 					makebtns = true
 				elseif (showstate == TrinityForms["Cat Form"]) then
 					pos=72		
 					makebtns = true
				end									
				if (makebtns) then
					for index=1,12 do
						actionButton = TrinityCreateActionButton(index+pos, dockFrame:GetID(), showstate, stanceHeader)																
						dockFrame.headers["Stance"]["list"][showstate] = dockFrame.headers["Stance"]["list"][showstate]..getglobal(dockFrame.config["btnType"]..index+pos):GetID()..",";						
					end
				end
				makebtns = false			
			end
		actionbarHeader:SetAttribute("addchild", stanceHeader);
		stanceHeader:SetAttribute("showstates", "1");		
		dockFrame.headers["Stance"]["parent"] = actionbarHeader:GetName()
		dockFrame.headers["Stance"]["showstate"] = 1;				
		
	elseif (UnitClass("player") == TRINITY_WARRIOR) then

		dockFrame = TrinityCreateDockFrame(getn(TrinityDockFrames)+1)		
		dockFrame.config["btnType"] = "TrinityActionButton"
		
		normalHeader = TrinityCreateNormalHeader(dockFrame)				
			normalHeader:SetAttribute("showstates", "0");		
			dockFrame.headers["Normal"]["parent"] = "UIParent"
			dockFrame.headers["Normal"]["showstate"] = 0;		
			dockFrame.headers["Normal"]["order"] = 0;
		
		pos=12
		actionbarHeader = TrinityCreateActionbarHeader(dockFrame)				
			dockFrame.headers["Actionbar"]["order"] = 1
			dockFrame.headers["Actionbar"]["start"] = 2;
		normalHeader:SetAttribute("addchild", actionbarHeader);
		actionbarHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Actionbar"]["parent"] = normalHeader:GetName()
		dockFrame.headers["Actionbar"]["showstate"] = 0;		
		
		pos=0
		stanceHeader = TrinityCreateStanceHeader(dockFrame)		
			dockFrame.headers["Stance"]["order"] = 2
			dockFrame.headers["Stance"]["start"] = 1;
			dockFrame.headers["Stance"]["end"] = GetNumShapeshiftForms()
			for showstate=dockFrame.headers["Stance"]["start"],dockFrame.headers["Stance"]["end"] do			
				dockFrame.headers["Stance"]["list"][showstate] = ",";
 				if (showstate == TrinityForms["Battle Stance"]) then
					pos=72
					makebtns = true
 				elseif (showstate == TrinityForms["Defensive Stance"]) then
 					pos=84
 					makebtns = true
 				elseif (showstate == TrinityForms["Berserker Stance"]) then
 					pos=96
 					makebtns = true
				end					
				if (makebtns) then
					for index=1,12 do
						actionButton = TrinityCreateActionButton(index+pos, dockFrame:GetID(), showstate, stanceHeader)																
						dockFrame.headers["Stance"]["list"][showstate] = dockFrame.headers["Stance"]["list"][showstate]..getglobal(dockFrame.config["btnType"]..index+pos):GetID()..",";						
					end
				end
				makebtns = false			
			end
		actionbarHeader:SetAttribute("addchild", stanceHeader);
		stanceHeader:SetAttribute("showstates", "1");		
		dockFrame.headers["Stance"]["parent"] = actionbarHeader:GetName()
		dockFrame.headers["Stance"]["showstate"] = 1;							
		
	elseif (UnitClass("player") == TRINITY_ROGUE) then
	
		dockFrame = TrinityCreateDockFrame(getn(TrinityDockFrames)+1)		
		dockFrame.config["btnType"] = "TrinityActionButton"
		
		local normalHeader = TrinityCreateNormalHeader(dockFrame)				
			normalHeader:SetAttribute("showstates", "0");		
			dockFrame.headers["Normal"]["parent"] = "UIParent"
			dockFrame.headers["Normal"]["showstate"] = 0;		
			dockFrame.headers["Normal"]["order"] = 0;
		
		pos=12
		actionbarHeader = TrinityCreateActionbarHeader(dockFrame)				
			dockFrame.headers["Actionbar"]["order"] = 1
			dockFrame.headers["Actionbar"]["start"] = 2;
		normalHeader:SetAttribute("addchild", actionbarHeader);
		actionbarHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Actionbar"]["parent"] = normalHeader:GetName()
		dockFrame.headers["Actionbar"]["showstate"] = 0;		
		
		pos=0
		stanceHeader = TrinityCreateStanceHeader(dockFrame)		
			dockFrame.headers["Stance"]["order"] = 2
			dockFrame.headers["Stance"]["start"] = 0;
			dockFrame.headers["Stance"]["end"] = 1;
			for showstate=dockFrame.headers["Stance"]["start"],dockFrame.headers["Stance"]["end"] do			
				dockFrame.headers["Stance"]["list"][showstate] = ",";
				if (makebtns) then
					for index=1,12 do
						actionButton = TrinityCreateActionButton(index+pos, dockFrame:GetID(), showstate, stanceHeader)																
						dockFrame.headers["Stance"]["list"][showstate] = dockFrame.headers["Stance"]["list"][showstate]..getglobal(dockFrame.config["btnType"]..index+pos):GetID()..",";						
					end
				end
				pos = 72;
			end
		actionbarHeader:SetAttribute("addchild", stanceHeader);
		stanceHeader:SetAttribute("showstates", "1");		
		dockFrame.headers["Stance"]["parent"] = actionbarHeader:GetName()
		dockFrame.headers["Stance"]["showstate"] = 1;					
		
	else

		dockFrame = TrinityCreateDockFrame(getn(TrinityDockFrames)+1)				
		dockFrame.config["btnType"] = "TrinityActionButton"
		
		normalHeader = TrinityCreateNormalHeader(dockFrame)				
			normalHeader:SetAttribute("showstates", "0");		
			dockFrame.headers["Normal"]["parent"] = "UIParent"
			dockFrame.headers["Normal"]["showstate"] = 0;		
			dockFrame.headers["Normal"]["order"] = 0;
		
		pos=0
		actionbarHeader = TrinityCreateActionbarHeader(dockFrame)				
			dockFrame.headers["Actionbar"]["order"] = 1
			dockFrame.headers["Actionbar"]["start"] = 1;
			showstate = 1;
			for index=1,12 do
				actionButton = TrinityCreateActionButton(index+pos, dockFrame:GetID(), showstate, actionbarHeader)					
				if (not dockFrame.headers["Actionbar"]["list"][showstate]) then
					dockFrame.headers["Actionbar"]["list"][showstate] = ","..getglobal(dockFrame.config["btnType"]..index+pos):GetID()..",";
				else
					dockFrame.headers["Actionbar"]["list"][showstate] = dockFrame.headers["Actionbar"]["list"][showstate]..getglobal(dockFrame.config["btnType"]..index+pos):GetID()..",";
				end			
			end				
		normalHeader:SetAttribute("addchild", actionbarHeader);
		actionbarHeader:SetAttribute("showstates", "0");		
		dockFrame.headers["Actionbar"]["parent"] = normalHeader:GetName()
		dockFrame.headers["Actionbar"]["showstate"] = 0;						
			
	end
	
	pos=0
	for index=1,120 do
		if (not getglobal("TrinityActionButton"..index)) then
			if (pos == 0) then				
				dockFrame = TrinityCreateDockFrame(getn(TrinityDockFrames)+1)				
				dockFrame.config["btnType"] = "TrinityActionButton"
				normalHeader = TrinityCreateNormalHeader(dockFrame)
				normalHeader:SetAttribute("showstates", "0");		
				dockFrame.headers["Normal"]["parent"] = "UIParent"
				dockFrame.headers["Normal"]["showstate"] = 0;		
				dockFrame.headers["Normal"]["order"] = 0;									
			end
			actionButton = TrinityCreateActionButton(index, dockFrame:GetID(), 0, normalHeader)
			
			if (not dockFrame.headers["Normal"]["list"][0]) then
				dockFrame.headers["Normal"]["list"][0] = ","..getglobal(dockFrame.config["btnType"]..index):GetID()..",";
			else
				dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..getglobal(dockFrame.config["btnType"]..index):GetID()..",";
			end
			
			pos = pos + 1;
			
			if (pos == 12) then
				pos = 0;
			end
		end
	end	
	
	TrinityCreateBagsDock()		
 	TrinityCreateMenuDock()
	TrinityCreatePetDock()
 	TrinityCreateFormDock()
 	TrinityCreateCastDock()
	TrinityCreateXPDock()	
end

function TrinityReassignDefaultUIElements()

	TrinityFunctionCounter("TrinityReassignDefaultUIElements")

	local anchorButton, dockFrame;
	local pos = 0;
	local defaultElement = {}
	
	bankButton = CreateFrame("CheckButton", "TrinityBankButton", UIParent, "ItemButtonTemplate")
	getglobal(bankButton:GetName().."IconTexture"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\bankButton.tga")	
	getglobal(bankButton:GetName().."IconTexture"):ClearAllPoints();
	getglobal(bankButton:GetName().."IconTexture"):SetPoint("TOPLEFT", bankButton, "TOPLEFT", 10,-10)
	getglobal(bankButton:GetName().."IconTexture"):SetPoint("BOTTOMRIGHT", bankButton, "BOTTOMRIGHT",-10,10)
	
	defaultElement[5] = MainMenuBarBackpackButton:GetName();	
	defaultElement[4] = CharacterBag0Slot:GetName();
	defaultElement[3] = CharacterBag1Slot:GetName();
	defaultElement[2] = CharacterBag2Slot:GetName();
 	defaultElement[1] = CharacterBag3Slot:GetName();	 	 	
 	
 	MainMenuBarBackpackButton:RegisterEvent("BAG_UPDATE");
 	MainMenuBarBackpackButton:SetScript("OnEvent", function() TrinityBackpackUpdate(arg1) end);
 	
 	if (TrinityMiscBars["bags"]) then
 		if (getglobal("TrinityDockFrame"..TrinityMiscBars["bags"])) then
 			dockFrame = getglobal("TrinityDockFrame"..TrinityMiscBars["bags"])
 		else 		
 			dockFrame = TrinityCreateBagsDock() 			
 		end
 	else
 		dockFrame = TrinityCreateBagsDock()
 	end
 	dockFrame.headers["Normal"]["list"][0] = ","; 	
 	
 	if (dockFrame.config["singlebag"]) then
 		MainMenuBarBackpackButton:SetScript("OnClick", function() OpenAllBags() end);
 	else 	
 		MainMenuBarBackpackButton:SetScript("OnClick", function() if (IsShiftKeyDown()) then OpenAllBags() else ToggleBackpack() end end);
 	end 	

	for index=1,5 do		
		if (getglobal("TrinityAnchorButton"..index+pos)) then
			anchorButton = getglobal("TrinityAnchorButton"..index+pos);
			getglobal(dockFrame.headers["Normal"]["name"]):SetAttribute("addchild", anchorButton)
			anchorButton.config["header"] = dockFrame.headers["Normal"]["name"]			
		else		
			anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame, 0, getglobal(dockFrame.headers["Normal"]["name"]))
			TrinityBarsSavedState["anchors"][index] = { anchorButton.config }			
		end		
		if (anchorButton.config["showstate"] ~= "STORED") then		
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end
		anchorButton.config["homedock"] = TrinityMiscBars["bags"]
		getglobal(defaultElement[index]):ClearAllPoints();
		getglobal(defaultElement[index]):SetParent(anchorButton);				
		anchorButton:SetWidth(getglobal(defaultElement[index]):GetWidth());
		anchorButton:SetHeight(getglobal(defaultElement[index]):GetHeight());
		anchorButton:SetHitRectInsets(anchorButton:GetWidth()/2, anchorButton:GetWidth()/2, anchorButton:GetHeight()/2, anchorButton:GetHeight()/2) 
		getglobal(defaultElement[index]):SetPoint("CENTER", anchorButton, "CENTER");
		getglobal(defaultElement[index]):Show();
		anchorButton.config["element"] = defaultElement[index];
	end
	
	pos = 5
  	defaultElement[1] = CharacterMicroButton:GetName();   	
  	defaultElement[2] = SpellbookMicroButton:GetName();
  	defaultElement[3] = TalentMicroButton:GetName();
  	defaultElement[4] = QuestLogMicroButton:GetName();
  	defaultElement[5] = SocialsMicroButton:GetName();
  	defaultElement[6] = LFGMicroButton:GetName();
  	defaultElement[7] = MainMenuMicroButton:GetName();
  	defaultElement[8] = HelpMicroButton:GetName();
  	defaultElement[9] = TrinityLatencyMicroButton:GetName();
  	defaultElement[10] = TrinityKeyRingButton:GetName();
		
 	if (TrinityMiscBars["menu"]) then
 		if (getglobal("TrinityDockFrame"..TrinityMiscBars["menu"])) then
 			dockFrame = getglobal("TrinityDockFrame"..TrinityMiscBars["menu"])
 		else 		
 			dockFrame = TrinityCreateMenuDock() 			
 		end
 	else
 		dockFrame = TrinityCreateMenuDock()
 	end
	dockFrame.headers["Normal"]["list"][0] = ",";
	for index=1,10 do		
		if (getglobal("TrinityAnchorButton"..index+pos)) then
			anchorButton = getglobal("TrinityAnchorButton"..index+pos);
			getglobal(dockFrame.headers["Normal"]["name"]):SetAttribute("addchild", anchorButton)
			anchorButton.config["header"] = dockFrame.headers["Normal"]["name"]						
		else			
			anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame, 0, getglobal(dockFrame.headers["Normal"]["name"]))
			TrinityBarsSavedState["anchors"][index] = { anchorButton.config }
		end		
		if (anchorButton.config["showstate"] ~= "STORED") then
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end		
		anchorButton.config["homedock"] = TrinityMiscBars["menu"]
		getglobal(defaultElement[index]):ClearAllPoints();
		getglobal(defaultElement[index]):SetParent(anchorButton);
		anchorButton:SetWidth(getglobal(defaultElement[index]):GetWidth()*0.8);
		anchorButton:SetHeight(getglobal(defaultElement[index]):GetHeight()/2);
		anchorButton:SetHitRectInsets(anchorButton:GetWidth()/2, anchorButton:GetWidth()/2, anchorButton:GetHeight()/2, anchorButton:GetHeight()/2) 
		getglobal(defaultElement[index]):SetPoint("BOTTOM", anchorButton, "BOTTOM",0,-4);
		getglobal(defaultElement[index]):Show();		
		anchorButton.config["element"] = defaultElement[index];
	end	
	
	pos = 15
	for i=1,10 do
		defaultElement[i] = getglobal("PetActionButton"..i):GetName();
		getglobal("PetActionButton"..i):SetScript("OnUpdate", function() TrinityPetButtonOnUpdate(arg1) end);
		getglobal("PetActionButton"..i):CreateTexture("$parentAutoCastSim", "OVERLAY", "TrinityCheckButtonTextureTemplate");		
		getglobal("PetActionButton"..i.."AutoCastSim"):SetPoint("TOPLEFT", 0, 0);
		getglobal("PetActionButton"..i.."AutoCastSim"):SetPoint("BOTTOMRIGHT", 0, 0);
 	end 
 	
 	if (TrinityMiscBars["pet"]) then
 		if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"])) then
 			dockFrame = getglobal("TrinityDockFrame"..TrinityMiscBars["pet"])
 		else 		
 			dockFrame = TrinityCreatePetDock() 			
 		end
 	else
 		dockFrame = TrinityCreatePetDock()
 	end
	dockFrame.headers["Normal"]["list"][0] = ","; 	
	for index=1,10 do		
		if (getglobal("TrinityAnchorButton"..index+pos)) then
			anchorButton = getglobal("TrinityAnchorButton"..index+pos);
			getglobal(dockFrame.headers["Normal"]["name"]):SetAttribute("addchild", anchorButton)
			anchorButton.config["header"] = dockFrame.headers["Normal"]["name"]						
		else			
			anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame, 0, getglobal(dockFrame.headers["Normal"]["name"]))
			TrinityBarsSavedState["anchors"][index] = { anchorButton.config }
		end		
		if (anchorButton.config["showstate"] ~= "STORED") then
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end		
		anchorButton.config["homedock"] = TrinityMiscBars["pet"]
		getglobal(defaultElement[index]):ClearAllPoints();
		getglobal(defaultElement[index]):SetParent(anchorButton);				
		anchorButton:SetWidth(getglobal(defaultElement[index]):GetWidth());
		anchorButton:SetHeight(getglobal(defaultElement[index]):GetHeight());
		anchorButton:SetHitRectInsets(anchorButton:GetWidth()/2, anchorButton:GetWidth()/2, anchorButton:GetHeight()/2, anchorButton:GetHeight()/2) 
		getglobal(defaultElement[index]):SetPoint("CENTER", anchorButton, "CENTER");
		getglobal(defaultElement[index]):Show();			
		anchorButton.config["element"] = defaultElement[index];
	end	
	
	pos = 25
	for i=1,10 do
		defaultElement[i] = getglobal("ShapeshiftButton"..i):GetName();		
		getglobal("ShapeshiftButton"..i):SetScript("OnEnter", function() if (TrinityShowButtonTooltips) then if ( GetCVar("UberTooltips") == "1" ) then	GameTooltip_SetDefaultAnchor(GameTooltip, this) else GameTooltip:SetOwner(this, "ANCHOR_RIGHT") end GameTooltip:SetShapeshift(this:GetID()) end end);		
		getglobal(defaultElement[i]):SetNormalTexture("")
	end	
	
 	if (TrinityMiscBars["form"]) then
 		if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"])) then
 			dockFrame = getglobal("TrinityDockFrame"..TrinityMiscBars["form"])
 		else 		
 			dockFrame = TrinityCreateFormDock() 			
 		end
 	else
 		dockFrame = TrinityCreateFormDock()
 	end
	dockFrame.headers["Normal"]["list"][0] = ",";
	for index=1,10 do		
		if (getglobal("TrinityAnchorButton"..index+pos)) then
			anchorButton = getglobal("TrinityAnchorButton"..index+pos);
			getglobal(dockFrame.headers["Normal"]["name"]):SetAttribute("addchild", anchorButton)
			anchorButton.config["header"] = dockFrame.headers["Normal"]["name"]						
		else			
			anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame, 0, getglobal(dockFrame.headers["Normal"]["name"]))
			TrinityBarsSavedState["anchors"][index] = { anchorButton.config }
		end		
		if (anchorButton.config["showstate"] ~= "STORED") then	
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end		
		anchorButton.config["homedock"] = TrinityMiscBars["form"]
		getglobal(defaultElement[index]):ClearAllPoints();
		getglobal(defaultElement[index]):SetParent(anchorButton);				
		anchorButton:SetWidth(getglobal(defaultElement[index]):GetWidth());
		anchorButton:SetHeight(getglobal(defaultElement[index]):GetHeight());		
		anchorButton:SetHitRectInsets(anchorButton:GetWidth()/2, anchorButton:GetWidth()/2, anchorButton:GetHeight()/2, anchorButton:GetHeight()/2) 
		getglobal(defaultElement[index]):SetPoint("CENTER", anchorButton, "CENTER");
		getglobal(defaultElement[index]):Show();					
		anchorButton.config["element"] = defaultElement[index];
		editBox = CreateFrame("EditBox", "TrinityFormEditBox"..index, dockFrame, "TrinityEditBoxShapeshiftTemplate");
		getglobal(editBox:GetName().."formNum"):SetPoint("TOPLEFT", anchorButton, "BOTTOMLEFT",2,0);
		editBox:SetScript("OnEnterPressed", function () TrinityFormsTransition[index] = tonumber(this:GetText()) TrinityUpdateFormNames() this:ClearFocus() end);
		editBox:SetPoint("TOPLEFT", anchorButton, "BOTTOM", -2, 2)
		editBox:SetPoint("TOPRIGHT", anchorButton, "BOTTOMRIGHT", -0, 2)
		editBox:SetTextColor(1,0.82,0)
	end	
	
	pos = 35
	defaultElement[1] = TrinityCastingBar:GetName();	
	
 	if (TrinityMiscBars["cast"]) then
 		if (getglobal("TrinityDockFrame"..TrinityMiscBars["cast"])) then
 			dockFrame = getglobal("TrinityDockFrame"..TrinityMiscBars["cast"])
 		else 		
 			dockFrame = TrinityCreateCastDock() 			
 		end
 	else
 		dockFrame = TrinityCreateCastDock()
 	end
	dockFrame.headers["Normal"]["list"][0] = ",";
	for index=1,1 do			
		if (getglobal("TrinityAnchorButton"..index+pos)) then
			anchorButton = getglobal("TrinityAnchorButton"..index+pos);
			if (anchorButton:GetAttribute("showstates") == "NOTEX") then
				anchorButton:SetAttribute("showstates", "0")
				anchorButton.config["showstate"] = 0
			end			
			getglobal(dockFrame.headers["Normal"]["name"]):SetAttribute("addchild", anchorButton)
			anchorButton.config["header"] = dockFrame.headers["Normal"]["name"]						
		else			
			anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame, 0, getglobal(dockFrame.headers["Normal"]["name"]))
			TrinityBarsSavedState["anchors"][index] = { anchorButton.config }
		end		
		if (anchorButton.config["showstate"] ~= "STORED") then	
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end		
		anchorButton.config["homedock"] = TrinityMiscBars["cast"]
		anchorButton:SetNormalTexture("");
		getglobal(defaultElement[index]):ClearAllPoints();
		getglobal(defaultElement[index]):SetParent(anchorButton);						
		getglobal(defaultElement[index]):SetPoint("TOPLEFT", anchorButton, "TOPLEFT");		
		getglobal(defaultElement[index]):SetPoint("BOTTOMRIGHT", anchorButton, "BOTTOMRIGHT");		
		anchorButton.config["element"] = defaultElement[index];		
		if (not dockFrame.config["anchorwidth"]) then
			anchorButton:SetWidth(getglobal(defaultElement[index]):GetWidth());
			dockFrame.config["anchorwidth"] = anchorButton:GetWidth();
		else
			anchorButton:SetWidth(dockFrame.config["anchorwidth"]);
		end
		if (not dockFrame.config["anchorheight"]) then
			anchorButton:SetHeight(getglobal(defaultElement[index]):GetHeight());		
			dockFrame.config["anchorheight"] = anchorButton:GetHeight();
		else
			anchorButton:SetHeight(dockFrame.config["anchorheight"]);	
		end			
		
		anchorButton:SetHitRectInsets(anchorButton:GetWidth()/2, anchorButton:GetWidth()/2, anchorButton:GetHeight()/2, anchorButton:GetHeight()/2) 
	end	
	
	pos = 36
	defaultElement[1] = TrinityXPFrame:GetName();	
	
 	if (TrinityMiscBars["XP"]) then
 		if (getglobal("TrinityDockFrame"..TrinityMiscBars["XP"])) then
 			dockFrame = getglobal("TrinityDockFrame"..TrinityMiscBars["XP"])
 		else 		
 			dockFrame = TrinityCreateXPDock() 			
 		end
 	else
 		dockFrame = TrinityCreateXPDock()
 	end
	dockFrame.headers["Normal"]["list"][0] = ",";
	for index=1,1 do			
		if (getglobal("TrinityAnchorButton"..index+pos)) then
			anchorButton = getglobal("TrinityAnchorButton"..index+pos);
			getglobal(dockFrame.headers["Normal"]["name"]):SetAttribute("addchild", anchorButton)
			anchorButton.config["header"] = dockFrame.headers["Normal"]["name"]						
		else			
			anchorButton = TrinityCreateAnchorButton(index+pos, dockFrame, 0, getglobal(dockFrame.headers["Normal"]["name"]))
			TrinityBarsSavedState["anchors"][index] = { anchorButton.config }
		end		
		if (anchorButton.config["showstate"] ~= "STORED") then
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..",";
		end		
		anchorButton.config["homedock"] = TrinityMiscBars["XP"]		
		anchorButton:SetFrameLevel(0)
		anchorButton:SetNormalTexture("");
		getglobal(defaultElement[index]):ClearAllPoints();
		getglobal(defaultElement[index]):SetParent(anchorButton);				
		getglobal(defaultElement[index]):SetFrameLevel(1)
		PlayerFrame:SetFrameStrata("LOW")				
		getglobal(defaultElement[index]):SetPoint("TOPLEFT", anchorButton, "TOPLEFT");		
		getglobal(defaultElement[index]):SetPoint("BOTTOMRIGHT", anchorButton, "BOTTOMRIGHT");		
		anchorButton.config["element"] = defaultElement[index];
		if (not dockFrame.config["anchorwidth"]) then
			anchorButton:SetWidth(getglobal(defaultElement[index]):GetWidth());
			dockFrame.config["anchorwidth"] = anchorButton:GetWidth();
		else
			anchorButton:SetWidth(dockFrame.config["anchorwidth"]);
		end
		if (not dockFrame.config["anchorheight"]) then
			anchorButton:SetHeight(getglobal(defaultElement[index]):GetHeight());		
			dockFrame.config["anchorheight"] = anchorButton:GetHeight();
		else
			anchorButton:SetHeight(dockFrame.config["anchorheight"]);	
		end			
		
		anchorButton:SetHitRectInsets(anchorButton:GetWidth()/2, anchorButton:GetWidth()/2, anchorButton:GetHeight()/2, anchorButton:GetHeight()/2) 
	end
	
	TrinityBarsSavedState["anchors"][38] = nil;
end

function TrinityMiscBarSetup(i, dockFrame)

	TrinityFunctionCounter("TrinityMiscBarSetup")

	if (i==TrinityMiscBars["bags"]) then	

	elseif (i==TrinityMiscBars["menu"]) then	

	elseif (i==TrinityMiscBars["pet"]) then	

	elseif (i==TrinityMiscBars["form"]) then	

	elseif (i==TrinityMiscBars["cast"]) then
		
		if (not dockFrame.config["orientation"]) then
			dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation();
		else
			TrinityCastingBar:SetOrientation(dockFrame.config["orientation"]);
			TrinityCastingBarDummy:SetOrientation(dockFrame.config["orientation"]);
			TrinityCastingBarSetTextures(dockFrame.config["orientation"]);
		end
		
		TrinityCastingBarDummy:SetParent(getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]));

		TrinityCastingBar:Hide();		
		
	elseif (i==TrinityMiscBars["XP"]) then	
		
		if (not dockFrame.config["orientation"]) then
			dockFrame.config["orientation"] = TrinityXPFrameBar:GetOrientation();
		else
			TrinityXPFrameBar:SetOrientation(dockFrame.config["orientation"]);
		end
	end
end

function TrinityUpdateFormNames()

	TrinityFunctionCounter("TrinityUpdateFormNames")

	TrinityForms = {}
	local transStates = nil;

 	for i=1,GetNumShapeshiftForms() do
 		local _, formName, _ = GetShapeshiftFormInfo(i); 		
 		TrinityForms[formName] = i;
 		
		if (not TrinityFormsTransition[i]) then
			TrinityFormsTransition[i] = i;
		end 		
		
		if (TrinityPlayerEnteredWorld) then
			getglobal("TrinityFormEditBox"..i):SetText(TrinityFormsTransition[i])	
			getglobal("TrinityFormEditBox"..i.."formNum"):SetText(i.."-")
			
			if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["showgrid"]) then
				getglobal("TrinityFormEditBox"..i):Show()
			else
				getglobal("TrinityFormEditBox"..i):Hide()
			end						
		end
 	end
 	
 	if (TrinityPlayerEnteredWorld) then 	
		for key,value in pairs (TrinityDockFrames) do
			dockFrame = getglobal("TrinityDockFrame"..key);			
			for k,v in pairs(dockFrame.headers) do				
				if (k == "Stance" and dockFrame.headers[k]["active"]) then
					for j=1,GetNumShapeshiftForms() do					
						if (tostring(j) == tostring(TrinityFormsTransition[j])) then											
							getglobal(dockFrame.headers[k]["name"]):SetAttribute("statemap-stance-"..j, "$input");
						else						
							getglobal(dockFrame.headers[k]["name"]):SetAttribute("statemap-stance-"..j, tostring(j)..":"..tostring(TrinityFormsTransition[j]));
						end					
					end
				end
			end
		end 	
	end
 	
 	if (UnitClass("player") == TRINITY_DRUID) then
 		TrinityForms["Prowl"] = GetNumShapeshiftForms()+1;
 		
 		if (not TrinityForms["Bear Form"]) then
 			TrinityForms["Bear Form"] = "NOTKNOWN";
 		end 		
 		if (not TrinityForms["Dire Bear Form"]) then
 			TrinityForms["Dire Bear Form"] = "NOTKNOWN";
 		end 		
 		if (not TrinityForms["Cat Form"]) then
 			TrinityForms["Cat Form"] = "NOTKNOWN";
 		end
 		if (not TrinityForms["Aquatic Form"]) then
 			TrinityForms["Aquatic Form"] = "NOTKNOWN";
 		end
 		if (not TrinityForms["Travel Form"]) then
 			TrinityForms["Travel Form"] = "NOTKNOWN";
 		end
 		if (not TrinityForms["Moonkin Form"]) then
 			TrinityForms["Moonkin Form"] = "NOTKNOWN";
 		end
 		if (not TrinityForms["Tree of Life"]) then
 			TrinityForms["Tree of Life"] = "NOTKNOWN";
 		end 		
 		if (not TrinityForms["Flight Form"]) then
 			TrinityForms["Flight Form"] = "NOTKNOWN";
 		end
 	end 
end

-- A function to handle events
function TrinityControls_OnEvent(self,event,...)

	TrinityFunctionCounter("TrinityControls_OnEvent")

	if (event == "VARIABLES_LOADED") then			
		TrinityVariablesLoaded = true;
	end
	
	if (event == "PLAYER_LOGIN") then			
		if (TrinityFirstRun) then
			TrinityInitializeClassDefaults()
		else
			TrinityLoadSV()
		end		
		TrinityUpdateDockPostions(TrinityFirstRun);
		TrinityReassignDefaultUIElements()		
		for k,v in pairs (TrinityDockFrames) do				
			local dockFrame = getglobal("TrinityDockFrame"..k);		
			TrinityUpdateDocking(dockFrame);
			TrinityUpdateTargeting(dockFrame);			
			TrinityRefreshOrderList(dockFrame)
			if (k==TrinityMiscBars["pet"]) then
				TrinityTogglePetButtonGrid(dockFrame)
			end
		end		
		TrinityUpdateBindings();		
		TrinitySetSelfCast(TrinitySelfCastOption);
		TrinityUpdateShapeshiftButtons();
		if (TrinityButtonLock) then
			LOCK_ACTIONBAR = "1"		
		else
			LOCK_ACTIONBAR = "0"		
		end
	end
	
	if (event == "UPDATE_SHAPESHIFT_FORM") then
		if (not TrinityDockBarsHide) then
			for k,v in pairs(TrinityDockFrames) do				
				local dockFrame = getglobal("TrinityDockFrame"..k);		
				TrinitySetupDockFrameUpdate(dockFrame)
			end
		end		
	end
	
	if (event == "UPDATE_STEALTH") then
		if (not TrinityDockBarsHide) then
			for k,v in pairs(TrinityDockFrames) do				
				local dockFrame = getglobal("TrinityDockFrame"..k);		
				TrinitySetupDockFrameUpdate(dockFrame)
			end
		end
		TrinityRefreshHeaders()
	end	
	
	if (event == "ACTIONBAR_PAGE_CHANGED") then
		if (not TrinityDockBarsHide) then
			for k,v in pairs(TrinityDockFrames) do				
				local dockFrame = getglobal("TrinityDockFrame"..k);		
				TrinitySetupDockFrameUpdate(dockFrame)
			end
		end		
	end
	
	if (event == "MODIFIER_STATE_CHANGED") then
		if (not TrinityDockBarsHide) then
			for k,v in pairs(TrinityDockFrames) do				
				local dockFrame = getglobal("TrinityDockFrame"..k);		
				TrinitySetupDockFrameUpdate(dockFrame)
			end
		end		
	end	
	
	if (event == "ACTIONBAR_SHOWGRID") then
		if (TrinityDockBarsHide) then
			TrinityButtonsHide = false;
			TrinityHideDocksButtons();
		end
	end
	
	if (event == "ACTIONBAR_HIDEGRID") then
		if (TrinityDockBarsHide) then 
			TrinityButtonsHide = true;			
			TrinityHideDocksButtons();
		end
	end	
	
	if (event == "PLAYER_ENTERING_WORLD") then
		TrinityRefreshHeaders();
		TrinityPlayerEnteredWorld = true;				
		TrinityHideKeyBindings();
		TrinityUpdateFormNames();
		for k,v in pairs (TrinityDockFrames) do				
			local dockFrame = getglobal("TrinityDockFrame"..k);		
			TrinitySwapTextures(dockFrame)	
			if (dockFrame.config["ghost"]) then
				dockFrame.config["vis"] = 1;
			end			
		end
		collectgarbage();
	end
	
	if (event == "PLAYER_LEAVING_WORLD") then	
		TrinityPlayerEnteredWorld = false;				
	end
	
	if (event == "PLAYER_REGEN_DISABLED") then
		if (not TrinityDockBarsHide) then
			UIErrorsFrame:AddMessage("In Combat Lockdown - Hiding Docks", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			TrinityDockLockdown = true;
			TrinityDockBarsHide = true;
			TrinityButtonsHide = true;
			for k,v in pairs (TrinityDockFrames) do
				local dockFrame = getglobal("TrinityDockFrame"..k);
				TrinityHideDocksButtons(k, k);
				TrinitySetupDockFrameUpdate(dockFrame);
			end								
			
			
		end
		for k,v in pairs(TrinityDockFrames) do
			local dockFrame = getglobal("TrinityDockFrame"..k);			
			if (dockFrame.config["battle"]) then
				SecureStateHeader_Refresh(getglobal(dockFrame.headers["Normal"]["name"]), 0);		
			end
		end
		
		TrinityRefreshHeaders()
		
		TrinityCombatLockdown = true;
	end
	
	if (event == "PLAYER_REGEN_ENABLED") then	
		if (TrinityDockLockdown) then
			UIErrorsFrame:AddMessage("Combat Lockdown Ended - Showing Docks", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			TrinityDockLockdown = false;
			TrinityDockBarsHide = false;
			TrinityButtonsHide = false;
			for k,v in pairs(TrinityDockFrames) do		
				local dockFrame = getglobal("TrinityDockFrame"..k);
				TrinityHideDocksButtons(k, k);
				TrinitySetupDockFrameUpdate(dockFrame);
			end
			
		end		
		for k,v in pairs(TrinityDockFrames) do
			local dockFrame = getglobal("TrinityDockFrame"..k);			
			if (dockFrame.config["battle"]) then	
				SecureStateHeader_Refresh(getglobal(dockFrame.headers["Normal"]["name"]), 1);				
			end
		end
		
		TrinityRefreshHeaders()
		
		TrinityCombatLockdown = false;
	end	
	
	if (event == "UPDATE_SHAPESHIFT_FORMS") then		
		TrinityUpdateFormNames();
		if (TrinityPlayerEnteredWorld) then
			for k,v in pairs(TrinityDockFrames) do
				local dockFrame = getglobal("TrinityDockFrame"..k);
				dockFrame.headers["Stance"]["end"] = GetNumShapeshiftForms()
				if (dockFrame.headers["Stance"]["active"]) then
					for showstate=dockFrame.headers["Stance"]["start"],dockFrame.headers["Stance"]["end"] do			
 						if (not dockFrame.headers["Stance"]["list"][showstate]) then
							dockFrame.headers["Stance"]["list"][showstate] = ",";
						else
						
						end				
					end
					if (TrinityPlayerEnteredWorld) then
						if (getn(dockFrame.headers["Stance"]["list"]) > GetNumShapeshiftForms()) then
							for clear=GetNumShapeshiftForms()+1, getn(dockFrame.headers["Stance"]["list"]) do							
								local buttonList= {}
								string.gsub(dockFrame.headers["Stance"]["list"][clear], "%d+", function (btn) table.insert(buttonList, btn) end);						
								for btn=1,getn(buttonList) do
									actionButton = getglobal(dockFrame.config["btnType"]..buttonList[btn]);		
									actionButton:ClearAllPoints();
									actionButton:SetPoint("CENTER", "TrinityStorageHeader", "CENTER");		
									actionButton.config["dock"] = 0;
									actionButton.config["showstates"] = "STORED";
									actionButton:SetAttribute("showstates", "STORED");		
									TrinityStorageHeader:SetAttribute("addchild", actionButton);	
									dockFrame.headers["Stance"]["list"][clear] = string.gsub(dockFrame.headers["Stance"]["list"][clear], "(%D)"..buttonList[btn]..",", "%1")						
									TrinityStorageHeader.data["buttonIndex"][tonumber(buttonList[btn])] = 1;
									TrinityStorageHeader.data["buttonCount"] = TrinityStorageHeader.data["buttonCount"] + 1;		
									buttonList[btn] = nil;						
								end
							end
						end				
					end
				end
			end
			TrinityUpdateShapeshiftButtons()	
		end
	end
end

function TrinityUpdateShapeshiftButtons()	

	TrinityFunctionCounter("TrinityUpdateShapeshiftButtons")

	TrinityUpdateFormNames();		

	for i=26,35 do
		local anchorButton = getglobal("TrinityAnchorButton"..i);
		local _, name, _, _ = GetShapeshiftFormInfo(i-25);

 			
		if (anchorButton.config["showstate"] ~= "STORED") then
			anchorButton:ClearAllPoints();
			anchorButton:SetPoint("CENTER", "TrinityStorageHeader", "CENTER");
			anchorButton.config["dock"] = 0;
			anchorButton.config["dockpos"] = 0;
			if (not name) then
				anchorButton.config["showstate"] = "NOTEX";			
				anchorButton:SetAttribute("showstates", "NOTEX");		
			else
				anchorButton.config["showstate"] = "UPDATE";			
				anchorButton:SetAttribute("showstates", "UPDATE");					
			end
			anchorButton.config["header"] = "TrinityStorageHeader";
			TrinityStorageHeader:SetAttribute("addchild", anchorButton);						
			getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).headers["Normal"]["list"][0] = string.gsub(getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).headers["Normal"]["list"][0], "(%D)"..i..",", "%1")				
			TrinityStorageHeader.data["anchorIndex"][tonumber(i)] = 1;
			TrinityStorageHeader.data["anchorCount"] = TrinityStorageHeader.data["anchorCount"] + 1;							
		end
	end
	
	if (GetNumShapeshiftForms() > 0) then		
		for i=26,25+GetNumShapeshiftForms() do
			if (getglobal("TrinityAnchorButton"..i).config["showstate"] == "UPDATE") then		
				TrinityAddButton(getglobal("TrinityDockFrame"..TrinityMiscBars["form"]))				
			end
		end 
	end
	
	TrinityUpdateDocking(getglobal("TrinityDockFrame"..TrinityMiscBars["form"]))
end

function TrinityUpdateDockPostions(reset)

	TrinityFunctionCounter("TrinityUpdateDockPostions")

	local dockFrameHeight;
	
	local anchor = "BOTTOM";
	local relTo = "UIParent";
	local relPoint = "BOTTOM";
	local x = 0;
	local y = 6;	
	
	if (reset) then
	
		dockFrameHeight = 45;
		
		for k,v in pairs(TrinityDockFrames) do			
		
			local dockFrame = getglobal("TrinityDockFrame"..k);		
			
			dockFrame:SetUserPlaced(false);		
			dockFrame:ClearAllPoints();			
			dockFrame:SetPoint(anchor, relTo, relPoint, x, y);
			dockFrame:SetUserPlaced(true);		
			y = y + dockFrameHeight;
			TrinityMiscBarSetup(k, dockFrame)
		end			

		TrinityFirstRun = false;
	else	
		for k,v in pairs(TrinityDockFrames) do		
			local dockFrame = getglobal("TrinityDockFrame"..k);										
			dockFrame:SetUserPlaced(false);
			dockFrame:ClearAllPoints();			
			dockFrame:SetPoint("CENTER", relTo, "BOTTOMLEFT", dockFrame.centerx, dockFrame.centery);
			dockFrame:SetUserPlaced(true);
			TrinityMiscBarSetup(k, dockFrame)
		end		
	end
end

function TrinityPagingToggle(dockFrame)

	TrinityFunctionCounter("TrinityPagingToggle")

	if (TrinityDockBarsHide) then
		local paged = {};		
		local found = false;
	
		for k,v in pairs(dockFrame.headers["Actionbar"]["list"]) do			
			if (string.find(v,"%d")) then				
				paged[k] = k;				
				found = true;
			end
		end
		
		if (found) then
			for i=1,6 do			
				if (paged[i]) then
					getglobal(dockFrame.headers["Actionbar"]["name"]):SetAttribute("statemap-actionbar-"..i, "$input");				
				else
					getglobal(dockFrame.headers["Actionbar"]["name"]):SetAttribute("statemap-actionbar-"..i, i..":");				
				end
			end
		end
	else
		for i=1,6 do			
			getglobal(dockFrame.headers["Actionbar"]["name"]):SetAttribute("statemap-actionbar-"..i, "$input");				
		end	
	end
end

function TrinityHideDocksButtons(startDock, endDock)

	TrinityFunctionCounter("TrinityHideDocksButtons")

	if (InCombatLockdown()) then
		return;
	end

	for i=1,120 do		
		if (TrinityPlayerEnteredWorld) then
			local actionButton = getglobal("TrinityActionButton"..i);		
			if (TrinityButtonsHide) then					
				if (not HasAction(i) and 
				    actionButton.config["header"]~="TrinityStorageHeader" and
				    not MouseIsOver(actionButton) and
				    not getglobal("TrinityDockFrame"..actionButton.config["dock"]).config["showgrid"]) then			    
					if (actionButton:GetAttribute("showstates") ~= "NOACTION") then
						if (tonumber(actionButton:GetAttribute("showstates"))) then
							actionButton.config["laststate"] = actionButton:GetAttribute("showstates")				    		
						end
						actionButton:SetAttribute("showstates", "NOACTION");				
						actionButton.config["showstate"] = "NOACTION";
					end				
				end		
			else
				if (tonumber(actionButton.config["laststate"]) and actionButton:GetAttribute("showstates") == "NOACTION") then
					actionButton:SetAttribute("showstates", actionButton.config["laststate"]);
					actionButton.config["showstate"] = actionButton.config["laststate"]
				end				
			end			
		end
	end	

	if (startDock and endDock) then
		for i=startDock,endDock do
			local dockFrame = getglobal("TrinityDockFrame"..i);	
		
			if (TrinityDockBarsHide) then				
				dockFrame.config["vis"] = 1;
				dockFrame:Hide();				
			else
				if (dockFrame.config["stored"] == false) then
					dockFrame:Show();								
				else
					if (not dockFrame.adjusting) then
						dockFrame.config["vis"] = 1;
						dockFrame:Hide();				
					end
				end
			end
			
			TrinitySetTargetBars(dockFrame)
			
			if (TrinityAdaptivePagingEnabled and dockFrame.headers["Actionbar"]["active"]) then
				--TrinityPagingToggle(dockFrame)
			end						
		end
	end

	TrinityRefreshHeaders();	
end

function TrinityUpdateDocking(dockFrame)

	TrinityFunctionCounter("TrinityUpdateDocking")

	local anchorplaced = {};
	local placed = {}
	local last = {}
	
	for key,value in pairs(dockFrame.headers) do
	
		anchorplaced[key] = {};
		placed[key] = {}
		last[key] = {}
		
		for showstate=dockFrame.headers[key]["start"],dockFrame.headers[key]["end"] do				
		
			if (dockFrame.headers[key]["list"][showstate]) then
			
				local buttonList = {};
				local pos = 1;

				anchorplaced[key][showstate] = false;			

				string.gsub(dockFrame.headers[key]["list"][showstate], "%d+", function (btn) table.insert(buttonList, btn) end);				

				for k,v in pairs(buttonList) do		
				
					local actionButton = getglobal(dockFrame.config["btnType"]..v);				
					local width = actionButton:GetWidth();
					local pad = 0;
					local height;
					
					if (dockFrame.config["shape"] < 2) then
						height = 46
					else
						height = actionButton:GetHeight()	
					end
					
		
					getglobal(actionButton:GetName().."HotKey"):SetText(actionButton.config["HotKeyText1"]);		
					getglobal(actionButton:GetName().."HotKeyRound"):SetText(actionButton.config["HotKeyText1"]);					
					
					if (dockFrame:GetID() == TrinityMiscBars["cast"]) then			
						if (TrinityCastingBar:GetOrientation() == "VERTICAL") then					
							width = 30;		
							height = TrinityCastingBar:GetParent():GetHeight()					
						else
							width = TrinityCastingBar:GetParent():GetWidth()		
							height = 40;
						end
					end
					
					if (dockFrame:GetID() == TrinityMiscBars["XP"]) then			
						if (TrinityXPFrameBar:GetOrientation() == "VERTICAL") then					
							width = 30;		
							height = TrinityXPFrame:GetParent():GetHeight()					
						else
							width = TrinityXPFrame:GetParent():GetWidth()		
							height = 40;
						end
					end
					
					if (dockFrame:GetID() == TrinityMiscBars["menu"]) then			
						TrinityDockFrameEditorLeftMenuHighlight:SetScale(dockFrame.config["scale"]);
					end										
					
					actionButton:SetScale(dockFrame.config["scale"]);
					
					if (dockFrame.config["ghost"] ~= 1) then
						actionButton:SetAlpha(dockFrame.config["alpha"]);						
					end		

					actionButton:ClearAllPoints();							

					if (not anchorplaced[key][showstate]) then							

						if (dockFrame.config["shape"] == 0) then
							actionButton:SetPoint("LEFT", dockFrame:GetName(), "CENTER", -(((width*getn(buttonList))+(dockFrame.config["buttonSpaceH"]*(getn(buttonList)-1)))/2), 0);					
							last[key][showstate] = actionButton:GetID();
						elseif (dockFrame.config["shape"] == 1) then
							if (dockFrame:GetID() == TrinityMiscBars["cast"] or dockFrame:GetID() == TrinityMiscBars["XP"]) then	
								actionButton:SetPoint("CENTER", dockFrame:GetName(), "CENTER", 0, ((height+dockFrame.config["buttonSpaceV"])*(getn(buttonList)-1))/2) ;
							else
								actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", 0, ((height+dockFrame.config["buttonSpaceV"])*(getn(buttonList)-1))/2) ;
							end
							last[key][showstate] = actionButton:GetID();
						elseif (dockFrame.config["shape"] == 2) then							
							dockFrame.adjust = 0							
							actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -( (width+dockFrame.config["buttonSpaceH"]) * (dockFrame.config["columns"]/2) - dockFrame.adjust), (height+dockFrame.config["buttonSpaceV"])*((getn(buttonList)/dockFrame.config["columns"])/2));
							placed[key][showstate] = 1;
							dockFrame.multiplier = 1;
							last[key][showstate] = actionButton:GetID();
						elseif (dockFrame.config["shape"] == 3) then
							placed[key][showstate] = 90;
							local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi))*(cos(placed[key][showstate])));
							local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi))*(sin(placed[key][showstate])));
							actionButton:SetPoint("CENTER", dockFrame:GetName(), "CENTER", x, y);						
						elseif (dockFrame.config["shape"] == 4) then
							placed[key][showstate] = 180;
							local radiusH = math.floor((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi));
							local radiusV = math.floor((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi));
							local x = radiusH * (cos(placed[key][showstate]));
							local y = radiusV * (sin(placed[key][showstate]));
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", x, y-(radiusV/2)+(width/2));			
						elseif (dockFrame.config["shape"] == 5) then
							placed[key][showstate] = 180;
							local radiusH = math.floor((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi));
							local radiusV = math.floor((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi));
							local x = radiusH * (cos(placed[key][showstate]));
							local y = radiusV * (sin(placed[key][showstate]));
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", x, y+(radiusV/2)+(width/2));						
						elseif (dockFrame.config["shape"] == 6) then
							placed[key][showstate] = 90;
							local radiusH = math.floor((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi));
							local radiusV = math.floor((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi));
							local x = radiusH * (cos(placed[key][showstate]));
							local y = radiusV * (sin(placed[key][showstate]));
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", x-(radiusH/2), y+(width/2));			
						elseif (dockFrame.config["shape"] == 7) then
							placed[key][showstate] = 90;
							local radiusH = math.floor((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi));
							local radiusV = math.floor((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi));
							local x = radiusH * (cos(placed[key][showstate]));
							local y = radiusV * (sin(placed[key][showstate]));
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", x+(radiusH/2), y+(width/2));			
						end

						anchorplaced[key][showstate] = true;
						actionButton.config["dockpos"] = pos;
						pos = pos + 1;

					else

						if (dockFrame.config["shape"] == 0) then
							actionButton:SetPoint("LEFT", getglobal(dockFrame.config["btnType"]..last[key][showstate]), "RIGHT", dockFrame.config["buttonSpaceH"], 0);							
							last[key][showstate] = actionButton:GetID();
						elseif (dockFrame.config["shape"] == 1) then
							actionButton:SetPoint("TOPLEFT", getglobal(dockFrame.config["btnType"]..last[key][showstate]), "BOTTOMLEFT", 0, -(dockFrame.config["buttonSpaceV"]));						
							last[key][showstate] = actionButton:GetID();
						elseif (dockFrame.config["shape"] == 2) then												
							dockFrame.adjust = 0												
							if ((dockFrame.config["columns"]*dockFrame.multiplier) == placed[key][showstate]+dockFrame.adjust) then
								actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width+dockFrame.config["buttonSpaceH"])*(dockFrame.config["columns"]/2)), (height+dockFrame.config["buttonSpaceV"])*((getn(buttonList)/dockFrame.config["columns"])/2)-(((height+dockFrame.config["buttonSpaceV"])*dockFrame.multiplier)));
								placed[key][showstate] = placed[key][showstate] + 1;
								dockFrame.multiplier = dockFrame.multiplier + 1;
							else
								actionButton:SetPoint("LEFT", getglobal(dockFrame.config["btnType"]..last[key][showstate]), "RIGHT", dockFrame.config["buttonSpaceH"], 0);							
								placed[key][showstate] = placed[key][showstate] + 1;								
							end
							last[key][showstate] = actionButton:GetID();
						elseif (dockFrame.config["shape"] == 3) then
							placed[key][showstate] = placed[key][showstate] - (360/getn(buttonList));							
							local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi))*(cos(placed[key][showstate])));
							local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi))*(sin(placed[key][showstate])));
							actionButton:SetPoint("CENTER", dockFrame:GetName(), "CENTER", x, y);						
						elseif (dockFrame.config["shape"] == 4) then
							placed[key][showstate] = placed[key][showstate] - (180/(getn(buttonList)-1));							
							local radiusH = math.floor((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi));
							local radiusV = math.floor((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi));
							local x = radiusH * (cos(placed[key][showstate]));
							local y = radiusV * (sin(placed[key][showstate]));
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", x, y-(radiusV/2)+(width/2));			
						elseif (dockFrame.config["shape"] == 5) then
							placed[key][showstate] = placed[key][showstate] + (180/(getn(buttonList)-1));							
							local radiusH = math.floor((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi));
							local radiusV = math.floor((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi));
							local x = radiusH * (cos(placed[key][showstate]));
							local y = radiusV * (sin(placed[key][showstate]));
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", x, y+(radiusV/2)+(width/2));						
						elseif (dockFrame.config["shape"] == 6) then
							placed[key][showstate] = placed[key][showstate] - (180/(getn(buttonList)-1));							
							local radiusH = math.floor((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi));
							local radiusV = math.floor((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi));
							local x = radiusH * (cos(placed[key][showstate]));
							local y = radiusV * (sin(placed[key][showstate]));
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", x-(radiusH/2), y+(width/2));			
						elseif (dockFrame.config["shape"] == 7) then
							placed[key][showstate] = placed[key][showstate] + (180/(getn(buttonList)-1));							
							local radiusH = math.floor((width+dockFrame.config["buttonSpaceH"])*(getn(buttonList)/math.pi));
							local radiusV = math.floor((width+dockFrame.config["buttonSpaceV"])*(getn(buttonList)/math.pi));
							local x = radiusH * (cos(placed[key][showstate]));
							local y = radiusV * (sin(placed[key][showstate]));
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", x+(radiusH/2), y+(width/2));			
						end		
						
						actionButton.config["dockpos"] = pos;
						pos = pos + 1;						
					end
				end
			end
		end		
	end	
	
	TrinityHideDocksButtons(dockFrame:GetID(), dockFrame:GetID())
	
	TrinitySetupDockFrameUpdate(dockFrame)	
	
end

function TrinitySetupDockFrameUpdate(dockFrame)

	TrinityFunctionCounter("TrinitySetupDockFrameUpdate")
	
	local width, height, pad;		
	
	local activeHeader, showstate, buttonList, buttonCount, foundActive = TrinityGetCurrHeaderShowstate(dockFrame)		
	
	if (buttonCount > 0) then
			
		if (TrinityDockBarsHide) then
			pad = 0;
			if (dockFrame:GetID() == TrinityMiscBars["cast"]) then			
				if (TrinityCastingBar:GetOrientation() == "VERTICAL") then					
					width = TrinityCastingBar:GetParent():GetWidth()		
					height = TrinityCastingBar:GetParent():GetHeight()					
				else
					width = TrinityCastingBar:GetParent():GetWidth()		
					height = TrinityCastingBar:GetParent():GetHeight()
				end
			elseif (dockFrame:GetID() == TrinityMiscBars["XP"]) then			
				if (TrinityXPFrameBar:GetOrientation() == "VERTICAL") then					
					width = TrinityXPFrame:GetParent():GetWidth()		
					height = TrinityXPFrame:GetParent():GetHeight()					
				else
					width = TrinityXPFrame:GetParent():GetWidth()		
					height = TrinityXPFrame:GetParent():GetHeight()					
				end			
			else
				width = getglobal(dockFrame.config["btnType"]..buttonList[1]):GetWidth()	
				height = getglobal(dockFrame.config["btnType"]..buttonList[1]):GetHeight()	
			end			
		else
			pad = 10
			if (dockFrame:GetID() == TrinityMiscBars["cast"]) then			
				if (TrinityCastingBar:GetOrientation() == "VERTICAL") then					
					width = 30;		
					height = TrinityCastingBar:GetParent():GetHeight()					
				else
					width = TrinityCastingBar:GetParent():GetWidth()		
					height = 46;
				end
			elseif (dockFrame:GetID() == TrinityMiscBars["XP"]) then			
				if (TrinityXPFrameBar:GetOrientation() == "VERTICAL") then					
					width = 30;		
					height = TrinityXPFrame:GetParent():GetHeight()					
				else
					width = TrinityXPFrame:GetParent():GetWidth()		
					height = 46;
				end			
			else
				width = getglobal(dockFrame.config["btnType"]..buttonList[1]):GetWidth()	
				if (dockFrame.config["shape"] < 2) then
					height = 46
				else
					height = getglobal(dockFrame.config["btnType"]..buttonList[1]):GetHeight()	
				end
			end			
		end
	else
		pad = 10; width = 36; height = 46;			
	end		
	
	TrinityUpdateDockFrame(dockFrame, activeHeader, showstate, buttonCount, width, height, pad);			
end

function TrinityGetCurrHeaderShowstate(dockFrame)

	TrinityFunctionCounter("TrinityGetCurrHeaderShowstate")

	local activeHeader, showstate, buttonCount, parent, btn;
	local buttonList = {};
	local foundActive = false;
	local order = 0;
	
	if (TrinityHeaderEditor:GetID() == dockFrame:GetID() and TrinityHeaderEditor:IsVisible()) then
		TrinityRefreshOrderList(dockFrame)
	end

	if (getglobal(dockFrame.headers["Normal"]["name"])) then	
		dockFrame.headers["Normal"]["currState"] = 0;
	end
	if (getglobal(dockFrame.headers["Actionbar"]["name"])) then	
		dockFrame.headers["Actionbar"]["currState"] = GetActionBarPage();
	end
	if (getglobal(dockFrame.headers["Stance"]["name"])) then
		dockFrame.headers["Stance"]["currState"] = GetShapeshiftForm();		
	end
	if (getglobal(dockFrame.headers["Stealth"]["name"])) then
		dockFrame.headers["Stealth"]["currState"] = IsStealthed() or 0;		
	end
	if (getglobal(dockFrame.headers["Alt"]["name"])) then
		dockFrame.headers["Alt"]["currState"] = IsAltKeyDown() or 0;		
	end
	if (getglobal(dockFrame.headers["Ctrl"]["name"])) then
		dockFrame.headers["Ctrl"]["currState"] = IsControlKeyDown() or 0;		
	end
	if (getglobal(dockFrame.headers["Shift"]["name"])) then
		dockFrame.headers["Shift"]["currState"] = IsShiftKeyDown() or 0;		
	end
	
	for k,v in pairs(dockFrame.headers) do
		if (dockFrame.headers[k]["active"]) then
			if (dockFrame.headers[k]["parent"]) then
				parent = dockFrame.headers[k]["parent"];
				if (not string.find(parent, "Trinity")) then
					parent = "Normal"
				else				
					parent = string.gsub(dockFrame.headers[k]["parent"], "(Trinity)(%a+)(Header%d*)", "%2");						
				end
				if (tonumber(dockFrame.headers[parent]["currState"]) == tonumber(dockFrame.headers[k]["showstate"])) then		    
					if (tonumber(dockFrame.headers[k]["order"]) >= order) then
						order = tonumber(dockFrame.headers[k]["order"])				
						activeHeader = k
						showstate = tonumber(dockFrame.headers[k]["currState"])
						foundActive = true;													
					end
				end
			end						
		end
	end
	
	if (not foundActive) then
		activeHeader = "Normal"
		showstate = 0;
	end		
	
	if (dockFrame.headers[activeHeader]["list"][showstate]) then
		string.gsub(dockFrame.headers[activeHeader]["list"][showstate], "%d+", function (btn) table.insert(buttonList, btn) end);
	end
	
	buttonCount = getn(buttonList)
	
	return activeHeader, showstate, buttonList, buttonCount, foundActive;
end

-- This function sizes the dockframe
function TrinityUpdateDockFrame(dockFrame, activeHeader, showstate, buttonCount, width, height, pad, num)

	TrinityFunctionCounter("TrinityUpdateDockFrame")

	local buttonList = {};
	
	if (dockFrame.elapsed < 0.75) then
		dockFrame.update = true;
		return;
	end	

	dockFrame:SetUserPlaced(false);
	local x,y = dockFrame:GetCenter();
	
	TrinityUpdateBarLabel(dockFrame, activeHeader);
	
	if (dockFrame.config["shape"] == 0) then				
		dockFrame:SetWidth((((width+dockFrame.config["buttonSpaceH"])*buttonCount)*dockFrame.config["scale"])+(pad*4));		
		dockFrame:SetHeight(height);				
	elseif (dockFrame.config["shape"] == 1) then
		dockFrame:SetWidth(width*1.4);
		dockFrame:SetHeight((((height+dockFrame.config["buttonSpaceV"])*(buttonCount))*dockFrame.config["scale"])+(pad*3));			
	elseif (dockFrame.config["shape"] == 2) then
		dockFrame:SetWidth((((width+dockFrame.config["buttonSpaceH"])*dockFrame.config["columns"])*dockFrame.config["scale"])+(pad*4));
		dockFrame:SetHeight((height+dockFrame.config["buttonSpaceV"])*(math.ceil(buttonCount/dockFrame.config["columns"]))*dockFrame.config["scale"]);
	elseif (dockFrame.config["shape"] == 3) then
		dockFrame:SetWidth(((((width+dockFrame.config["buttonSpaceH"])*2)*((buttonCount/math.pi)))*dockFrame.config["scale"])+(width));
		dockFrame:SetHeight(((((height+dockFrame.config["buttonSpaceV"])*2)*((buttonCount/math.pi)))*dockFrame.config["scale"])+(height));
	elseif (dockFrame.config["shape"] == 4) then
		dockFrame:SetWidth(((width+dockFrame.config["buttonSpaceH"])*(buttonCount/math.pi)*dockFrame.config["scale"]*2)+(width));
		dockFrame:SetHeight(((height+dockFrame.config["buttonSpaceV"])*(buttonCount/math.pi)*dockFrame.config["scale"])+(height));
	elseif (dockFrame.config["shape"] == 5) then
		dockFrame:SetWidth(((width+dockFrame.config["buttonSpaceH"])*(buttonCount/math.pi)*dockFrame.config["scale"]*2)+(width));
		dockFrame:SetHeight(((height+dockFrame.config["buttonSpaceV"])*(buttonCount/math.pi)*dockFrame.config["scale"])+(height));	
	elseif (dockFrame.config["shape"] == 6) then
		dockFrame:SetWidth(((width+dockFrame.config["buttonSpaceH"])*(buttonCount/math.pi)*dockFrame.config["scale"])+(width));
		dockFrame:SetHeight(((height+dockFrame.config["buttonSpaceV"])*(buttonCount/math.pi)*dockFrame.config["scale"]*2)+(height));    
	elseif (dockFrame.config["shape"] == 7) then
		dockFrame:SetWidth(((width+dockFrame.config["buttonSpaceH"])*(buttonCount/math.pi)*dockFrame.config["scale"])+(width));
		dockFrame:SetHeight(((height+dockFrame.config["buttonSpaceV"])*(buttonCount/math.pi)*dockFrame.config["scale"]*2)+(height));    
	end
	
	if (TrinityPlayerEnteredWorld) then		
		dockFrame:ClearAllPoints();
		dockFrame:SetPoint("CENTER","UIParent", "BOTTOMLEFT", x, y);
		dockFrame:SetUserPlaced(true);
	end
	
	TrinitySaveButtonState();		
end

function TrinityUpdateBarLabel(dockFrame, activeHeader)

	TrinityFunctionCounter("TrinityUpdateBarLabel")

	if (not dockFrame.selected) then
		return;
	end

	local stealth = IsStealthed() or 0;
	local targetText, stanceText	
	local targets = {
		["none"] = "None",
		["player"] = "Self",
		["pet"] = "Pet",
		["target"] = "CurTgt",
		["targettarget"] = "TgtTgt",
		["focus"] = "Focus",
		["party1"] = "Party1",
		["partypet1"] = "P-Pet1",
		["party2"] = "Party2",
		["partypet2"] = "P-Pet2",
		["party3"] = "Party3",
		["partypet3"] = "P-Pet3",
		["party4"] = "Party4",
		["partypet4"] = "P-Pet4",
		["mouseover"] = "Mouse",
		["raid1"] = "Raid1",
		["raid1pet"] = "R-Pet1",		
		["raid2"] = "Raid1",
		["raid2pet"] = "R-Pet2",	
		["raid3"] = "Raid1",
		["raid3pet"] = "R-Pet3",		
		["raid4"] = "Raid1",
		["raid4pet"] = "R-Pet4",		
		["raid5"] = "Raid1",
		["raid5pet"] = "R-Pet5",		
		["raid6"] = "Raid1",
		["raid6pet"] = "R-Pet6",		
		["raid7"] = "Raid1",
		["raid7pet"] = "R-Pet7",		
		["raid8"] = "Raid1",
		["raid8pet"] = "R-Pet8",		
		["raid9"] = "Raid1",
		["raid9pet"] = "R-Pet9",		
		["raid10"] = "Raid1",
		["raid10pet"] = "R-Pet10",		
		["raid11"] = "Raid1",
		["raid11pet"] = "R-Pet11",		
		["raid12"] = "Raid1",
		["raid12pet"] = "R-Pet12",		
		["raid13"] = "Raid1",
		["raid13pet"] = "R-Pet13",		
		["raid14"] = "Raid1",
		["raid14pet"] = "R-Pet14",		
		["raid15"] = "Raid1",
		["raid15pet"] = "R-Pet15",		
		["raid16"] = "Raid1",
		["raid16pet"] = "R-Pet16",		
		["raid17"] = "Raid1",
		["raid17pet"] = "R-Pet17",		
		["raid18"] = "Raid1",
		["raid18pet"] = "R-Pet18",		
		["raid19"] = "Raid1",
		["raid19pet"] = "R-Pet19",		
		["raid20"] = "Raid1",
		["raid20pet"] = "R-Pet20",		
		["raid21"] = "Raid1",
		["raid21pet"] = "R-Pet21",		
		["raid22"] = "Raid1",
		["raid22pet"] = "R-Pet22",		
		["raid23"] = "Raid1",
		["raid23pet"] = "R-Pet23",		
		["raid24"] = "Raid1",
		["raid24pet"] = "R-Pet24",		
		["raid25"] = "Raid1",
		["raid25pet"] = "R-Pet25",		
		["raid26"] = "Raid1",
		["raid26pet"] = "R-Pet26",		
		["raid27"] = "Raid1",
		["raid27pet"] = "R-Pet27",		
		["raid28"] = "Raid1",
		["raid28pet"] = "R-Pet28",		
		["raid29"] = "Raid1",
		["raid29pet"] = "R-Pet29",		
		["raid30"] = "Raid1",
		["raid30pet"] = "R-Pet30",		
		["raid31"] = "Raid1",
		["raid31pet"] = "R-Pet31",		
		["raid32"] = "Raid1",
		["raid32pet"] = "R-Pet32",		
		["raid33"] = "Raid1",
		["raid33pet"] = "R-Pet33",		
		["raid34"] = "Raid1",
		["raid34pet"] = "R-Pet34",		
		["raid35"] = "Raid1",
		["raid35pet"] = "R-Pet35",		
		["raid36"] = "Raid1",
		["raid36pet"] = "R-Pet36",		
		["raid37"] = "Raid1",
		["raid37pet"] = "R-Pet37",		
		["raiddiamond"] = "Raid1",
		["raiddpet"] = "R-Pet38",		
		["raid39"] = "Raid1",
		["raid39pet"] = "R-Pet39",		
		["raid40"] = "Raid1",
		["raid40pet"] = "R-Pet40",		
	}
	
	if (GetShapeshiftForm() ~= 0) then
		_, stanceText, _ = GetShapeshiftFormInfo(GetShapeshiftForm());
		if (UnitClass("player") == TRINITY_PRIEST) then
			stanceText = UnitClass("player");
		end
	else
		stanceText = UnitClass("player");
	end
	
	if (IsStealthed() and stanceText == "Cat Form") then
		stanceText = "Prowl"
	elseif (IsStealthed()) then
		stanceText = "Stealth"
	end	
	
	targetText = targets[dockFrame.config["target"]];
	if (stanceText) then
		stanceText = string.match(stanceText, "^%a+");
	end
	
	if (activeHeader == "Stance" or activeHeader == "Stealth") then
		if (dockFrame.mode == 1) then
			TrinityDockFrameEditorRightBarTypeBarNumber:SetText(stanceText);			
		else
			TrinityDockFrameEditorRightBarTypeBarNumber:SetText(targetText);	
		end
	elseif (activeHeader == "Actionbar") then
		if (dockFrame.mode == 1) then
			TrinityDockFrameEditorRightBarTypeBarNumber:SetText("Paged-"..GetActionBarPage());
		else
			TrinityDockFrameEditorRightBarTypeBarNumber:SetText(targetText);	
		end
	elseif (dockFrame:GetID() == TrinityMiscBars["bags"]) then		

	elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then

	elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

	elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

	elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then

	elseif (dockFrame:GetID() == TrinityMiscBars["XP"]) then

	else	
		if (dockFrame.mode == 1) then
			TrinityDockFrameEditorRightBarTypeBarNumber:SetText(activeHeader);		
		else
			TrinityDockFrameEditorRightBarTypeBarNumber:SetText(targetText);	
		end
	end		
end

-- This function updates each button with visual elements
function Trinity_UpdateButton()

	TrinityFunctionCounter("Trinity_UpdateButton")

	if (not TrinityPlayerEnteredWorld) then
		return;
	end

	local id = this:GetID();	
	local icon = getglobal(this:GetName().."IconFrame".."Icon");
	local isUsable, notEnoughMana = IsUsableAction(id);
	
	if ( isUsable ) then
		if ( IsActionInRange(id) == 0) then
			icon:SetVertexColor(0.8, 0.1, 0.1);			
		else
			icon:SetVertexColor(1.0, 1.0, 1.0);			
		end
	elseif ( notEnoughMana ) then
		icon:SetVertexColor(0.2, 0.2, 0.9);		
	else
		icon:SetVertexColor(0.3, 0.3, 0.3);		
	end	
	
	if ( IsCurrentAction(id) or IsAutoRepeatAction(id) ) then
		this:SetChecked(1);
	else
		this:SetChecked(0);
	end		

end

function Trinity_UpdateActionbar_OnEvent(button)

	TrinityFunctionCounter("Trinity_UpdateActionbar_OnEvent")

	local id = button:GetID();	
	local macroName = getglobal(button:GetName().."Name");
	local icon = getglobal(button:GetName().."IconFrame".."Icon");
	local border = getglobal(button:GetName().."Border");
	local normalTexture = getglobal(button:GetName().."NormalTexture");		
	local count = getglobal(button:GetName().."Count");

	macroName:SetText(GetActionText(id));
	
	if ( HasAction(id) ) then
		local texture = GetActionTexture(id);
		icon:SetTexture(texture);
		icon:SetTexCoord(0,1,0,1);
		if (button.config["style"] == 1) then
			button:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		elseif (button.config["style"] == 3) then
			button:SetNormalTexture("");
			icon:SetTexCoord(0.08,0.92,0.08,0.92);
		end
		normalTexture:SetVertexColor(1,1,1,1);
		icon:Show();		
	else	
		if (button.config["style"] == 1 or button.config["style"] == 3) then					
			button:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");					
		end
		normalTexture:SetVertexColor(1,1,1,0.35);
		icon:Hide();
	end
	
	if ( IsEquippedAction(id) ) then
		border:SetVertexColor(0, 1.0, 0, 0.5);
		border:Show();
	else
		border:Hide();
	end	
	
	if ( IsConsumableAction(id) ) then
		count:SetText(GetActionCount(id));
	else
		count:SetText("");
	end	
end
	
function Trinity_UpdateCooldown_OnUpdate()	

	TrinityFunctionCounter("Trinity_UpdateCooldown_OnUpdate")

	local id = this:GetID();	
	local cooldowntext=getglobal(this:GetName().."CooldownText");
	local cooldowntexthuge=getglobal(this:GetName().."CooldownTextHuge");		
	local start, duration, enable = GetActionCooldown(id);	

	--cooldown code courtesy of hacocuk from Curse Gaming
	if (TrinityCoolDown) then
		if ( start > 0 and duration > 4 and enable > 0) then			
			local cd=math.ceil(duration-(GetTime()-start));		
			if (cd<6) then
				cooldowntext:Hide()
				cooldowntexthuge:Show()				
			else
				cooldowntext:Show()
				cooldowntexthuge:Hide()						
			end				
			if(cd>60) then
				cd=ceil(cd/60);
				cd=cd.."m";
			end		
			cooldowntexthuge:SetText(cd);
			cooldowntext:SetText(cd);
		else
			cooldowntext:SetText("");
			cooldowntexthuge:SetText("");
			this.cooldown = nil;
		end		
	end	
end

function Trinity_UpdateCooldown_OnEvent()

	TrinityFunctionCounter("Trinity_UpdateCooldown_OnEvent")

	local id = this:GetID();	
	
	if (HasAction(id) and not getglobal("TrinityDockFrame"..this.config["dock"]).config["ghost"]) then
		local cooldown = getglobal(this:GetName().."IconFrame".."Cooldown");
		local start, duration, enable = GetActionCooldown(id);			
		CooldownFrame_SetTimer(cooldown, start, duration, enable);			
		this.cooldown = true;
	end
end

function Trinity_UpdateInventory_OnEvent()

	TrinityFunctionCounter("Trinity_UpdateInventory_OnEvent")

	local id = this:GetID();	
	local border = getglobal(this:GetName().."Border");
	local count = getglobal(this:GetName().."Count");

	if ( IsEquippedAction(id) ) then
		border:SetVertexColor(0, 1.0, 0, 0.5);
		border:Show();
	else
		border:Hide();
	end	
	
	if ( IsConsumableAction(id) ) then
		count:SetText(GetActionCount(id));
	else
		count:SetText("");
	end
end

function TrinityRefreshHeaders()

	TrinityFunctionCounter("TrinityRefreshHeaders")	

	local header, state;
	
	if (not InCombatLockdown()) then

		for k,v in pairs(TrinityDockFrames) do
		
			local dockFrame = getglobal("TrinityDockFrame"..k)
			
			local activeHeader, _, _, _, _ = TrinityGetCurrHeaderShowstate(dockFrame)				
			
			for key,value in pairs(dockFrame.headers) do
				if (dockFrame.headers[key]["active"]) then
				
					header = getglobal(dockFrame.headers[key]["name"])				
					
					if (key == "Normal") then
						if (dockFrame.config["battle"]) then
							state = 1;
						else
							state = 0;
						end						
						header:SetAttribute("state-0", state);
					elseif (key == "Actionbar") then
						state = GetActionBarPage();
						header:SetAttribute("state-"..string.lower(key), state+1);
						header:SetAttribute("state-"..string.lower(key), state);					
					elseif (key == "Stance") then
						state = GetShapeshiftForm();
						header:SetAttribute("state-"..string.lower(key), state+1);
						header:SetAttribute("state-"..string.lower(key), state);					
					elseif (key == "Stealth") then
						state = IsStealthed() or 0;
						header:SetAttribute("state-"..string.lower(key), state+1);
						header:SetAttribute("state-"..string.lower(key), state);					
					elseif (key == "Alt") then
						state = IsAltKeyDown() or 0;
						header:SetAttribute("state-"..string.lower(key), state+1);					
						header:SetAttribute("state-"..string.lower(key), state);					
					elseif (key == "Ctrl") then				
						state = IsControlKeyDown() or 0;			
						header:SetAttribute("state-"..string.lower(key), state+1);
						header:SetAttribute("state-"..string.lower(key), state);					
					elseif (key == "Shift") then
						state = IsShiftKeyDown() or 0;			
						header:SetAttribute("state-"..string.lower(key), state+1);
						header:SetAttribute("state-"..string.lower(key), state);					
					end
					
					SecureStateHeader_Refresh(header, state);						
				end
			end

			header = getglobal(dockFrame.headers[activeHeader]["name"])
			if (activeHeader == "Normal") then
				if (dockFrame.config["battle"]) then
					state = 1;
				else
					state = 0;
				end								
			else				
				state = header:GetAttribute("state-"..string.lower(activeHeader));								
			end
			SecureStateHeader_Refresh(header, state);									
		
			dockFrame.config["vis"] = 1;
		
			SecureStateHeader_Refresh(TrinityStorageHeader, "99");			
		end			
	end
end

function TrinityActionButton_SetTooltip()

	TrinityFunctionCounter("TrinityActionButton_SetTooltip")

	if ( GetCVar("UberTooltips") == "1" ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);
	else
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");		
	end
	
	if ( GameTooltip:SetAction(this:GetID()) ) then
		this.updateTooltip = TOOLTIP_UPDATE_TIME;
	else
		this.updateTooltip = nil;
	end
end

-- Function to change the arrangment of buttons
function TrinityChangeShape(frame, dir)

	TrinityFunctionCounter("TrinityChangeShape")

	frame.elapsed = 0;
	
	if (dir == "left") then
		frame.config["shape"] = frame.config["shape"] - 1;
		if (frame.config["shape"] < 0) then
			frame.config["shape"] = TrinityMaxDockShapes
		end
	elseif (dir == "right") then
		frame.config["shape"] = frame.config["shape"] + 1;
		if (frame.config["shape"] > TrinityMaxDockShapes) then
			frame.config["shape"] = 0;
		end
	end
	
	if (frame.config["shape"] ~= 2) then
		TrinityDockFrameEditorRightIncreaseRows:Hide();
		TrinityDockFrameEditorRightDecreaseRows:Hide();
		TrinityDockFrameEditorRightColumns:Hide();
		TrinityDockFrameEditorRightRows:Hide();
	else
		TrinityDockFrameEditorRightIncreaseRows:Show();
		TrinityDockFrameEditorRightDecreaseRows:Show();
		TrinityDockFrameEditorRightColumns:Show();
		TrinityDockFrameEditorRightRows:Show();	
	end			
end

function TrinityChangeTarget(frame, dir)

	TrinityFunctionCounter("TrinityChangeTarget")

	local index;

	for i=1, getn(TrinityTargets) do
		if (frame.config["target"] == TrinityTargets[i]) then
			index = i;
			break;
		end
	end

	if (dir == "right") then
		if (index == 1) then
			index = getn(TrinityTargets)
		else
			index = index - 1;
		end
		
		frame.config["target"] = TrinityTargets[index];
		
	elseif (dir == "left") then
		if (index == getn(TrinityTargets)) then
			index = 1;
		else
			index = index + 1;
		end
		
		frame.config["target"] = TrinityTargets[index];
	end	
	
	TrinityUpdateTargeting(frame);
end

function TrinityUpdateTargeting(frame)

	TrinityFunctionCounter("TrinityUpdateTargeting")

	local actionButton;
	
	for key, value in pairs(frame.headers) do
		if (frame.headers[key]["active"]) then
			for k,v in pairs(frame.headers[key]["list"]) do
				local buttonList = {}				
				if (v and v ~= "") then
					string.gsub(v, "%d+", function (btn) table.insert(buttonList, btn) end);		
					for i=1,getn(buttonList) do					
						actionButton = getglobal(frame.config["btnType"]..buttonList[i]);
						if (frame.config["target"] == "none") then
							actionButton:SetAttribute("useparent-unit", true);
							actionButton:SetAttribute("unit", nil);
							frame.headers["Normal"]["parent"] = "UIParent";
							getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");							
							getglobal(frame.headers["Normal"]["name"]):Show()
						else
							actionButton:SetAttribute("useparent-unit", false);
							actionButton:SetAttribute("unit", frame.config["target"]);	
						end						
					end
				end
			end
		end
	end
	
	TrinitySetTargetBars(frame)
end

function TrinitySetTargetBars(frame)

	TrinityFunctionCounter("TrinitySetTargetBars")

	if (frame.config["target"] == "target") then
		if (TrinityDockBarsHide) then
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["currtarget"])) then
				frame.headers["Normal"]["parent"] = TrinityUnitFrameSets[TrinityUnitSet]["currtarget"];
				getglobal(frame.headers["Normal"]["name"]):SetParent(TrinityUnitFrameSets[TrinityUnitSet]["currtarget"]);
				getglobal(frame.headers["Normal"]["name"]):SetScale(1)
			else
				frame.headers["Normal"]["parent"] = "UIParent";
				getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
				getglobal(frame.headers["Normal"]["name"]):Show()											
			end
		else
			frame.headers["Normal"]["parent"] = "UIParent";
			getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
			getglobal(frame.headers["Normal"]["name"]):Show()
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["currtarget"])) then
				getglobal(frame.headers["Normal"]["name"]):SetScale(getglobal(TrinityUnitFrameSets[TrinityUnitSet]["currtarget"]):GetScale())
			end
		end
	elseif (frame.config["target"] == "targettarget") then
		if (TrinityDockBarsHide) then	
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["targettarget"])) then
				frame.headers["Normal"]["parent"] = TrinityUnitFrameSets[TrinityUnitSet]["targettarget"];
				getglobal(frame.headers["Normal"]["name"]):SetParent(TrinityUnitFrameSets[TrinityUnitSet]["targettarget"]);
				getglobal(frame.headers["Normal"]["name"]):SetScale(1)
			else
				frame.headers["Normal"]["parent"] = "UIParent";
				getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
				getglobal(frame.headers["Normal"]["name"]):Show()
			end
		else
			frame.headers["Normal"]["parent"] = "UIParent";
			getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
			getglobal(frame.headers["Normal"]["name"]):Show()
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["targettarget"])) then
				getglobal(frame.headers["Normal"]["name"]):SetScale(getglobal(TrinityUnitFrameSets[TrinityUnitSet]["targettarget"]):GetScale())
			end
		end			
	elseif (frame.config["target"] == "party1") then
		if (TrinityDockBarsHide) then	
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party1"])) then
				frame.headers["Normal"]["parent"] = TrinityUnitFrameSets[TrinityUnitSet]["party1"];
				getglobal(frame.headers["Normal"]["name"]):SetParent(TrinityUnitFrameSets[TrinityUnitSet]["party1"]);
				getglobal(frame.headers["Normal"]["name"]):SetScale(1)
			else
				frame.headers["Normal"]["parent"] = "UIParent";
				getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
				getglobal(frame.headers["Normal"]["name"]):Show()
			end
		else
			frame.headers["Normal"]["parent"] = "UIParent";
			getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
			getglobal(frame.headers["Normal"]["name"]):Show()
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party1"])) then
				getglobal(frame.headers["Normal"]["name"]):SetScale(getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party1"]):GetScale())
			end			
		end			
	elseif (frame.config["target"] == "party2") then
		if (TrinityDockBarsHide) then	
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party2"])) then
				frame.headers["Normal"]["parent"] = TrinityUnitFrameSets[TrinityUnitSet]["party2"];
				getglobal(frame.headers["Normal"]["name"]):SetParent(TrinityUnitFrameSets[TrinityUnitSet]["party2"]);
				getglobal(frame.headers["Normal"]["name"]):SetScale(1)
			else
				frame.headers["Normal"]["parent"] = "UIParent";
				getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
				getglobal(frame.headers["Normal"]["name"]):Show()
			end
		else
			frame.headers["Normal"]["parent"] = "UIParent";
			getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
			getglobal(frame.headers["Normal"]["name"]):Show()
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party2"])) then
				getglobal(frame.headers["Normal"]["name"]):SetScale(getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party2"]):GetScale())
			end			
		end			
	elseif (frame.config["target"] == "party3") then
		if (TrinityDockBarsHide) then	
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party3"])) then
				frame.headers["Normal"]["parent"] = TrinityUnitFrameSets[TrinityUnitSet]["party3"];
				getglobal(frame.headers["Normal"]["name"]):SetParent(TrinityUnitFrameSets[TrinityUnitSet]["party3"]);
				getglobal(frame.headers["Normal"]["name"]):SetScale(1)
			else
				frame.headers["Normal"]["parent"] = "UIParent";
				getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
				getglobal(frame.headers["Normal"]["name"]):Show()
			end
		else
			frame.headers["Normal"]["parent"] = "UIParent";
			getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");	
			getglobal(frame.headers["Normal"]["name"]):Show()
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party3"])) then
				getglobal(frame.headers["Normal"]["name"]):SetScale(getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party3"]):GetScale())
			end			
		end			
	elseif (frame.config["target"] == "party4") then
		if (TrinityDockBarsHide) then	
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party4"])) then
				frame.headers["Normal"]["parent"] = TrinityUnitFrameSets[TrinityUnitSet]["party4"];
				getglobal(frame.headers["Normal"]["name"]):SetParent(TrinityUnitFrameSets[TrinityUnitSet]["party4"]);
				getglobal(frame.headers["Normal"]["name"]):SetScale(1)
			else
				frame.headers["Normal"]["parent"] = "UIParent";
				getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
				getglobal(frame.headers["Normal"]["name"]):Show()
			end
		else
			frame.headers["Normal"]["parent"] = "UIParent";
			getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");		
			getglobal(frame.headers["Normal"]["name"]):Show()
			if (getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party4"])) then
				getglobal(frame.headers["Normal"]["name"]):SetScale(getglobal(TrinityUnitFrameSets[TrinityUnitSet]["party4"]):GetScale())
			end			
		end			
	else
		frame.headers["Normal"]["parent"] = "UIParent";
		getglobal(frame.headers["Normal"]["name"]):SetParent("UIParent");														
		getglobal(frame.headers["Normal"]["name"]):Show()
		getglobal(frame.headers["Normal"]["name"]):SetScale(1)
	end
end

-- Function to change the size of buttons
function TrinityUpdateScale(frame, action)

	TrinityFunctionCounter("TrinityUpdateScale")

	frame.elapsed = 0;
	
	if (action == "up") then
		frame.config["scale"] = frame.config["scale"] + 0.01;
	else
		frame.config["scale"] = frame.config["scale"] - 0.01;
		if (frame.config["scale"] < 0.2) then
			frame.config["scale"] = 0.2;
		end
	end	
end

-- Function to change the opacity of buttons.
function TrinityUpdateAlpha(frame, action)

	TrinityFunctionCounter("TrinityUpdateAlpha")

	if (action == "up") then
		frame.config["alpha"] = frame.config["alpha"] + 0.05;
		if (frame.config["alpha"] > 1) then
			frame.config["alpha"] = 1;
		end
	else
		frame.config["alpha"] = frame.config["alpha"] - 0.05;
		if (frame.config["alpha"] < 0.1) then
			frame.config["alpha"] = 0.1;
		end
	end	
end

function TrinityAdjustSpacing(frame, dir)

	TrinityFunctionCounter("TrinityAdjustSpacing")

	frame.elapsed = 0;

	if (dir == "add") then
	
		if (this.click == "LeftButton") then
			frame.config["buttonSpaceH"] = frame.config["buttonSpaceH"] + 1;
		else
			frame.config["buttonSpaceV"] = frame.config["buttonSpaceV"] + 1;
		end
		
	else
	
		if (this.click == "LeftButton") then
			frame.config["buttonSpaceH"] = frame.config["buttonSpaceH"] - 1;
		else
			frame.config["buttonSpaceV"] = frame.config["buttonSpaceV"] - 1;
		end
		
	end

end

function TrinityUpdateRows(frame, action)

	TrinityFunctionCounter("TrinityUpdateRows")

	frame.elapsed = 0;
	
	local _, _, _, buttonCount, _ = TrinityGetCurrHeaderShowstate(frame)
	
	if (action == "up") then
	
		frame.config["columns"] = frame.config["columns"] + 1;
		if (frame.config["columns"] > buttonCount) then
			frame.config["columns"] = buttonCount;
		end
	else
		frame.config["columns"] = frame.config["columns"] - 1;
		if (frame.config["columns"] < 2) then
			frame.config["columns"] = 2;
		end
	end
	
	TrinityDockFrameEditorRightRows:SetText(frame.config["columns"]);	
end

-- Function to add a button to a docking frame.
function TrinityAddButton(frame)

	TrinityFunctionCounter("TrinityAddButton")

	local activeHeader, showstate, buttonList, buttonCount, foundActive = TrinityGetCurrHeaderShowstate(frame)	
	local newButton = 0;
	
	frame.elapsed = 0;

	for i=1,155 do		
	
		if (frame.config["btnType"] == "TrinityActionButton") then
			if (TrinityStorageHeader.data["buttonIndex"][i] == 1 and newButton == 0) then
				newButton = i
				break
			end
		elseif (frame.config["btnType"] == "TrinityAnchorButton") then
			if (getglobal(frame.config["btnType"]..i)) then
				if (tonumber(getglobal(frame.config["btnType"]..i).config["homedock"]) == tonumber(frame:GetID())) then
					if (TrinityStorageHeader.data["anchorIndex"][i] == 1 and newButton == 0) then
						newButton = i
						break
					end
				end
			end
		end	
	end
	
	if (newButton ~=0) then
		actionButton = getglobal(frame.config["btnType"]..newButton);		
		actionButton:SetClampedToScreen(true)
			
		actionButton.config["dock"] = frame:GetID();
		actionButton.config["showstate"] = showstate;
		actionButton:SetAttribute("showstates", showstate);			
		actionButton.config["header"] = frame.headers[activeHeader]["name"];
		getglobal(frame.headers[activeHeader]["name"]):SetAttribute("addchild", actionButton);
			
		if (not frame.headers[activeHeader]["list"][showstate] or frame.headers[activeHeader]["list"][showstate] == "") then
			frame.headers[activeHeader]["list"][showstate] = ","..actionButton:GetID()..",";
		else
			frame.headers[activeHeader]["list"][showstate] = frame.headers[activeHeader]["list"][showstate]..actionButton:GetID()..","
		end			

		if (frame.config["btnType"] == "TrinityActionButton") then
			TrinityStorageHeader.data["buttonIndex"][newButton] = 0;			
			TrinityStorageHeader.data["buttonCount"] = TrinityStorageHeader.data["buttonCount"] - 1;			
		elseif (frame.config["btnType"] == "TrinityAnchorButton") then
			TrinityStorageHeader.data["anchorIndex"][newButton] = 0;			
			TrinityStorageHeader.data["anchorCount"] = TrinityStorageHeader.data["anchorCount"] - 1;			
		end
		
		TrinitySwapTextures(frame)
			
		return;	
	end
	
	UIErrorsFrame:AddMessage("All buttons are being used, no available buttons found.\nRemove buttons from one bar to add to another.", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
end

-- Function to remove a button from a docking frame.
function TrinitySubtractButtons(frame, all)

	TrinityFunctionCounter("TrinitySubtractButtons")

	local activeHeader, showstate, buttonList, buttonCount, foundActive = TrinityGetCurrHeaderShowstate(frame)	
	local count = 1;
	
	frame.elapsed = 0;	
	
	if (buttonCount < 1) then
		return;
	end
	
	if (all) then
		count = buttonCount;
	end
	
	for i=1,count do	
	
		if (frame:GetID() == TrinityMiscBars["menu"]) then
			if (not all) then
				actionButton = getglobal(frame.config["btnType"]..buttonList[TrinityDockFrameEditorLeftMenuHighlight.index]);
			else
				actionButton = getglobal(frame.config["btnType"]..buttonList[getn(buttonList)]);
			end
		else
			actionButton = getglobal(frame.config["btnType"]..buttonList[getn(buttonList)]);
		end
		
		actionButton:ClearAllPoints();
		actionButton:SetClampedToScreen(false)
		actionButton:SetPoint("CENTER", "TrinityStorageHeader", "CENTER");
		
		actionButton.config["dock"] = 0;
		actionButton.config["dockpos"] = 0;
		actionButton.config["showstate"] = "STORED";
		actionButton.config["header"] = "TrinityStorageHeader";
		actionButton:SetAttribute("showstates", "STORED");		
		TrinityStorageHeader:SetAttribute("addchild", actionButton);		

		if (frame:GetID() == TrinityMiscBars["menu"]) then
			if (not all) then
				frame.headers[activeHeader]["list"][showstate] = string.gsub(frame.headers[activeHeader]["list"][showstate], "(%D)"..buttonList[TrinityDockFrameEditorLeftMenuHighlight.index]..",", "%1")						
				if (frame.config["btnType"] == "TrinityActionButton") then
					TrinityStorageHeader.data["buttonIndex"][tonumber(buttonList[TrinityDockFrameEditorLeftMenuHighlight.index])] = 1;
					TrinityStorageHeader.data["buttonCount"] = TrinityStorageHeader.data["buttonCount"] + 1;
				elseif (frame.config["btnType"] == "TrinityAnchorButton") then
					TrinityStorageHeader.data["anchorIndex"][tonumber(buttonList[TrinityDockFrameEditorLeftMenuHighlight.index])] = 1;
					TrinityStorageHeader.data["anchorCount"] = TrinityStorageHeader.data["anchorCount"] + 1;
				end
			
				buttonList[TrinityDockFrameEditorLeftMenuHighlight.index] = nil;			
			else
			
				frame.headers[activeHeader]["list"][showstate] = string.gsub(frame.headers[activeHeader]["list"][showstate], "(%D)"..buttonList[getn(buttonList)]..",", "%1")						
				if (frame.config["btnType"] == "TrinityActionButton") then
					TrinityStorageHeader.data["buttonIndex"][tonumber(buttonList[getn(buttonList)])] = 1;
					TrinityStorageHeader.data["buttonCount"] = TrinityStorageHeader.data["buttonCount"] + 1;
				elseif (frame.config["btnType"] == "TrinityAnchorButton") then
					TrinityStorageHeader.data["anchorIndex"][tonumber(buttonList[getn(buttonList)])] = 1;
					TrinityStorageHeader.data["anchorCount"] = TrinityStorageHeader.data["anchorCount"] + 1;
				end
			
				buttonList[getn(buttonList)] = nil;			
			end			
		else
			frame.headers[activeHeader]["list"][showstate] = string.gsub(frame.headers[activeHeader]["list"][showstate], "(%D)"..buttonList[getn(buttonList)]..",", "%1")						
			if (frame.config["btnType"] == "TrinityActionButton") then
				TrinityStorageHeader.data["buttonIndex"][tonumber(buttonList[getn(buttonList)])] = 1;
				TrinityStorageHeader.data["buttonCount"] = TrinityStorageHeader.data["buttonCount"] + 1;
			elseif (frame.config["btnType"] == "TrinityAnchorButton") then
				TrinityStorageHeader.data["anchorIndex"][tonumber(buttonList[getn(buttonList)])] = 1;
				TrinityStorageHeader.data["anchorCount"] = TrinityStorageHeader.data["anchorCount"] + 1;
			end
			
			buttonList[getn(buttonList)] = nil;
		end		
	end	
end

function TrinityMenuHighlightRight()

	TrinityFunctionCounter("TrinityMenuHighlightRight")

	local _, _, buttonList, _, _ = TrinityGetCurrHeaderShowstate(this:GetParent():GetParent())
	TrinityDockFrameEditorLeftMenuHighlight.index = TrinityDockFrameEditorLeftMenuHighlight.index + 1
	if (TrinityDockFrameEditorLeftMenuHighlight.index > getn(buttonList)) then
		TrinityDockFrameEditorLeftMenuHighlight.index = 1
	end
	TrinityDockFrameEditorLeftMenuHighlight:SetPoint("CENTER", getglobal("TrinityAnchorButton"..buttonList[TrinityDockFrameEditorLeftMenuHighlight.index]), "CENTER",0,7);	
end

function TrinityMenuHighlightLeft()

	TrinityFunctionCounter("TrinityMenuHighlightLeft")

	local _, _, buttonList, _, _ = TrinityGetCurrHeaderShowstate(this:GetParent():GetParent())
	TrinityDockFrameEditorLeftMenuHighlight.index = TrinityDockFrameEditorLeftMenuHighlight.index - 1
	if (TrinityDockFrameEditorLeftMenuHighlight.index < 1) then
		TrinityDockFrameEditorLeftMenuHighlight.index = getn(buttonList);
	end
	TrinityDockFrameEditorLeftMenuHighlight:SetPoint("CENTER", getglobal("TrinityAnchorButton"..buttonList[TrinityDockFrameEditorLeftMenuHighlight.index]), "CENTER",0,7);
end

function TrinityAddOnUpdate(anchor, frame, elapsed)	

	TrinityFunctionCounter("TrinityAddOnUpdate")

	this.elapsed = this.elapsed + elapsed;
	frame.count = frame.count + elapsed
	if (frame.count > 10) then
		frame.count = 10
	end	

	if (MouseIsOver(this)) then
		TrinityActionButton_SetTooltip()			
		GameTooltip:SetText("LeftClick to increase bar width\nRightClick to increase bar height", 1.0, 1.0, 1.0);
		GameTooltip:Show();
	end
	if ( this:GetButtonState() == "PUSHED" and this.elapsed > 0.15) then
		if (this.click == "RightButton") then
			TrinityStatusBarHeight(anchor, frame, "add")
		else
			TrinityStatusBarWidth(anchor, frame, "add")
		end
		TrinityUpdateDocking(frame);
		this.elapsed = 0;
		PlaySound("UChatScrollButton");
	end
end

function TrinitySubtractOnUpdate(anchor, frame, elapsed)

	TrinityFunctionCounter("TrinitySubtractOnUpdate")

	this.elapsed = this.elapsed + elapsed;
	frame.count = frame.count + elapsed
	if (frame.count > 10) then
		frame.count = 10
	end

	if (MouseIsOver(this)) then
		TrinityActionButton_SetTooltip()			
		GameTooltip:SetText("LeftClick to decrease bar width\nRightClick to decrease bar height", 1.0, 1.0, 1.0);
		GameTooltip:Show();
	end
	if ( this:GetButtonState() == "PUSHED" and this.elapsed > 0.15) then			
		if (this.click == "RightButton") then
			TrinityStatusBarHeight(anchor, frame, "subtract")
		else
			TrinityStatusBarWidth(anchor, frame, "subtract")
		end
		TrinityUpdateDocking(frame);
		this.elapsed = 0;
		PlaySound("UChatScrollButton");
	end
end

function TrinityToggleBags(dockFrame)

	TrinityFunctionCounter("TrinityToggleBags")

	for i=1,4 do
		anchorButton = getglobal("TrinityAnchorButton"..i);		
		if (anchorButton.config["showstate"] == "STORED") then		
			anchorButton.config["dock"] = dockFrame:GetID();
			anchorButton.config["showstate"] = 0;
			anchorButton:SetAttribute("showstates", "0");			
			anchorButton.config["header"] = dockFrame.headers["Normal"]["name"];
			getglobal(dockFrame.headers["Normal"]["name"]):SetAttribute("addchild", anchorButton);			
			if (not dockFrame.headers["Normal"]["list"][0] or dockFrame.headers["Normal"]["list"][0] == "") then
				dockFrame.headers["Normal"]["list"][0] = ","..anchorButton:GetID()..",";
			else
				dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0]..anchorButton:GetID()..","
			end			
			dockFrame.headers["Normal"]["list"][0] = string.gsub(dockFrame.headers["Normal"]["list"][0], "(%D)".."5,", "%1")
			dockFrame.headers["Normal"]["list"][0] = dockFrame.headers["Normal"]["list"][0].."5,"
			TrinityStorageHeader.data["anchorIndex"][i] = 0;			
			TrinityStorageHeader.data["anchorCount"] = TrinityStorageHeader.data["anchorCount"] - 1;
			MainMenuBarBackpackButton:SetScript("OnClick", function() if (IsShiftKeyDown()) then OpenAllBags() else ToggleBackpack() end end);
			dockFrame.config["singlebag"] = false;			
			
			TrinitySwapTextures(dockFrame)
		else
			anchorButton:ClearAllPoints();
			anchorButton:SetPoint("CENTER", "TrinityStorageHeader", "CENTER");		
			anchorButton.config["dock"] = 0;
			anchorButton.config["dockpos"] = 0;
			anchorButton.config["showstate"] = "STORED";
			anchorButton.config["header"] = "TrinityStorageHeader";
			anchorButton:SetAttribute("showstates", "STORED");		
			TrinityStorageHeader:SetAttribute("addchild", anchorButton);
			dockFrame.headers["Normal"]["list"][0] = string.gsub(dockFrame.headers["Normal"]["list"][0], "(%D)"..i..",", "%1")						
			TrinityStorageHeader.data["anchorIndex"][i] = 1;
			TrinityStorageHeader.data["anchorCount"] = TrinityStorageHeader.data["anchorCount"] + 1;		
			MainMenuBarBackpackButton:SetScript("OnClick", function() OpenAllBags() end);
			dockFrame.config["singlebag"] = true;
		end
	end
	
	TrinityUpdateDocking(dockFrame);
end

function TrinityHideShowStatusBars(button, dockFrame)

	TrinityFunctionCounter("TrinityHideShowStatusBars")

	if (button.config["showstate"] == "STORED") then
		TrinityAddButton(dockFrame)
		if (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			TrinityCastingBarDummy:Show();
		end
	else
		TrinitySubtractButtons(dockFrame, nil)		
		if (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			TrinityCastingBarDummy:Hide();
		end			
	end
	
	TrinityUpdateDocking(dockFrame);
end

function TrinityStatusBarWidth(anchor, frame, dir)

	TrinityFunctionCounter("TrinityStatusBarWidth")

	frame.elapsed = 0;
	
	local increase = math.ceil(frame.count);	
	
	if (frame.config["shape"] == 0) then
		
		if (dir == "add") then
		
			anchor:SetWidth(anchor:GetWidth()+increase)
		
		else
			if (anchor:GetWidth()-increase > 10) then
				anchor:SetWidth(anchor:GetWidth()-increase)		
			else
				anchor:SetWidth(10)		
			end	
		end		
		
		frame.config["anchorwidth"] = anchor:GetWidth();
		frame.config["anchorheight"] = anchor:GetHeight();
		
	elseif (frame.config["shape"] == 1) then
		
		if (dir == "add") then
		
			anchor:SetHeight(anchor:GetHeight()+increase)

		else
			if (anchor:GetHeight()-increase > 10) then
				anchor:SetHeight(anchor:GetHeight()-increase)
			else
				anchor:SetHeight(10)
			end
		end
		
		frame.config["anchorwidth"] = anchor:GetWidth();
		frame.config["anchorheight"] = anchor:GetHeight();
	end
	
	anchor:SetHitRectInsets(anchor:GetWidth()/2, anchor:GetWidth()/2, anchor:GetHeight()/2, anchor:GetHeight()/2) 
end

function TrinityStatusBarHeight(anchor, frame, dir)
	
	TrinityFunctionCounter("TrinityStatusBarHeight")

	frame.elapsed = 0;
	
	local increase = math.ceil(frame.count);
	
	if (frame.config["shape"] == 0) then
		
		if (dir == "add") then
		
			anchor:SetHeight(anchor:GetHeight()+increase)
		
		else
			if (anchor:GetHeight()-increase > 5) then
				anchor:SetHeight(anchor:GetHeight()-increase)		
			else
				anchor:SetHeight(5)		
			end	
		end
		
		frame.config["anchorwidth"] = anchor:GetWidth();
		frame.config["anchorheight"] = anchor:GetHeight();
		
	elseif (frame.config["shape"] == 1) then
		
		if (dir == "add") then
		
			anchor:SetWidth(anchor:GetWidth()+increase)

		else
			if (anchor:GetWidth()-increase > 5) then
				anchor:SetWidth(anchor:GetWidth()-increase)
			else
				anchor:SetWidth(5)
			end
		end
		
		frame.config["anchorwidth"] = anchor:GetWidth();
		frame.config["anchorheight"] = anchor:GetHeight();
	end
	
	anchor:SetHitRectInsets(anchor:GetWidth()/2, anchor:GetWidth()/2, anchor:GetHeight()/2, anchor:GetHeight()/2) 
end

function TrinityCastingBarSetTextures(orient)

	TrinityFunctionCounter("TrinityCastingBarSetTextures")

	local castBar = TrinityCastingBar:GetName()				

	if (orient == "HORIZONTAL") then

		getglobal(castBar):SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
		TrinityCastingBarDummy:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")				
		getglobal(castBar .. "Spark"):SetHeight(32);
		getglobal(castBar .. "Text"):SetFont("Fonts\\FRIZQT__.TTF", 12);
		
		getglobal(castBar .. "Text"):SetPoint("TOPLEFT", -8, 2);
		getglobal(castBar .. "Text"):SetPoint("BOTTOMRIGHT", 8, -2);		
	end
	
	if (orient == "VERTICAL") then
		
		getglobal(castBar):SetStatusBarTexture("Interface\\AddOns\\TrinityBars\\Images\\BarFill2V")
		TrinityCastingBarDummy:SetStatusBarTexture("Interface\\AddOns\\TrinityBars\\Images\\BarFill2V")
		getglobal(castBar .. "Spark"):SetHeight(10);
		getglobal(castBar .. "Text"):SetFont("Fonts\\ARIALN.TTF", 12);
		
		getglobal(castBar .. "Text"):SetPoint("TOPLEFT", -2, 8);
		getglobal(castBar .. "Text"):SetPoint("BOTTOMRIGHT", 2, -8);				
	end
end


function TrinityCastingBarOrientation(dockFrame)

	TrinityFunctionCounter("TrinityCastingBarOrientation")

	local castBar = TrinityCastingBar:GetName()				
	local width, height;		

	if (dockFrame.config["anchorwidth"] == 0 or not dockFrame.config["anchorwidth"]) then
		width = TrinityCastingBar:GetParent():GetWidth()
	else
		width = dockFrame.config["anchorwidth"];
	end
	
	if (dockFrame.config["anchorheight"] == 0 or not dockFrame.config["anchorheight"]) then
		height = TrinityCastingBar:GetParent():GetHeight()	 
	else
		height = dockFrame.config["anchorheight"];
	end
	 
	if ( (mod(dockFrame.config["shape"],2) == 0 and dockFrame.config["orientation"] == "VERTICAL")) then 				
	
		getglobal(castBar):SetOrientation("HORIZONTAL");
		TrinityCastingBarDummy:SetOrientation("HORIZONTAL");
		TrinityCastingBarSetTextures("HORIZONTAL");
		
		TrinityCastingBar:GetParent():SetWidth(height)	
		TrinityCastingBar:GetParent():SetHeight(width/0.8)
		
		dockFrame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		dockFrame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
		dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation() 
		dockFrame.config["shape"] = 0;
	end
		
	if ((mod(dockFrame.config["shape"],2) ~= 0 and dockFrame.config["orientation"] == "HORIZONTAL")) then
		
		getglobal(castBar):SetOrientation("VERTICAL");
		TrinityCastingBarDummy:SetOrientation("VERTICAL");
		TrinityCastingBarSetTextures("VERTICAL");
		
		TrinityCastingBar:GetParent():SetWidth(height*0.8)
		TrinityCastingBar:GetParent():SetHeight(width)

		dockFrame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		dockFrame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();	
		dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation() 
		dockFrame.config["shape"] = 1;
	end	
end

function TrinityXPBarSetTextures(orient)

	TrinityFunctionCounter("TrinityXPBarSetTextures")

	if (orient == "HORIZONTAL") then
		TrinityXPFrameBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	end
	
	if (orient == "VERTICAL") then		
		TrinityXPFrameBar:SetStatusBarTexture("Interface\\AddOns\\TrinityBars\\Images\\BarFill2V")
	end
end


function TrinityXPBarOrientation(dockFrame)

	TrinityFunctionCounter("TrinityXPBarOrientation")

	local xpBar = TrinityXPFrame:GetName()				
	local width, height;		

	if (dockFrame.config["anchorwidth"] == 0 or not dockFrame.config["anchorwidth"]) then
		width = TrinityXPFrame:GetParent():GetWidth()
	else
		width = dockFrame.config["anchorwidth"];
	end
	
	if (dockFrame.config["anchorheight"] == 0 or not dockFrame.config["anchorheight"]) then
		height = TrinityXPFrame:GetParent():GetHeight()	 
	else
		height = dockFrame.config["anchorheight"];
	end
	 
	if ( (mod(dockFrame.config["shape"],2) == 0 and dockFrame.config["orientation"] == "VERTICAL")) then 				
	
		TrinityXPFrameBar:SetOrientation("HORIZONTAL");		
		TrinityXPBarSetTextures("HORIZONTAL");
		
		TrinityXPFrame:GetParent():SetWidth(height)	
		TrinityXPFrame:GetParent():SetHeight(width/0.8)
		
		dockFrame.config["anchorwidth"] = TrinityXPFrame:GetParent():GetWidth();
		dockFrame.config["anchorheight"] = TrinityXPFrame:GetParent():GetHeight();
		dockFrame.config["orientation"] = TrinityXPFrameBar:GetOrientation() 
		dockFrame.config["shape"] = 0;
	end
		
	if ((mod(dockFrame.config["shape"],2) ~= 0 and dockFrame.config["orientation"] == "HORIZONTAL")) then
		
		TrinityXPFrameBar:SetOrientation("VERTICAL");
		TrinityXPBarSetTextures("VERTICAL");
		
		TrinityXPFrame:GetParent():SetWidth(height*0.8)
		TrinityXPFrame:GetParent():SetHeight(width)

		dockFrame.config["anchorwidth"] = TrinityXPFrame:GetParent():GetWidth();
		dockFrame.config["anchorheight"] = TrinityXPFrame:GetParent():GetHeight();	
		dockFrame.config["orientation"] = TrinityXPFrameBar:GetOrientation() 
		dockFrame.config["shape"] = 1;
	end	
end

-- A function to hide/show buttons on mouseover
function TrinityGhostUpdate(dockFrame)	

	TrinityFunctionCounter("TrinityGhostUpdate")
	
	if (MouseIsOver(dockFrame) and dockFrame.config["vis"] == 0 and dockFrame.config["hide"] == 0) then				
		getglobal(dockFrame.headers["Normal"]["name"]):SetAlpha(dockFrame.config["alpha"]);						
		dockFrame.config["vis"] = 1;		
	end
	
	if (not MouseIsOver(dockFrame) and dockFrame.config["vis"] == 1) then		
		getglobal(dockFrame.headers["Normal"]["name"]):SetAlpha(0);		
		dockFrame.config["vis"] = 0;		
	end
end		

function TrinityMinimapOptionsOnLoad()

	TrinityFunctionCounter("TrinityMinimapOptionsOnLoad")

	local angle = 90;
	
	for i=1,7 do
	
		local buttonOption = getglobal("TrinityBarsMinimapButtonOption"..i);	
		buttonOption:SetScale(0.8)
		
		if (i==1) then
			buttonOption:SetParent("TrinityBarsControl");
			buttonOption:SetScript("OnClick", function() TrinityMinimapOptions1() end);			
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Click to toggle Configuration Mode\nShift-Click to show/hide button tooltips") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\config.tga");						
			if (TrinityDockBarsHide == true) then
				getglobal(buttonOption:GetName().."Icon"):SetVertexColor(0.75,0.75,0.75);
			else
				getglobal(buttonOption:GetName().."Icon"):SetVertexColor(1,1,1);
			end
			getglobal(buttonOption:GetName().."Icon"):SetPoint("TOPLEFT", 7,-6)
			getglobal(buttonOption:GetName().."Icon"):SetPoint("BOTTOMRIGHT", -7,8)			
		end								
		
		if (i==2) then
			buttonOption:SetParent("TrinityBarsControl");
			buttonOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions2(buttonOption) end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("LeftClick to Lock/Unlock Action Buttons\nRightClick to toggle shift-dragging actions.") end);			
			if (TrinityButtonLock == true) then
				getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\locked2.tga");			
			else
				getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\unlocked3.tga");
			end
			getglobal(buttonOption:GetName().."Icon"):SetPoint("TOPLEFT", 5,-6)
			getglobal(buttonOption:GetName().."Icon"):SetPoint("BOTTOMRIGHT", -5,7)
		end
		
		if (i==3) then
			buttonOption:SetParent("TrinityBarsControl");
			buttonOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions3(buttonOption) end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("LeftClick to cycle through button styles\nRightClick to enable/disbale cooldown counter") end);			
		end
		
		if (i==4) then
			TrinityOption4SubMenu = false;
			buttonOption.index = 1;
			buttonOption:SetParent("TrinityBarsControl");
			buttonOption:SetScript("OnClick", function() TrinityMinimapOptions4(buttonOption) end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Load/Save Templates") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
			getglobal(buttonOption:GetName().."Icon"):SetVertexColor(0,0,0);					
			for j=1,4 do	
				local subOption = getglobal(buttonOption:GetName().."Sub"..j);	
				if (j==1) then
					getglobal(subOption:GetName().."Border"):SetTexture("");
					getglobal(subOption:GetName().."Icon"):SetTexture("");
					subOption:SetParent("TrinityBarsControl")
				end
				if (j==2) then
					subOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions4Sub2(buttonOption) end);			
					subOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Load the Template indicated below") end);
					getglobal(subOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
					getglobal(subOption:GetName().."Icon"):SetVertexColor(0,0,0);					
					subOption:SetParent("TrinityBarsControl")
					
						getglobal(subOption:GetName().."Sub1"):SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions4Sub2Sub1(buttonOption) end);			
						getglobal(subOption:GetName().."Sub1"):SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Save current setup as a Template\nEdit line above to name it.") end);
						getglobal(subOption:GetName().."Sub1Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
						getglobal(subOption:GetName().."Sub1Icon"):SetVertexColor(0,0,0);											
					
				end
				if (j==3) then					
					getglobal(subOption:GetName().."Border"):SetTexture("");
					getglobal(subOption:GetName().."Icon"):SetTexture("");
					subOption:SetParent("TrinityBarsControl")
				end		
				if (j==4) then
					subOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions4Sub4(buttonOption) end);			
					subOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Next Template") end);
					subOption:SetParent("TrinityBarsControl")
					
						getglobal(subOption:GetName().."Sub1"):SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions4Sub4Sub1(buttonOption) end);			
						getglobal(subOption:GetName().."Sub1"):SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Previous Template") end);						
				end										
			end			
		end

		if (i==5) then
			TrinityOption5SubMenu = false;
			buttonOption:SetParent("TrinityBarsControl");
			buttonOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions5(this) end);			
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Dock Frame Options") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
			getglobal(buttonOption:GetName().."Icon"):SetVertexColor(0,0,0);
			buttonOption.dockID = 1;			
			for j=1,6 do	
				local subOption = getglobal(buttonOption:GetName().."Sub"..j);	
				if (j==1) then
					subOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions5Sub1(buttonOption) end);			
					subOption:SetScript("OnUpdate", function() this.dockID = buttonOption.dockID TrinityMinimapOptionsOnUpdate("Left/Right-Click to cycle forward/back through dock frames") end);
					subOption:CreateFontString("$parentDockID", "ARTWORK", "GameFontNormal");
					getglobal(subOption:GetName().."DockID"):SetText(buttonOption.dockID);
					getglobal(subOption:GetName().."DockID"):SetPoint("CENTER",-1,2);					
					getglobal(subOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
					getglobal(subOption:GetName().."Icon"):SetVertexColor(0,0,0);
					subOption:SetParent("TrinityBarsControl")
				end
				if (j==2) then
					subOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions5Sub2(buttonOption) end);			
					subOption:SetScript("OnUpdate", function() this.dockID = buttonOption.dockID TrinityMinimapOptionsOnUpdate("Click to store/restore all docks") end);
					getglobal(subOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
					getglobal(subOption:GetName().."Icon"):SetVertexColor(0,0,0);					
					subOption:SetParent("TrinityBarsControl")
				end
				if (j==3) then
					subOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions5Sub3(this) end);			
					subOption:SetScript("OnUpdate", function() this.dockID = buttonOption.dockID TrinityMinimapOptionsOnUpdate("Left-Click to store the selected dock\nRight-Click to store the selected dock's buttons") end);
					getglobal(subOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
					getglobal(subOption:GetName().."Icon"):SetVertexColor(0,0,0);					
					subOption:SetParent("TrinityBarsControl")
				end		
				if (j==4) then
					subOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions5Sub4(buttonOption) end);			
					subOption:SetScript("OnUpdate", function() this.dockID = buttonOption.dockID TrinityMinimapOptionsOnUpdate("Click to delete the currently selected dock") end);
					getglobal(subOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
					getglobal(subOption:GetName().."Icon"):SetVertexColor(0,0,0);					
					subOption:SetParent("TrinityBarsControl")
				end						
				if (j==5) then
					subOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions5Sub5(buttonOption) end);			
					subOption:SetScript("OnUpdate", function() this.dockID = buttonOption.dockID TrinityMinimapOptionsOnUpdate("Click to create an additional dock") end);
					getglobal(subOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
					getglobal(subOption:GetName().."Icon"):SetVertexColor(0,0,0);					
					subOption:SetParent("TrinityBarsControl")
				end		
				if (j==6) then
					subOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions5Sub6(buttonOption) end);			
					subOption:SetScript("OnUpdate", function() this.dockID = buttonOption.dockID TrinityMinimapOptionsOnUpdate("Click to reset dock") end);
					getglobal(subOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\docks.tga");
					getglobal(subOption:GetName().."Icon"):SetVertexColor(0,0,0);					
					subOption:SetParent("TrinityBarsControl")
				end						
			end
		end
		
		if (i==6) then
			buttonOption:SetParent("TrinityBarsControl");
			buttonOption:SetScript("OnClick", function() if (IsShiftKeyDown()) then if (TrinityKeyBindingTextHidden == true) then TrinityKeyBindingTextHidden = false else TrinityKeyBindingTextHidden = true end TrinityHideKeyBindings() else TrinityMinimapOptions6() end end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Click to enable/disable key binding mode\nShift-Click to hide key bindings") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\keybindoff.tga");									
		end
		
		if (i==7) then
			buttonOption.option = "None";
			buttonOption.unitsets = {}			
			buttonOption.unitindex = 1;
			local count = 1;
			for k,v in pairs(TrinityUnitFrameSets) do
				buttonOption.unitsets[count] = k
				if (k == TrinityUnitSet) then
					buttonOption.unitindex = count;
				end
				count = count + 1;
			end					
			buttonOption:SetParent("TrinityBarsControl");
			buttonOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions7(buttonOption) end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Left/RightClick to cycle through self-cast options\nShift-Click to cycle through UnitFrame options") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Icons\\Spell_Arcane_ArcanePotency.blp");			
		end		
	end
end

function TrinityMenuOptionTransition(button, count)

	TrinityFunctionCounter("TrinityMenuOptionTransition")
	
	this.angle = 90;
	
	if (this.count > 1) then
		this.count = this.count - 1;
	end			
	
	this.transition = this.transition - this.count;
	if (this.transition < count) then
		this.transition = count
	end	

	for i=1,count do
		local buttonOption = getglobal(button..i);	
		local x = ((buttonOption:GetWidth()/.8)*.85)*(cos(this.angle));
		local y = ((buttonOption:GetWidth()/.8)*.85)*(sin(this.angle));
		buttonOption:SetScale(0.8)
		buttonOption:SetPoint("CENTER", TrinityBarsGlobalMenuAnchor, "CENTER", x, y);
		this.angle = this.angle - (360/this.transition);
	end
	
	if (this.transition <= count) then
		TrinityOpenOptionsMenu = false;
		TrinityOption4SubMenu = false;		
		TrinityOption5SubMenu = false;
	end
end

function TrinityMinimapOptionsOnClick()

	TrinityFunctionCounter("TrinityMinimapOptionsOnClick")

	if (this:GetName() == "TrinityBarsMinimapButton") then
		if (TrinityBarsGlobalMenuAnchor:IsVisible()) then
			TrinityBarsGlobalMenuAnchor:Hide();
		else
			TrinityBarsGlobalMenuAnchor:Show();
		end
	end	

	if (IsAltKeyDown() and IsControlKeyDown() and IsShiftKeyDown()) then
		if (InCombatLockdown()) then
			UIErrorsFrame:AddMessage("In Combat Lockdown", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			return;
		end
		TrinityButtonStyle = 1;
		TrinitySetSelfCast(1);

		TrinityDockBarsHide = false;
		TrinityButtonsHide = false;
		TrinityButtonLock = false;
		TrinityKeyBindingTextHidden = false;
		TrinityShowButtonTooltips = true;
		TrinityDocksStored = false;
		
		TrinityBarsGlobalMenuAnchor:ClearAllPoints();
		TrinityBarsGlobalMenuAnchor:SetPoint("CENTER", "TrinityBarsMinimapButton", "CENTER")
		TrinityBarsGlobalMenuAnchor:SetUserPlaced(false);
		TrinityBarsGlobalMenuAnchor.drag = false;		
		TrinityUpdateDockPostions(true);
		for k,v in pairs(TrinityDockFrames) do
			local dockFrame = getglobal("TrinityDockFrame"..k);
			dockFrame.config["scale"] = 1;
			dockFrame.config["alpha"] = 1;
			dockFrame.config["shape"] = 0;
			dockFrame.config["ghost"] = nil;
			TrinityDockFrameEditorRightGhost:SetChecked(dockFrame.config["ghost"]);
			dockFrame.config["showgrid"] = nil;
			dockFrame.config["buttonSpaceH"] = 3;
			dockFrame.config["buttonSpaceV"] = 3;
			dockFrame.config["style"] = 1;
			dockFrame.config["target"] = "none";
			dockFrame.config["stored"] = false;
			dockFrame.config["storedbuttons"] = false;
			dockFrame:SetUserPlaced(false);
			dockFrame:ClearAllPoints();			
			dockFrame:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
			dockFrame:SetUserPlaced(true);

			if (dockFrame:GetID()==TrinityMiscBars["cast"]) then
				dockFrame.config["orientation"] = "VERTICAL";
				dockFrame.config["anchorwidth"] = 12;
				dockFrame.config["anchorheight"] = 195;
				TrinityCastingBarOrientation(dockFrame)
			elseif (dockFrame:GetID()==TrinityMiscBars["XP"]) then	
				dockFrame.config["orientation"] = "VERTICAL";
				dockFrame.config["anchorwidth"] = 8;
				dockFrame.config["anchorheight"] = 135;
				TrinityXPBarOrientation(dockFrame)
			end		
			TrinityUpdateDocking(dockFrame);
		end
		TrinityUpdateDockPostions(true);
		TrinityUpdateBindings();
		TrinityRefreshHeaders();
		return;
	end
	
	if (IsShiftKeyDown()) then
		
		if (TrinityGlobalTooltipEnabled) then
			TrinityGlobalTooltipEnabled = false;
		else
			TrinityGlobalTooltipEnabled = true;
		end
		
		return;
	end
	
	TrinityBarsControl.transition = 75;
	TrinityBarsControl.count = 14;	
	
	if (TrinityBarsMinimapButtonOption5Sub1:IsVisible()) then
		TrinityBarsMinimapButtonOption5Sub1:Hide()
		TrinityBarsMinimapButtonOption5Sub2:Hide()
		TrinityBarsMinimapButtonOption5Sub3:Hide()
		TrinityBarsMinimapButtonOption5Sub4:Hide()
		TrinityBarsMinimapButtonOption5Sub5:Hide()
		TrinityBarsMinimapButtonOption5Sub6:Hide()
	elseif (TrinityBarsMinimapButtonOption4Sub1:IsVisible()) then
		TrinityBarsMinimapButtonOption4Sub1:Hide()
		TrinityBarsMinimapButtonOption4Sub2:Hide()
		TrinityBarsMinimapButtonOption4Sub3:Hide()
		TrinityBarsMinimapButtonOption4Sub4:Hide()	
	else	
		for i=1,7 do	
			local buttonOption = getglobal("TrinityBarsMinimapButtonOption"..i);	
			if (buttonOption:IsVisible()) then
				buttonOption:Hide();
				TrinityOpenOptionsMenu = false;	
			else
				if (TrinityBarsGlobalMenuAnchor:IsVisible()) then
					buttonOption:Show()
					TrinityOpenOptionsMenu = true;
					TrinityBarsMinimapButton.count = 15;
				end
			end
		end
	end	

end

function TrinityGlobalMenuCheck(frame)

	TrinityFunctionCounter("TrinityGlobalMenuCheck")

	local x1,y1 = TrinityBarsMinimapButton:GetCenter()
	local x2,y2 = frame:GetCenter()
	local width = frame:GetWidth()/2
	
	if (x1 and x2 and y1 and y2 and width) then
		if (x2 > x1-width and x2 < x1+width and y2 > y1-width and y2 < y1+width) then
			if (not IsShiftKeyDown()) then
				frame:StopMovingOrSizing();		
				frame:ClearAllPoints();
				frame:SetPoint("CENTER", "TrinityBarsMinimapButton", "CENTER")
				-- LedMirage 1/04/2007 fix for negative frame level start
				if (TrinityBarsMinimapButton:GetFrameLevel() > 1 ) then
					frame:SetFrameLevel(TrinityBarsMinimapButton:GetFrameLevel()-1)
				else
					frame:SetFrameLevel(0);
				end	
				-- LedMirage 1/04/2007 fix for negative frame level end				
				frame:SetUserPlaced(false);
				frame.drag = false;
			end
		else
			if (frame.drag) then
				TrinityBarsMinimapButton:Show();
			else
				TrinityBarsMinimapButton:Hide()
			end
		end
	end
end

function TrinityMinimapOptionsOnEnter(text)

	TrinityFunctionCounter("TrinityMinimapOptionsOnEnter")

	TrinityActionButton_SetTooltip()			
	GameTooltip:SetText(text, 1.0, 1.0, 1.0);
	GameTooltip:Show();
end

function TrinityMinimapOptionsOnUpdate(text)

	TrinityFunctionCounter("TrinityMinimapOptionsOnUpdate")

	if (MouseIsOver(this)) then
		TrinityActionButton_SetTooltip()			
		GameTooltip:SetText(text, 1.0, 1.0, 1.0);
		
		if (this:GetID() == 1) then
			if (TrinityDockBarsHide) then
				GameTooltip:AddLine("Configuration mode is |cff00ff00OFF|r");
			else
				GameTooltip:AddLine("Configuration mode is |cfff00000ON|r");
			end
			
			if(TrinityShowButtonTooltips) then
				GameTooltip:AddLine("Action button tooltips are |cff00ff00ENABLED|r");
			else
				GameTooltip:AddLine("Action button tooltips are |cfff00000DISABLED|r");
			end			
		end		

		if (this:GetID() == 2) then
			if (TrinityButtonLock) then
				GameTooltip:AddLine("Action buttons are currently |cff00ff00LOCKED|r");
			else
				GameTooltip:AddLine("Action buttons are currently |cfff00000UNLOCKED|r");
			end
			
			if (TrinityShiftButtonLock) then
				GameTooltip:AddLine("Actions may be removed with shift-drag |cff00ff00ENABLED|r");
			else
				GameTooltip:AddLine("Actions may be removed with shift-drag |cfff00000DISABLED|r");
			end			
			
		end
		
		if (this:GetID() == 3) then
			if (TrinityButtonStyle == 1) then
				GameTooltip:AddLine("Current global button style is |cff00ff00SQUARE|r");		
			elseif (TrinityButtonStyle == 2) then
				GameTooltip:AddLine("Current global button style is |cff00ff00ROUND|r");		
			elseif (TrinityButtonStyle == 3) then
				GameTooltip:AddLine("Current global button style is |cff00ff00SQUARE-TRIMMED|r");		
			elseif (TrinityButtonStyle == 4) then
				GameTooltip:AddLine("Current global button style is |cff00ff00DIAMOND|r");		
			end
			if (TrinityCoolDown) then
				GameTooltip:AddLine("Cooldown Counter is |cff00ff00ENABLED|r");
			else
				GameTooltip:AddLine("Cooldown Counter is |cfff00000DISABLED|r");
			end
		end
		
		if (this:GetID() == 4) then

		end		
		
		if (this:GetID() == 53) then
		
			local dockID = this.dockID;
			
			if (dockID == TrinityMiscBars["bags"]) then		
				dockID = "Bags"
			elseif (dockID == TrinityMiscBars["menu"]) then
				dockID = "MenuBar"
			elseif (dockID == TrinityMiscBars["pet"]) then
				dockID = "PetBar"
			elseif (dockID == TrinityMiscBars["form"]) then
				dockID = "FormBar"
			elseif (dockID == TrinityMiscBars["cast"]) then
				dockID = "CastBar"
			elseif (dockID == TrinityMiscBars["XP"]) then
				dockID = "XPBar"				
			end							
		
			if (getglobal("TrinityDockFrame"..this.dockID).config["stored"] == true) then
				GameTooltip:AddLine("Dock frame "..dockID.." is |cff00ff00STORED|r");
			end
			if (getglobal("TrinityDockFrame"..this.dockID).config["stored"] == false) then
				GameTooltip:AddLine("Dock frame "..dockID.." is |cfff00000NOT STORED|r");
			end
		end

		if (this:GetID() == 6) then
			if (TrinityKeyBinder:IsVisible()) then
				GameTooltip:AddLine("Key binding mode is |cfff00000ON|r");
			else
				GameTooltip:AddLine("Key binding mode is |cff00ff00OFF|r");
			end
			if (TrinityKeyBindingTextHidden) then
				GameTooltip:AddLine("Key bind text is |cfff00000HIDDEN|r");
			else
				GameTooltip:AddLine("Key bind text is |cff00ff00SHOWN|r");
			end						
		end
		
		if (this:GetID() == 7) then
			GameTooltip:AddLine("Current self-cast option is set to |cff00ff00"..this.option.."|r");
			GameTooltip:AddLine("Current UnitFrame option is set to |cff00ff00"..TrinityUnitSet.."|r");			
		end		
			
		GameTooltip:Show();
	end
end

function TrinityMinimapOptions1()	

	TrinityFunctionCounter("TrinityMinimapOptions1")

	if (InCombatLockdown()) then
		UIErrorsFrame:AddMessage("In Combat Lockdown", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		return;
	end							
	
	if (IsShiftKeyDown()) then
		if (TrinityShowButtonTooltips == true) then
			TrinityShowButtonTooltips = false;
			UIErrorsFrame:AddMessage("Action Button tooltips are disabled", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		else
			TrinityShowButtonTooltips = true;
			UIErrorsFrame:AddMessage("Action Button tooltips are enabled", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		end
		return;
	end		
	
	if (TrinityDockBarsHide) then
		TrinityDockBarsHide = false;								
		TrinityButtonsHide = false;
		getglobal(this:GetName().."Icon"):SetVertexColor(1,1,1);
		if (TrinityTooltipDock) then
			if (not TrinityTooltipDock:IsVisible()) then
				TrinityTooltipDock:Show();
			end
		end								
	else
		TrinityDockBarsHide = true;
		TrinityButtonsHide = true;
		getglobal(this:GetName().."Icon"):SetVertexColor(0.75,0.75,0.75);
		if (TrinityTooltipDock) then
			if (TrinityTooltipDock:IsVisible()) then
				TrinityTooltipDock:Hide();
			end
		end				
	end
	
	PlaySound("igChatScrollDown");
	for k,v in pairs(TrinityDockFrames) do		
		TrinityUpdateDocking(getglobal("TrinityDockFrame"..k));
		getglobal("TrinityDockFrame"..k).config["vis"] = 1;
	end
end

function TrinityMinimapOptions2()

	TrinityFunctionCounter("TrinityMinimapOptions2")

	if (this.click == "RightButton") then
	
		if (TrinityShiftButtonLock) then
			TrinityShiftButtonLock = false;			
			UIErrorsFrame:AddMessage("Actions cannot be removed with shift-drag", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);					
		else
			TrinityShiftButtonLock = true;			
			UIErrorsFrame:AddMessage("Actions may be removed with shift-drag", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);					
		end		
			
	else

		if (TrinityButtonLock) then
			TrinityButtonLock = false;
			LOCK_ACTIONBAR = "0"
			UIErrorsFrame:AddMessage("Buttons are unlocked", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
			getglobal(this:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\unlocked3.tga");
		else
			TrinityButtonLock = true;
			LOCK_ACTIONBAR = "1"
			UIErrorsFrame:AddMessage("Buttons are locked", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
			getglobal(this:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\locked2.tga");
		end
	end
end

function TrinityMinimapOptions3()

	TrinityFunctionCounter("TrinityMinimapOptions3")

	if (this.click == "RightButton") then
		if (TrinityCoolDown) then
			TrinityCoolDown = false;
		else
			TrinityCoolDown = true;
		end
		return;
	end

	if (TrinityButtonStyle == 1) then	
		TrinityButtonStyle = 2;				
	elseif (TrinityButtonStyle == 2) then	
		TrinityButtonStyle = 3;		
	elseif (TrinityButtonStyle == 3) then	
		TrinityButtonStyle = 4;		
	elseif (TrinityButtonStyle == 4) then	
		TrinityButtonStyle = 1;		
	end	
	
	for k,v in pairs(TrinityDockFrames) do	
		local dockFrame = getglobal("TrinityDockFrame"..k);		
		dockFrame.config["style"] = TrinityButtonStyle;
		TrinitySwapTextures(dockFrame);
	end
end

function TrinityMinimapOptions4(button)

	TrinityFunctionCounter("TrinityMinimapOptions4")

	TrinityMinimapOptionsOnClick()
	TrinityBarsControl.transition = 75;
	TrinityBarsControl.count = 14;		
	TrinityOption4SubMenu = true;	
		
	for i=1,4 do				
		local subOption = getglobal(button:GetName().."Sub"..i);	
		subOption:Show()
	end
	
	TrinityMinimapOption4Reset(button)
end

function TrinityMinimapOption4Reset(button)

	TrinityFunctionCounter("TrinityMinimapOption4Reset")

	local count = 1;
	TrinityTemplatesList = {}
	
	for k,_ in pairs(TrinityTemplates) do		
		TrinityTemplatesList[count] = k
		count = count + 1;		
	end
	
	if (TrinityTemplatesList[button.index]) then
		TrinityBarsMinimapButtonOption4Sub3Text1Template:SetText(TrinityTemplatesList[button.index]);		
	else
		TrinityBarsMinimapButtonOption4Sub3Text1Template:SetText("No Templates Available");			
	end			
end

function TrinityMinimapOptions4Sub1(button)

	TrinityFunctionCounter("TrinityMinimapOptions4Sub1")

end

function TrinityMinimapOptions4Sub2(button)

	TrinityFunctionCounter("TrinityMinimapOptions4Sub2")

	local dockFrame, actionButton, anchorButton
	local normalHeader, actionbarHeader, stanceHeader, stealthHeader, altHeader, ctrlHeader, shiftHeader, anchorHeader;
	local templateName = TrinityBarsMinimapButtonOption4Sub3Text1Template:GetText()
	local oldDockFrameCount = getn(TrinityDockFrames)
	
	TrinityDockFrames = {};
	
	if (not TrinityTemplates[templateName]) then
		UIErrorsFrame:AddMessage("Current Template not Available", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
		return
	end

	for k,v in pairs(TrinityTemplates[templateName]["docks"]) do
		if (TrinityTemplates[templateName]["docks"][k]) then
			if (getglobal("TrinityDockFrame"..k)) then
				dockFrame = getglobal("TrinityDockFrame"..k);
				TrinityDockFrames[k] = dockFrame:GetName();
			else
				dockFrame = TrinityCreateDockFrame(k)				
			end
			dockFrame.headers = TrinityTemplates[templateName]["docks"][k][1];
			dockFrame.config = TrinityTemplates[templateName]["docks"][k][2];
			dockFrame.centerx = TrinityTemplates[templateName]["docks"][k][3];
			dockFrame.centery = TrinityTemplates[templateName]["docks"][k][4];
			
			for key,value in pairs(dockFrame.headers) do					
				if (dockFrame.headers[key]["active"]) then						
					if (key == "Normal") then
						if (getglobal("TrinityNormalHeader"..k)) then
							normalHeader = getglobal("TrinityNormalHeader"..k)
						else
							normalHeader = TrinityCreateNormalHeader(dockFrame)
						end
					elseif (key == "Actionbar") then
						if (getglobal("TrinityActionbarHeader"..k)) then
							actionbarHeader = getglobal("TrinityActionbarHeader"..k)
						else						
							actionbarHeader = TrinityCreateActionbarHeader(dockFrame)
						end
					elseif (key == "Stance") then
						if (getglobal("TrinityStanceHeader"..k)) then
							stanceHeader = getglobal("TrinityStanceHeader"..k)
						else						
							stanceHeader = TrinityCreateStanceHeader(dockFrame)
						end
					elseif (key == "Stealth") then
						if (getglobal("TrinityStealthHeader"..k)) then
							stealthHeader = getglobal("TrinityStealthHeader"..k)
						else						
							stealthHeader = TrinityCreateStealthHeader(dockFrame)
						end
					elseif (key == "Alt") then
						if (getglobal("TrinityAltHeader"..k)) then
							altHeader = getglobal("TrinityAltHeader"..k)
						else						
							altHeader = TrinityCreateAltHeader(dockFrame)
						end
					elseif (key == "Ctrl") then
						if (getglobal("TrinityCtrlHeader"..k)) then
							ctrlHeader = getglobal("TrinityCtrlHeader"..k)
						else						
							ctrlHeader = TrinityCreateCtrlHeader(dockFrame)
						end
					elseif (key == "Shift") then
						if (getglobal("TrinityShiftHeader"..k)) then
							shiftHeader = getglobal("TrinityShiftHeader"..k)
						else						
							shiftHeader = TrinityCreateShiftHeader(dockFrame)
						end
					elseif (key == "Anchor") then
						if (getglobal("TrinityAnchorHeader"..k)) then
							anchorHeader = getglobal("TrinityAnchorHeader"..k)
						else							
							anchorHeader = TrinityCreateAnchorHeader(dockFrame)							
						end
					end
				end
				
				-- New Vars
				if (not dockFrame.headers[key]["stateRef"]) then
					dockFrame.headers[key]["stateRef"] = 0;
				end
				if (not dockFrame.config["battle"]) then
					dockFrame.config["battle"] = nil;
				end								
				-- New Vars					
			end

			for key,value in pairs(dockFrame.headers) do					
				if (dockFrame.headers[key]["active"]) then						
				
					if (key == "Normal") then	
						if (dockFrame.headers[key]["parent"]) then
							getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", normalHeader);
							normalHeader:SetAttribute("showstates", dockFrame.headers[key]["showstate"]);
						end
					elseif (key == "Actionbar") then
						if (dockFrame.headers[key]["parent"]) then
							getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", actionbarHeader);
							actionbarHeader:SetAttribute("showstates", dockFrame.headers[key]["showstate"]);
						end							
					elseif (key == "Stance") then
						if (dockFrame.headers[key]["parent"]) then
							getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", stanceHeader);
							stanceHeader:SetAttribute("showstates", dockFrame.headers[key]["showstate"]);
						end							
					elseif (key == "Stealth") then
						if (dockFrame.headers[key]["parent"]) then
							getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", stealthHeader);
							stealthHeader:SetAttribute("showstates", dockFrame.headers[key]["showstate"]);
						end							
					elseif (key == "Alt") then
						if (dockFrame.headers[key]["parent"]) then
							getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", altHeader);
							altHeader:SetAttribute("showstates", dockFrame.headers[key]["showstate"]);
						end							
					elseif (key == "Ctrl") then
						if (dockFrame.headers[key]["parent"]) then
							getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", ctrlHeader);
							ctrlHeader:SetAttribute("showstates", dockFrame.headers[key]["showstate"]);
						end							
					elseif (key == "Shift") then
						if (dockFrame.headers[key]["parent"]) then
							getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", shiftHeader);
							shiftHeader:SetAttribute("showstates", dockFrame.headers[key]["showstate"]);
						end			
					elseif (key == "Anchor") then
						if (dockFrame.headers[key]["parent"]) then
							getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", shiftHeader);
							shiftHeader:SetAttribute("showstates", dockFrame.headers[key]["showstate"]);
						end										
					end
				end
			end								
		end		
	end
	
	for i=1,getn(TrinityTemplates[templateName]["buttons"]) do					
		if (TrinityTemplates[templateName]["buttons"][i]) then
			if (getglobal("TrinityActionButton"..i)) then
				actionButton = getglobal("TrinityActionButton"..i)				
				getglobal(TrinityTemplates[templateName]["buttons"][i][1]["header"]):SetAttribute("addchild", actionButton)
			else
				actionButton = TrinityCreateActionButton(i, TrinityTemplates[templateName]["buttons"][i][1]["dock"], TrinityTemplates[templateName]["buttons"][i][1]["showstate"], getglobal(TrinityTemplates[templateName]["buttons"][i][1]["header"]))						
			end
			actionButton.config = TrinityTemplates[templateName]["buttons"][i][1];
			actionButton:SetAttribute("showstates", actionButton.config["showstate"])			
			if (not actionButton.config["style"]) then
				actionButton.config["style"] = 1;
			end	
		end
	end		
	
	for i=1,getn(TrinityTemplates[templateName]["anchors"]) do					
		if (TrinityTemplates[templateName]["anchors"][i]) then
			if (getglobal("TrinityAnchorButton"..i)) then
				anchorButton = getglobal("TrinityAnchorButton"..i)				
				getglobal(TrinityTemplates[templateName]["anchors"][i][1]["header"]):SetAttribute("addchild", anchorButton)
			else
				anchorButton = TrinityCreateAnchorButton(i, TrinityTemplates[templateName]["anchors"][i][1]["dock"], TrinityTemplates[templateName]["anchors"][i][1]["showstate"], getglobal(TrinityTemplates[templateName]["anchors"][i][1]["header"]))						
			end
			anchorButton.config = TrinityTemplates[templateName]["anchors"][i][1];
			anchorButton:SetAttribute("showstates", anchorButton.config["showstate"])			
		end
	end

	TrinityStorageHeader.data = TrinityTemplates[templateName]["storage"][1]
	
	TrinityDockBarsHide = TrinityTemplates[templateName]["globals"][1]
	TrinityButtonsHide = TrinityTemplates[templateName]["globals"][2]
	TrinityButtonLock = TrinityTemplates[templateName]["globals"][3]		
	TrinityMiscBars["cast"] = TrinityTemplates[templateName]["globals"][4]["cast"]
	TrinityMiscBars["menu"] = TrinityTemplates[templateName]["globals"][4]["menu"]
	TrinityMiscBars["bags"] = TrinityTemplates[templateName]["globals"][4]["bags"]
	TrinityMiscBars["form"] = TrinityTemplates[templateName]["globals"][4]["form"]
	TrinityMiscBars["pet"] = TrinityTemplates[templateName]["globals"][4]["pet"]
	TrinityMiscBars["XP"] = TrinityTemplates[templateName]["globals"][4]["XP"]
	TrinitySpellBindings = TrinityTemplates[templateName]["globals"][5]
	TrinityButtonStyle = TrinityTemplates[templateName]["globals"][6]
	TrinityKeyBindingTextHidden = TrinityTemplates[templateName]["globals"][7]
	TrinitySelfCastOption = TrinityTemplates[templateName]["globals"][8]
	TrinityShowButtonTooltips = TrinityTemplates[templateName]["globals"][9]
	TrinityDocksStored = TrinityTemplates[templateName]["globals"][10]		
	TrinityCoolDown = TrinityTemplates[templateName]["globals"][11]	
	
	TrinityUpdateDockPostions(false);
	TrinityReassignDefaultUIElements()		
	for k,v in pairs(TrinityDockFrames) do				
		local dockFrame = getglobal("TrinityDockFrame"..k);		
		TrinityUpdateDocking(dockFrame);
		TrinityUpdateTargeting(dockFrame);			
		TrinitySwapTextures(dockFrame)	
		if (dockFrame.config["ghost"]) then
			dockFrame.config["vis"] = 1;
		end
		if (i==TrinityMiscBars["pet"]) then
			TrinityTogglePetButtonGrid(dockFrame)
		end
		TrinityRefreshOrderList(dockFrame)		
	end		
	TrinityUpdateBindings();		
	TrinitySetSelfCast(TrinitySelfCastOption);
	TrinityUpdateShapeshiftButtons();
	TrinityBarsMinimapButtonOption4Sub1Edit1:SetText(UnitClass("player"));	
		
	TrinityRefreshHeaders();	
	TrinityHideKeyBindings();
	for k,v in pairs(TrinityDockFrames) do				
		local dockFrame = getglobal("TrinityDockFrame"..k);		
		TrinitySwapTextures(dockFrame)			
	end
	
	TrinitySaveButtonState()
	
	TrinityMinimapOption4Reset(button)	
	
	UIErrorsFrame:AddMessage("Template "..templateName.." loaded", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		

end

function TrinityMinimapOptions4Sub2Sub1(button)

	TrinityFunctionCounter("TrinityMinimapOptions4Sub2Sub1")

	local dockFrame, actionButton, anchorButton;

	local templateName = TrinityBarsMinimapButtonOption4Sub1Edit1:GetText()
	
	if (strlen(templateName) < 1) then
		UIErrorsFrame:AddMessage("Invalid Template Name", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
		return
	end	

	TrinityTemplates[templateName] = {}
	
	TrinityTemplates[templateName]["docks"] = {}
	
	for k,v in pairs(TrinityDockFrames) do
		dockFrame = getglobal("TrinityDockFrame"..k);			
		TrinityTemplates[templateName]["docks"][k] = { dockFrame.headers, dockFrame.config, dockFrame:GetCenter() };
	end
	
	TrinityTemplates[templateName]["buttons"] = {}
	for i=1,120 do
		actionButton = getglobal("TrinityActionButton"..i);					
		TrinityTemplates[templateName]["buttons"][i] = { actionButton.config }			
	end	
	
	TrinityTemplates[templateName]["anchors"] = {}
	for i=1,37 do
		anchorButton = getglobal("TrinityAnchorButton"..i);					
		TrinityTemplates[templateName]["anchors"][i] = { anchorButton.config }			
	end		
	
	TrinityTemplates[templateName]["storage"] = { TrinityStorageHeader.data };		
	
	TrinityTemplates[templateName]["globals"] = {	
		TrinityDockBarsHide,
		TrinityButtonsHide,
		TrinityButtonLock,
		TrinityMiscBars,
		TrinitySpellBindings,
		TrinityButtonStyle,
		TrinityKeyBindingTextHidden,
		TrinitySelfCastOption,
		TrinityShowButtonTooltips,
		TrinityDocksStored,
		TrinityCoolDown,
	}	
	
	TrinityMinimapOption4Reset(button)
	
	UIErrorsFrame:AddMessage("Template "..templateName.." saved", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
end

function TrinityMinimapOptions4Sub3(button)

	TrinityFunctionCounter("TrinityMinimapOptions4Sub3")

end

function TrinityMinimapOptions4Sub4(button)	

	TrinityFunctionCounter("TrinityMinimapOptions4Sub4")

end

function TrinityMinimapOptions4Sub4Sub1(button)

	TrinityFunctionCounter("TrinityMinimapOptions4Sub4Sub1")

	if (this.click == "LeftButton") then
		if (TrinityTemplatesList[button.index]) then
			button.index = button.index + 1;
			if (button.index > getn(TrinityTemplatesList)) then
				button.index = 1;
			end
		end
	else

		if (TrinityTemplatesList[button.index]) then
			button.index = button.index - 1;
			if (button.index < 1) then
				button.index = getn(TrinityTemplatesList);
			end
		end
	end
	
	TrinityBarsMinimapButtonOption4Sub3Text1Template:SetText(TrinityTemplatesList[button.index]);
	
	TrinityMinimapOption4Reset(button)
end

function TrinityMinimapOptions5(button)

	TrinityFunctionCounter("TrinityMinimapOptions5")

	TrinityMinimapOptionsOnClick()
	TrinityBarsControl.transition = 75;
	TrinityBarsControl.count = 14;		
	TrinityOption5SubMenu = true;
		
	for i=1,6 do				
		local subOption = getglobal(this:GetName().."Sub"..i);	
		subOption:Show()
	end				
end

function TrinityMinimapOptions5Sub1(button)

	TrinityFunctionCounter("TrinityMinimapOptions5Sub1")

	if (not TrinityDockBarsHide) then

		local dockID;
		local dockIndex = {}
		local first = 0;
		local limit = 1;		
		
		for k,v in pairs(TrinityDockFrames) do
			if (k > limit) then				
				limit = k+1;
			end
		end		
		
		for i=1,limit do
			if (TrinityDockFrames[i]) then
				if (first == 0) then
					first = i;
				end
				dockIndex[i] = TrinityDockFrames[i]
			else
				dockIndex[i] = nil;
			end
		end

		for k,v in pairs(TrinityDockFrames) do			
			getglobal("TrinityDockFrame"..k):SetBackdropBorderColor(0,0,0,0)
			getglobal("TrinityDockFrame"..k):SetFrameStrata("LOW");
			getglobal("TrinityDockFrame"..k).selected = false;
			if (getglobal("TrinityDockFrame"..k).config["stored"]) then
				getglobal("TrinityDockFrame"..k):Hide();
			end
		end

		local found = false;
		
		if (this.click == "LeftButton") then			
			for i=0,limit do
				if (not found) then					
					if (i > button.dockID) then						
						button.dockID = i								
						if (button.dockID == limit) then
							button.dockID = first;
						end			
						if (getglobal("TrinityDockFrame"..button.dockID) and dockIndex[i]) then							
							found = true
						end
					end						
				else
					break;
				end
			end
		else
			return;
		end
		
		if (found) then	
		
			local dockFrame = getglobal("TrinityDockFrame"..button.dockID);		
			
			dockFrame.adjusting = false;					
			TrinityHideDocksButtons(dockFrame:GetID(), dockFrame:GetID())
		
			dockFrame:SetBackdropBorderColor(0,0,0,0)					
			dockFrame:SetFrameStrata("MEDIUM");
			dockFrame:Show();
			dockFrame.adjusting = true;		
			dockFrame.selected = true;
			dockFrame:EnableKeyboard(false)

			TrinityDockFrameEditorLeft:Hide()
			TrinityDockFrameEditorRight:Hide()
			TrinityUpdateDockConfig(dockFrame);
		end

		return

	else
		UIErrorsFrame:AddMessage("Must be in configuration mode", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
	end		

end

function TrinityMinimapOptions5Sub2(button)

	TrinityFunctionCounter("TrinityMinimapOptions5Sub2")

	local dockID;
	local dockFrame;

	if (TrinityDocksStored) then
		for k,v in pairs(TrinityDockFrames) do		
			dockFrame = getglobal("TrinityDockFrame"..k);
			dockFrame.config["stored"] = false;
			TrinityDockFrameEditorRightStore:SetChecked(dockFrame.config["stored"])
			if (not TrinityDockBarsHide) then
				dockFrame:Show();
			end
			TrinityHideDocksButtons(dockFrame:GetID(), dockFrame:GetID())
		end
		TrinityDocksStored = false;				
		UIErrorsFrame:AddMessage("All docks have been restored", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
	else
		for k,v in pairs(TrinityDockFrames) do
			dockFrame = getglobal("TrinityDockFrame"..k);
			dockFrame.config["stored"] = true;
			TrinityDockFrameEditorRightStore:SetChecked(dockFrame.config["stored"])
			dockFrame:Hide();
			TrinityHideDocksButtons(dockFrame:GetID(), dockFrame:GetID())
		end
		UIErrorsFrame:AddMessage("All docks have been stored", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
		TrinityDocksStored = true;
	end		
end

function TrinityMinimapOptions5Sub3(button)

	TrinityFunctionCounter("TrinityMinimapOptions5Sub3")

	local dockID;
	local dockFrame = getglobal("TrinityDockFrame"..button.dockID);

	if (button.click == "LeftButton") then
		if (dockFrame.config["stored"] == false) then
			dockFrame.config["stored"] = true;
			TrinityDockFrameEditorRightStore:SetChecked(dockFrame.config["stored"])
			dockFrame:Hide();
			UIErrorsFrame:AddMessage("Dock "..dockFrame:GetID().." has been stored", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		else
			dockFrame.config["stored"] = false;
			if (not TrinityDockBarsHide) then
				TrinityDockFrameEditorRightStore:SetChecked(dockFrame.config["stored"])
				dockFrame:Show();
				UIErrorsFrame:AddMessage("Dock "..dockFrame:GetID().." has been restored", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			end
		end
					
	end
	TrinityHideDocksButtons(dockFrame:GetID(), dockFrame:GetID())
end


function TrinityMinimapOptions5Sub4(button)

	TrinityFunctionCounter("TrinityMinimapOptions5Sub4")

	local frame = getglobal("TrinityDockFrame"..button.dockID)
	local count = 0;
	
	if (frame:GetID() == TrinityMiscBars["bags"] or
	    frame:GetID() == TrinityMiscBars["menu"] or
	    frame:GetID() == TrinityMiscBars["pet"] or
	    frame:GetID() == TrinityMiscBars["form"] or
	    frame:GetID() == TrinityMiscBars["cast"] or
	    frame:GetID() == TrinityMiscBars["XP"]) then
		
		UIErrorsFrame:AddMessage("This dock cannot be deleted", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		return;
	end

	for key,value in pairs(frame.headers) do
		for k,v in pairs(frame.headers[key]["list"]) do	
			local buttonList = {};						
			string.gsub(frame.headers[key]["list"][k], "%d+", function (btn) table.insert(buttonList, btn) end);					
			for kk,vv in pairs(buttonList) do					
				local actionButton = getglobal(frame.config["btnType"]..vv);		
				actionButton:ClearAllPoints();
				actionButton:SetPoint("CENTER", "TrinityStorageHeader", "CENTER");
				actionButton.config["dock"] = 0;
				actionButton.config["dockpos"] = 0;
				actionButton.config["showstate"] = "STORED";
				actionButton.config["header"] = "TrinityStorageHeader";
				actionButton:SetAttribute("showstates", "STORED");		
				TrinityStorageHeader:SetAttribute("addchild", actionButton);						
				frame.headers[key]["list"][k] = string.gsub(frame.headers[key]["list"][k], "(%D)"..v..",", "%1")				
				TrinityStorageHeader.data["buttonIndex"][tonumber(vv)] = 1;
				TrinityStorageHeader.data["buttonCount"] = TrinityStorageHeader.data["buttonCount"] + 1;					
				count = count + 1;
			end
		end
	end
	
	if (count ~= 0) then
		UIErrorsFrame:AddMessage(count.." buttons placed into storage", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
	end
	
	frame:Hide();	
	TrinityDockFrames[button.dockID] = nil;	
	
	UIErrorsFrame:AddMessage("Dock "..button.dockID.." has been deleted", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);	
	TrinitySaveButtonState();
end

function TrinityMinimapOptions5Sub5(button)

	TrinityFunctionCounter("TrinityMinimapOptions5Sub5")

	local dockFrame, normalHeader;
	local index = 1;	
	
	while (TrinityDockFrames[index]) do
		index = index + 1;
		if (index > 100) then
			break;
		end
	end
	
	if (getglobal("TrinityDockFrame"..index)) then
		dockFrame = getglobal("TrinityDockFrame"..index)
		normalHeader = getglobal("TrinityNormalHeader"..index)
		TrinityDockFrameDefaults(index, dockFrame);
		TrinityDockFrames[index] = dockFrame:GetName()
	else
		dockFrame = TrinityCreateDockFrame(index)			
		normalHeader = TrinityCreateNormalHeader(dockFrame)				
	end
	
	normalHeader:SetAttribute("showstates", "0");		
	dockFrame.config["btnType"] = "TrinityActionButton"		
	dockFrame.headers["Normal"]["parent"] = "UIParent"
	dockFrame.headers["Normal"]["showstate"] = "0";		
	dockFrame.headers["Normal"]["order"] = 0;
	dockFrame.headers["Normal"]["list"][0] = ",";			
	dockFrame:SetUserPlaced(false);
	dockFrame:ClearAllPoints();						
	dockFrame:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
	dockFrame:SetUserPlaced(true);						
	TrinityUpdateDocking(dockFrame);	
	dockFrame:Show();
	UIErrorsFrame:AddMessage("Dock "..dockFrame:GetID().." has been created", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
end

function TrinityMinimapOptions5Sub6(button)

	TrinityFunctionCounter("TrinityMinimapOptions5Sub6")

	local dockFrame = getglobal("TrinityDockFrame"..button.dockID);

	dockFrame.config["scale"] = 1;
	dockFrame.config["alpha"] = 1;
	dockFrame.config["shape"] = 0;
	dockFrame.config["ghost"] = nil;
	TrinityDockFrameEditorRightGhost:SetChecked(dockFrame.config["ghost"]);
	dockFrame.config["showgrid"] = nil;
	dockFrame.config["buttonSpaceH"] = 3;
	dockFrame.config["buttonSpaceV"] = 3;
	dockFrame.config["style"] = 1;
	dockFrame.config["target"] = "none";
	dockFrame.config["stored"] = false;
	dockFrame.config["storedbuttons"] = false;
	dockFrame:SetUserPlaced(false);
	dockFrame:ClearAllPoints();			
	dockFrame:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
	dockFrame:SetUserPlaced(true);
	
	if (dockFrame:GetID()==TrinityMiscBars["cast"]) then
		dockFrame.config["orientation"] = "VERTICAL";
	        dockFrame.config["anchorwidth"] = 12;
		dockFrame.config["anchorheight"] = 195;
		TrinityCastingBarOrientation(dockFrame)
	elseif (dockFrame:GetID()==TrinityMiscBars["XP"]) then	
		dockFrame.config["orientation"] = "VERTICAL";
	        dockFrame.config["anchorwidth"] = 8;
		dockFrame.config["anchorheight"] = 135;
		TrinityXPBarOrientation(dockFrame)
	end
	
	TrinityUpdateDocking(dockFrame);
	
	UIErrorsFrame:AddMessage("Dock "..dockFrame:GetID().." has been reset\nButtons associated with this dock remain unchanged", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
end		

function TrinityMinimapOptions6()

	TrinityFunctionCounter("TrinityMinimapOptions6")

	if (InCombatLockdown()) then
		UIErrorsFrame:AddMessage("In Combat Lockdown", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		return;
	end
	if (TrinityKeyBinder:IsVisible()) then
		TrinityKeyBinder:EnableKeyboard(false);						
		TrinityKeyBinder:Hide();		
		getglobal(this:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\keybindoff.tga");			
	else
		TrinityKeyBinder:EnableKeyboard(false);						
		TrinityKeyBinder:Show();		
		getglobal(this:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\keybindon.tga");			
	end
end

function TrinityMinimapOptions7(button)

	TrinityFunctionCounter("TrinityMinimapOptions7")

	if (IsShiftKeyDown()) then
	
		if (this.click == "LeftButton") then
			button.unitindex = button.unitindex + 1;
			if (button.unitindex > getn(button.unitsets)) then
				button.unitindex = 1;
			end
		else
			button.unitindex = button.unitindex - 1;
			if (button.unitindex < 1) then
				button.unitindex = getn(button.unitsets);
			end
		end
		
		TrinityUnitSet = button.unitsets[button.unitindex]
		
		for k,v in pairs(TrinityDockFrames) do
			TrinitySetTargetBars(getglobal("TrinityDockFrame"..k))
		end
		
		UIErrorsFrame:AddMessage("UnitFrame option set to |cff00ff00"..TrinityUnitSet.."|r", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
	else

		if (this.click == "LeftButton") then
			TrinitySelfCastOption = TrinitySelfCastOption + 1;
			if (TrinitySelfCastOption > 5) then
				TrinitySelfCastOption = 1;
			end
		else
			TrinitySelfCastOption = TrinitySelfCastOption - 1;
			if (TrinitySelfCastOption <= 0) then
				TrinitySelfCastOption = 5;
			end
		end
		
		TrinitySetSelfCast(TrinitySelfCastOption);
		
		UIErrorsFrame:AddMessage("Self-Cast option set to |cff00ff00"..TrinityBarsMinimapButtonOption7.option.."|r", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
	end
end

function TrinitySetSelfCast(option)

	TrinityFunctionCounter("TrinitySetSelfCast")

	TrinityBarsMinimapButtonOption7.option = "None"	
	
	for k,v in pairs(TrinityDockFrames) do
		local dockFrame = getglobal("TrinityDockFrame"..k);
		for key,value in pairs(dockFrame.headers) do
			if (dockFrame.headers[key]["active"]) then
				if (option == 1 or option ~= 2) then
					getglobal(dockFrame.headers[key]["name"]):SetAttribute("unit2", nil);
				end
				if (option == 2) then
					getglobal(dockFrame.headers[key]["name"]):SetAttribute("unit2", "player");
					TrinityBarsMinimapButtonOption7.option = "RightClick"
				end
				if (option == 1 or option ~= 3) then		
					getglobal(dockFrame.headers[key]["name"]):SetAttribute("alt-unit*", nil);
				end
				if (option == 3) then
					getglobal(dockFrame.headers[key]["name"]):SetAttribute("alt-unit*", "player");
					TrinityBarsMinimapButtonOption7.option = "Alt-Cast"
				end
				if (option == 1 or option ~= 4) then		
					getglobal(dockFrame.headers[key]["name"]):SetAttribute("ctrl-unit*", nil);
				end
				if (option == 4) then	
					getglobal(dockFrame.headers[key]["name"]):SetAttribute("ctrl-unit*", "player");
					TrinityBarsMinimapButtonOption7.option = "Ctrl-Cast"
				end
				if (option == 1 or option ~= 5) then		
					getglobal(dockFrame.headers[key]["name"]):SetAttribute("shift-unit*", nil);
				end
				if (option == 5) then		
					getglobal(dockFrame.headers[key]["name"]):SetAttribute("shift-unit*", "player");
					TrinityBarsMinimapButtonOption7.option = "Shift-Cast"
				end
			end
		end
	end
	
	--for i=1,120 do
	
	--	local actionButton = getglobal("TrinityActionButton"..i);
		
	--	if (option == 1 or option ~= 2) then
	--		actionButton:SetAttribute("unit2", nil);
	--	end
	--	if (option == 2) then
	--		actionButton:SetAttribute("unit2", "player");			
	--	end
	--	if (option == 1 or option ~= 3) then		
	--		actionButton:SetAttribute("alt-unit*", nil);
	--	end
	--	if (option == 3) then
	--		actionButton:SetAttribute("alt-unit*", "player");
	--	end
	--	if (option == 1 or option ~= 4) then		
	--		actionButton:SetAttribute("ctrl-unit*", nil);
	--	end
	--	if (option == 4) then	
	--		actionButton:SetAttribute("ctrl-unit*", "player");
	--	end
	--	if (option == 1 or option ~= 5) then		
	--		actionButton:SetAttribute("shift-unit*", nil);
	--	end
	--	if (option == 5) then		
	--		actionButton:SetAttribute("shift-unit*", "player");
	--	end
	--end	
end

function TrinitySpellBinder_OnLoad()

	TrinityFunctionCounter("TrinitySpellBinder_OnLoad")

	local posCount = 5
	local negCount = 0;
	for i=1,12 do
		local bindFrame = CreateFrame("Button", "TrinitySpellBinderButton"..i, getglobal("SpellButton"..i), "TrinitySpellBinderTemplate");				
		if (mod(i,2) == 0) then
			bindFrame:SetID(i+posCount);
			posCount = posCount - 1;			
		else
			bindFrame:SetID(i+negCount);
			 negCount = negCount - 1;			
		end		
		bindFrame:SetPoint("TOPLEFT", getglobal("SpellButton"..i), "TOPLEFT", 0 ,0);
		bindFrame:SetPoint("BOTTOMRIGHT", getglobal("SpellButton"..i), "BOTTOMRIGHT", 0 ,0);
		bindFrame:SetFrameLevel(getglobal("SpellButton"..i):GetFrameLevel()+1);		
		
		getglobal("SpellButton"..i):CreateFontString("$parentHotKey", "ARTWORK", "NumberFontNormalSmall");		
		getglobal("SpellButton"..i.."HotKey"):SetPoint("TOPRIGHT", -1, -5);		
	end		
	for i=1,10 do
		local bindFrame = CreateFrame("Button", "TrinitySpellBinderButton"..i+12, getglobal("ShapeshiftButton"..i), "TrinitySpellBinderTemplate");				
		bindFrame:SetID(i+12);
		bindFrame:SetPoint("TOPLEFT", getglobal("ShapeshiftButton"..i), "TOPLEFT", 0 ,0);
		bindFrame:SetPoint("BOTTOMRIGHT", getglobal("ShapeshiftButton"..i), "BOTTOMRIGHT", 0 ,0);
		bindFrame:SetFrameLevel(getglobal("ShapeshiftButton"..i):GetFrameLevel()+1);	
		getglobal("ShapeshiftButton"..i.."HotKey"):SetPoint("TOPRIGHT", 0, -3);		
		getglobal("ShapeshiftButton"..i.."HotKey"):SetTextColor(1,1,1)
		getglobal("ShapeshiftButton"..i):CreateFontString("$parentHotKeyRound", "ARTWORK", "NumberFontNormalSmallRound");		
		getglobal("ShapeshiftButton"..i.."HotKeyRound"):SetPoint("TOPRIGHT", 0, -3);		
		getglobal("ShapeshiftButton"..i.."HotKeyRound"):SetTextColor(1,1,1)		
	end			
end

function TrinitySpellBookFrame_OnEvent()

	TrinityFunctionCounter("TrinitySpellBookFrame_OnEvent")

	if ( event == "SPELLS_CHANGED" or "UPDATE_BINDINGS") then
		if ( SpellBookFrame:IsVisible() ) then					
			SpellBookFrame_Update();
			SpellBook_UpdatePageArrows();
			for i=1,12 do
				getglobal("SpellButton"..i.."HotKey"):SetText();								
				local frameid = getglobal("TrinitySpellBinderButton"..i):GetID()
				local spellid = SpellBook_GetSpellID(frameid);
				local spellName, subSpellName = GetSpellName(spellid, SpellBookFrame.bookType);
				if (spellName) then
					if (subSpellName) then
						spellName = spellName.."("..subSpellName..")".."-HotKey";
					else
						spellName = spellName.."()".."-HotKey";
					end				
					for k,v in pairs(TrinitySpellBindings) do
						if (k == spellName) then
							getglobal("SpellButton"..i.."HotKey"):SetText(v);								
						end
					end
				end
			end
		end
	elseif ( event == "LEARNED_SPELL_IN_TAB" ) then
		local flashFrame = getglobal("SpellBookSkillLineTab"..arg1.."Flash");
		if ( SpellBookFrame.bookType == BOOKTYPE_PET ) then
			return;
		else
			if ( flashFrame ) then
				flashFrame:Show();
				SpellBookFrame.flashTabs = 1;
			end
		end
	end
end

function TrinityChooseButtonStyle(dockFrame)

	TrinityFunctionCounter("TrinityChooseButtonStyle")

	if (dockFrame.config["style"] == 1) then
	
		dockFrame.config["style"] = 2;		
		TrinitySwapTextures(dockFrame)
		
	elseif (dockFrame.config["style"] == 2) then
	
		dockFrame.config["style"] = 3;
		TrinitySwapTextures(dockFrame)
		
	elseif (dockFrame.config["style"] == 3) then
	
		dockFrame.config["style"] = 4;
		TrinitySwapTextures(dockFrame)
		
	elseif (dockFrame.config["style"] == 4) then
	
		dockFrame.config["style"] = 1;
		TrinitySwapTextures(dockFrame)		
	end	
	
end


function TrinitySwapTextures(dockFrame)

	TrinityFunctionCounter("TrinitySwapTextures")

	for key,value in pairs(dockFrame.headers) do
	
		for showstate=dockFrame.headers[key]["start"],dockFrame.headers[key]["end"] do				
		
			if (dockFrame.headers[key]["list"][showstate]) then
			
				local buttonList = {};

				string.gsub(dockFrame.headers[key]["list"][showstate], "%d+", function (btn) table.insert(buttonList, btn) end);				
				
				if (dockFrame.config["style"] == 1) then

					for k,v in pairs(buttonList) do		
						if (dockFrame.config["btnType"] == "TrinityActionButton") then
							local actionButton = getglobal(dockFrame.config["btnType"]..v);	
							actionButton.config["style"] = dockFrame.config["style"];
							actionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
							getglobal(actionButton:GetName().."NormalTexture"):SetWidth(60);
							getglobal(actionButton:GetName().."NormalTexture"):SetHeight(60);			
							getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
							getglobal(actionButton:GetName().."Border"):SetWidth(60);
							getglobal(actionButton:GetName().."Border"):SetHeight(60);			
							actionButton:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
							getglobal(dockFrame.config["btnType"]..v.."BindFrame"):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
							actionButton:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
							actionButton:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");			
							getglobal(actionButton:GetName().."Pushed"):SetWidth(38);
							getglobal(actionButton:GetName().."Pushed"):SetHeight(38);							
							getglobal(actionButton:GetName().."Sheen"):SetTexture("");			
							getglobal(actionButton:GetName().."IconFrame"):SetWidth(36);
							getglobal(actionButton:GetName().."IconFrame"):SetHeight(36);			
							getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("TOPLEFT",0,0)
							getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("BOTTOMRIGHT",0,0)
							getglobal(actionButton:GetName().."IconFrameIcon"):SetTexCoord(0,1,0,1);
							if (not TrinityKeyBindingTextHidden) then
								getglobal(actionButton:GetName().."HotKey"):Show()
								getglobal(actionButton:GetName().."HotKeyRound"):Hide()
							end
							getglobal(actionButton:GetName().."Count"):SetTextHeight(14);
							getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);													
							Trinity_UpdateActionbar_OnEvent(actionButton)
							
						elseif (dockFrame.config["btnType"] == "TrinityAnchorButton") then
						
							local element = getglobal(getglobal(dockFrame.config["btnType"]..v).config["element"])
						
							if (dockFrame:GetID() == TrinityMiscBars["bags"]) then	

								element:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
								getglobal(element:GetName().."NormalTexture"):SetWidth(60);
								getglobal(element:GetName().."NormalTexture"):SetHeight(60);
								getglobal(element:GetName().."NormalTexture"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture"):SetPoint("CENTER",0,0);												
								element:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
								element:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
								element:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");									
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");						
								getglobal(element:GetName().."Sheen"):SetTexture("");
								getglobal(element:GetName().."IconTexture"):ClearAllPoints();
								getglobal(element:GetName().."IconTexture"):SetPoint("TOPLEFT",0,0);		
								getglobal(element:GetName().."IconTexture"):SetPoint("BOTTOMLEFT",0,0);		
								getglobal(element:GetName().."IconTexture"):SetPoint("TOPRIGHT",0,0);		
								getglobal(element:GetName().."IconTexture"):SetPoint("BOTTOMRIGHT",0,0);
								getglobal(element:GetName().."IconTexture"):SetTexCoord(0,1,0,1);
								
							elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

								element:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
								getglobal(element:GetName().."NormalTexture2"):SetWidth(60);
								getglobal(element:GetName().."NormalTexture2"):SetHeight(60);			
								getglobal(element:GetName().."NormalTexture2"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture2"):SetPoint("CENTER",0,0);									
								getglobal(element:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
								getglobal(element:GetName().."Border"):SetWidth(60);
								getglobal(element:GetName().."Border"):SetHeight(60);			
								element:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
								element:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
								element:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
								getglobal(element:GetName().."Sheen"):SetTexture("");
								getglobal(element:GetName().."Cooldown"):ClearAllPoints();
								getglobal(element:GetName().."Cooldown"):SetPoint("TOPLEFT", getglobal(element:GetName().."Icon"), "TOPLEFT" , 0, 0);		
								getglobal(element:GetName().."Cooldown"):SetPoint("BOTTOMRIGHT", getglobal(element:GetName().."Icon"), "BOTTOMRIGHT" , 0, 0);								
								getglobal(element:GetName().."Cooldown"):SetFrameStrata("MEDIUM");
								getglobal(element:GetName().."Cooldown"):SetFrameLevel(3);
								if ( autoCastAllowed ) then
									getglobal(element:GetName().."AutoCastable"):Show();
								else
									getglobal(element:GetName().."AutoCastable"):Hide();
								end
								if ( autoCastEnabled ) then
									getglobal(element:GetName().."AutoCast"):Show();
								else
									getglobal(element:GetName().."AutoCast"):Hide();
								end				
								getglobal(element:GetName().."AutoCastSim"):SetTexture("");						
								getglobal(element:GetName().."AutoCastable"):SetTexture("Interface\Buttons\UI-AutoCastableOverlay");
								getglobal(element:GetName().."Icon"):ClearAllPoints();
								getglobal(element:GetName().."Icon"):SetPoint("TOPLEFT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMLEFT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("TOPRIGHT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
								if (not TrinityKeyBindingTextHidden) then								
									getglobal(element:GetName().."HotKey"):Show();
								end
								getglobal(element:GetName().."HotKey"):SetPoint("TOPLEFT", -1, -5);
								getglobal(element:GetName().."Count"):SetTextHeight(14);
								getglobal(element:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);						

							elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

								element:SetNormalTexture("")
								getglobal(element:GetName().."NormalTexture"):SetWidth(60);
								getglobal(element:GetName().."NormalTexture"):SetHeight(60);			
								getglobal(element:GetName().."NormalTexture"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture"):SetPoint("CENTER",0,0);									
								getglobal(element:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
								getglobal(element:GetName().."Border"):SetWidth(60);
								getglobal(element:GetName().."Border"):SetHeight(60);			
								element:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
								element:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
								element:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
								getglobal(element:GetName().."Sheen"):SetTexture("");
								getglobal(element:GetName().."Cooldown"):ClearAllPoints();
								getglobal(element:GetName().."Cooldown"):SetPoint("BOTTOMLEFT",0, 0);		
								getglobal(element:GetName().."Cooldown"):SetScale(0.83);
								getglobal(element:GetName().."Cooldown"):SetFrameStrata("LOW");			
								getglobal(element:GetName().."Icon"):ClearAllPoints();
								getglobal(element:GetName().."Icon"):SetPoint("TOPLEFT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMLEFT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("TOPRIGHT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
								if (not TrinityKeyBindingTextHidden) then
									getglobal(element:GetName().."HotKey"):Show()
									getglobal(element:GetName().."HotKeyRound"):Hide()
								end
								getglobal(element:GetName().."Count"):SetTextHeight(14);
								getglobal(element:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);				
							end							
						end
					end
					
				elseif (dockFrame.config["style"] == 2) then
				
					for k,v in pairs(buttonList) do						
						if (dockFrame.config["btnType"] == "TrinityActionButton") then
						
							local actionButton = getglobal(dockFrame.config["btnType"]..v);						
							actionButton.config["style"] = dockFrame.config["style"];
							actionButton:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButton.tga")
							getglobal(actionButton:GetName().."NormalTexture"):SetWidth(36);
							getglobal(actionButton:GetName().."NormalTexture"):SetHeight(36);			
							getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonBorder.tga");
							getglobal(actionButton:GetName().."Border"):SetWidth(36);
							getglobal(actionButton:GetName().."Border"):SetHeight(36);			
							actionButton:SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonHiLight.tga");			
							getglobal(dockFrame.config["btnType"]..v.."BindFrame"):SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonHiLight.tga");			
							actionButton:SetCheckedTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonChecked.tga");			
							actionButton:SetPushedTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonPushed.tga");										
							getglobal(actionButton:GetName().."Pushed"):SetWidth(36);
							getglobal(actionButton:GetName().."Pushed"):SetHeight(36);							
							getglobal(actionButton:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonSheen.tga");			
							getglobal(actionButton:GetName().."Sheen"):SetWidth(39);
							getglobal(actionButton:GetName().."Sheen"):SetHeight(32);
							getglobal(actionButton:GetName().."Sheen"):SetPoint("CENTER",0,1);																
							getglobal(actionButton:GetName().."IconFrame"):SetWidth(25);
							getglobal(actionButton:GetName().."IconFrame"):SetHeight(25);
							getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("TOPLEFT",3,-3)
							getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("BOTTOMRIGHT",-3,3)
							
							if (not TrinityKeyBindingTextHidden) then
								getglobal(actionButton:GetName().."HotKey"):Hide()
								getglobal(actionButton:GetName().."HotKeyRound"):Show()
							end
							getglobal(actionButton:GetName().."Count"):SetTextHeight(10);
							getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOM", 0, 0);																
							Trinity_UpdateActionbar_OnEvent(actionButton)
							
						elseif (dockFrame.config["btnType"] == "TrinityAnchorButton") then
						
							local element = getglobal(getglobal(dockFrame.config["btnType"]..v).config["element"])
							
							if (dockFrame:GetID() == TrinityMiscBars["bags"]) then	

								element:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButton.tga")
								getglobal(element:GetName().."NormalTexture"):SetWidth(36);
								getglobal(element:GetName().."NormalTexture"):SetHeight(36);
								getglobal(element:GetName().."NormalTexture"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture"):SetPoint("TOP",0,-0.5);												
								element:SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonHiLight.tga");			
								element:SetCheckedTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonChecked.tga");			
								element:SetPushedTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonPushed.tga");						
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
								getglobal(element:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonSheen.tga");
								getglobal(element:GetName().."IconTexture"):ClearAllPoints();
								getglobal(element:GetName().."IconTexture"):SetPoint("TOPLEFT",7,-7);		
								getglobal(element:GetName().."IconTexture"):SetPoint("BOTTOMLEFT",7,6);		
								getglobal(element:GetName().."IconTexture"):SetPoint("TOPRIGHT",-7,-7);		
								getglobal(element:GetName().."IconTexture"):SetPoint("BOTTOMRIGHT",7,6);
								getglobal(element:GetName().."IconTexture"):SetTexCoord(0,1,0,1);

							elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

								element:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButton.tga")
								getglobal(element:GetName().."NormalTexture2"):SetWidth(32);
								getglobal(element:GetName().."NormalTexture2"):SetHeight(32);			
								getglobal(element:GetName().."NormalTexture2"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture2"):SetPoint("TOP",0,1);									
								getglobal(element:GetName().."Border"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonBorder.tga");
								getglobal(element:GetName().."Border"):SetWidth(36);
								getglobal(element:GetName().."Border"):SetHeight(36);			
								element:SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonHiLight.tga");			
								element:SetCheckedTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonChecked.tga");			
								element:SetPushedTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonPushed.tga");			
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
								getglobal(element:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonSheen.tga");
								getglobal(element:GetName().."Cooldown"):ClearAllPoints();
								getglobal(element:GetName().."Cooldown"):SetPoint("TOPLEFT", getglobal(element:GetName().."Icon"), "TOPLEFT" , 0, 0);		
								getglobal(element:GetName().."Cooldown"):SetPoint("BOTTOMRIGHT", getglobal(element:GetName().."Icon"), "BOTTOMRIGHT" , 0, 0);								
								getglobal(element:GetName().."Cooldown"):SetFrameStrata("MEDIUM");
								getglobal(element:GetName().."Cooldown"):SetFrameLevel(3);
								getglobal(element:GetName().."Cooldown"):SetScale(0.4)											
								getglobal(element:GetName().."AutoCast"):Hide()
								getglobal(element:GetName().."AutoCastable"):SetTexture("");						
								getglobal(element:GetName().."AutoCastSim"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonChecked.tga");						
								getglobal(element:GetName().."AutoCastSim"):SetAlpha(0);
								getglobal(element:GetName().."Icon"):ClearAllPoints();
								getglobal(element:GetName().."Icon"):SetPoint("TOPLEFT",5,-5);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMLEFT",5, 5);		
								getglobal(element:GetName().."Icon"):SetPoint("TOPRIGHT",-5,-5);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMRIGHT",5,5);			
								getglobal(element:GetName().."HotKey"):SetTextHeight(10);
								getglobal(element:GetName().."HotKey"):SetPoint("TOPLEFT", -6, -6);
								getglobal(element:GetName().."Count"):SetTextHeight(10);
								getglobal(element:GetName().."Count"):SetPoint("BOTTOMRIGHT", -6, 5);				

							elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

								element:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButton.tga")
								getglobal(element:GetName().."NormalTexture"):SetWidth(32);
								getglobal(element:GetName().."NormalTexture"):SetHeight(32);			
								getglobal(element:GetName().."NormalTexture"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture"):SetPoint("TOP",0,1);												
								getglobal(element:GetName().."Border"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonBorder.tga");
								getglobal(element:GetName().."Border"):SetWidth(36);
								getglobal(element:GetName().."Border"):SetHeight(36);			
								element:SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonHiLight.tga");			
								element:SetCheckedTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonChecked.tga");			
								element:SetPushedTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonPushed.tga");			
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
								getglobal(element:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButtonSheen.tga");
								getglobal(element:GetName().."Cooldown"):ClearAllPoints();
								getglobal(element:GetName().."Cooldown"):SetPoint("BOTTOMLEFT",12, 12);		
								getglobal(element:GetName().."Cooldown"):SetScale(0.5);
								getglobal(element:GetName().."Cooldown"):SetFrameStrata("LOW");
								getglobal(element:GetName().."Cooldown"):SetFrameLevel(1);
								getglobal(element:GetName().."Icon"):ClearAllPoints();
								getglobal(element:GetName().."Icon"):SetPoint("TOPLEFT",5,-5);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMLEFT",5, 5);		
								getglobal(element:GetName().."Icon"):SetPoint("TOPRIGHT",-5,-5);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMRIGHT",5,5);			
								if (not TrinityKeyBindingTextHidden) then
									getglobal(element:GetName().."HotKey"):Hide()
									getglobal(element:GetName().."HotKeyRound"):Show()
								end
								getglobal(element:GetName().."Count"):SetTextHeight(10);
								getglobal(element:GetName().."Count"):SetPoint("BOTTOMRIGHT", -6, 5);				
							end									
							
						end							
					end
					
				elseif (dockFrame.config["style"] == 3) then	
				
					for k,v in pairs(buttonList) do										
						if (dockFrame.config["btnType"] == "TrinityActionButton") then					
							local actionButton = getglobal(dockFrame.config["btnType"]..v);						
							actionButton.config["style"] = dockFrame.config["style"];
							actionButton:SetNormalTexture("")
							getglobal(actionButton:GetName().."NormalTexture"):SetWidth(60);
							getglobal(actionButton:GetName().."NormalTexture"):SetHeight(60);			
							getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
							getglobal(actionButton:GetName().."Border"):SetWidth(60);
							getglobal(actionButton:GetName().."Border"):SetHeight(60);			
							actionButton:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
							getglobal(dockFrame.config["btnType"]..v.."BindFrame"):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
							actionButton:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
							actionButton:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");			
							getglobal(actionButton:GetName().."Pushed"):SetWidth(38);
							getglobal(actionButton:GetName().."Pushed"):SetHeight(38);							
							getglobal(actionButton:GetName().."Sheen"):SetTexture("");			
							getglobal(actionButton:GetName().."IconFrame"):SetWidth(36);
							getglobal(actionButton:GetName().."IconFrame"):SetHeight(36);		
							getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("TOPLEFT",0,0)
							getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("BOTTOMRIGHT",0,0)
							getglobal(actionButton:GetName().."IconFrameIcon"):SetTexCoord(0.08,0.92,0.08,0.92);
							if (not TrinityKeyBindingTextHidden) then
								getglobal(actionButton:GetName().."HotKey"):Show()
								getglobal(actionButton:GetName().."HotKeyRound"):Hide()
							end
							getglobal(actionButton:GetName().."Count"):SetTextHeight(14);
							getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);																			
							Trinity_UpdateActionbar_OnEvent(actionButton)
							
						elseif (dockFrame.config["btnType"] == "TrinityAnchorButton") then
						
							local element = getglobal(getglobal(dockFrame.config["btnType"]..v).config["element"])
						
							if (dockFrame:GetID() == TrinityMiscBars["bags"]) then	

								element:SetNormalTexture("")
								getglobal(element:GetName().."NormalTexture"):SetWidth(60);
								getglobal(element:GetName().."NormalTexture"):SetHeight(60);
								getglobal(element:GetName().."NormalTexture"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture"):SetPoint("CENTER",0,0);												
								element:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
								element:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
								element:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");									
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");						
								getglobal(element:GetName().."Sheen"):SetTexture("");
								getglobal(element:GetName().."IconTexture"):ClearAllPoints();
								getglobal(element:GetName().."IconTexture"):SetPoint("TOPLEFT",0,0);		
								getglobal(element:GetName().."IconTexture"):SetPoint("BOTTOMLEFT",0,0);		
								getglobal(element:GetName().."IconTexture"):SetPoint("TOPRIGHT",0,0);		
								getglobal(element:GetName().."IconTexture"):SetPoint("BOTTOMRIGHT",0,0);
								getglobal(element:GetName().."IconTexture"):SetTexCoord(0.08,0.92,0.08,0.92);
								
							elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

								element:SetNormalTexture("")
								getglobal(element:GetName().."NormalTexture2"):SetWidth(60);
								getglobal(element:GetName().."NormalTexture2"):SetHeight(60);			
								getglobal(element:GetName().."NormalTexture2"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture2"):SetPoint("CENTER",0,0);									
								getglobal(element:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
								getglobal(element:GetName().."Border"):SetWidth(60);
								getglobal(element:GetName().."Border"):SetHeight(60);			
								element:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
								element:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
								element:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
								getglobal(element:GetName().."Sheen"):SetTexture("");
								getglobal(element:GetName().."Cooldown"):ClearAllPoints();
								getglobal(element:GetName().."Cooldown"):SetPoint("TOPLEFT", getglobal(element:GetName().."Icon"), "TOPLEFT" , 0, 0);		
								getglobal(element:GetName().."Cooldown"):SetPoint("BOTTOMRIGHT", getglobal(element:GetName().."Icon"), "BOTTOMRIGHT" , 0, 0);								
								getglobal(element:GetName().."Cooldown"):SetFrameStrata("MEDIUM");
								getglobal(element:GetName().."Cooldown"):SetFrameLevel(3);
								if ( autoCastAllowed ) then
									getglobal(element:GetName().."AutoCastable"):Show();
								else
									getglobal(element:GetName().."AutoCastable"):Hide();
								end
								if ( autoCastEnabled ) then
									getglobal(element:GetName().."AutoCast"):Show();
								else
									getglobal(element:GetName().."AutoCast"):Hide();
								end				
								getglobal(element:GetName().."AutoCastSim"):SetTexture("");						
								getglobal(element:GetName().."AutoCastable"):SetTexture("Interface\Buttons\UI-AutoCastableOverlay");
								getglobal(element:GetName().."Icon"):ClearAllPoints();
								getglobal(element:GetName().."Icon"):SetPoint("TOPLEFT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMLEFT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("TOPRIGHT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMRIGHT",0,0);
								if (not TrinityKeyBindingTextHidden) then
									getglobal(element:GetName().."HotKey"):Show();
								end
								getglobal(element:GetName().."HotKey"):SetPoint("TOPLEFT", -1, -5);
								getglobal(element:GetName().."Count"):SetTextHeight(14);
								getglobal(element:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);						

							elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

								element:SetNormalTexture("")
								getglobal(element:GetName().."NormalTexture"):SetWidth(60);
								getglobal(element:GetName().."NormalTexture"):SetHeight(60);			
								getglobal(element:GetName().."NormalTexture"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture"):SetPoint("CENTER",0,0);									
								getglobal(element:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
								getglobal(element:GetName().."Border"):SetWidth(60);
								getglobal(element:GetName().."Border"):SetHeight(60);			
								element:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
								element:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
								element:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
								getglobal(element:GetName().."Sheen"):SetTexture("");
								getglobal(element:GetName().."Cooldown"):ClearAllPoints();
								getglobal(element:GetName().."Cooldown"):SetPoint("BOTTOMLEFT",0, 0);		
								getglobal(element:GetName().."Cooldown"):SetScale(0.83);
								getglobal(element:GetName().."Cooldown"):SetFrameStrata("LOW");			
								getglobal(element:GetName().."Icon"):ClearAllPoints();
								getglobal(element:GetName().."Icon"):SetPoint("TOPLEFT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMLEFT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("TOPRIGHT",0,0);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
								if (not TrinityKeyBindingTextHidden) then								
									getglobal(element:GetName().."HotKey"):Show()
									getglobal(element:GetName().."HotKeyRound"):Hide()
								end
								getglobal(element:GetName().."Count"):SetTextHeight(14);
								getglobal(element:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);				
							end						
						end							
					end
					
				elseif (dockFrame.config["style"] == 4) then
				
					for k,v in pairs(buttonList) do						
						if (dockFrame.config["btnType"] == "TrinityActionButton") then
						
							local actionButton = getglobal(dockFrame.config["btnType"]..v);						
							actionButton.config["style"] = dockFrame.config["style"];
							actionButton:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\diamond.tga")
							getglobal(actionButton:GetName().."NormalTexture"):SetWidth(36);
							getglobal(actionButton:GetName().."NormalTexture"):SetHeight(36);			
							getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\diamondBorder.tga");
							getglobal(actionButton:GetName().."Border"):SetWidth(36);
							getglobal(actionButton:GetName().."Border"):SetHeight(36);			
							actionButton:SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\diamondHighlight.tga");			
							getglobal(dockFrame.config["btnType"]..v.."BindFrame"):SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\diamondHighlight.tga");			
							actionButton:SetCheckedTexture("Interface\\Addons\\TrinityBars\\Images\\diamondChecked.tga");			
							actionButton:SetPushedTexture("Interface\\Addons\\TrinityBars\\Images\\diamondPushed.tga");			
							getglobal(actionButton:GetName().."Pushed"):SetWidth(36);
							getglobal(actionButton:GetName().."Pushed"):SetHeight(36);							
							getglobal(actionButton:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\diamondSheen.tga");			
							getglobal(actionButton:GetName().."Sheen"):SetWidth(34);
							getglobal(actionButton:GetName().."Sheen"):SetHeight(34);
							getglobal(actionButton:GetName().."Sheen"):SetPoint("CENTER",0,0);									
							getglobal(actionButton:GetName().."IconFrame"):SetWidth(19);
							getglobal(actionButton:GetName().."IconFrame"):SetHeight(19);
							getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("TOPLEFT",0,0)
							getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("BOTTOMRIGHT",0,0)							
							
							if (not TrinityKeyBindingTextHidden) then
								getglobal(actionButton:GetName().."HotKey"):Hide()
								getglobal(actionButton:GetName().."HotKeyRound"):Show()
							end
							getglobal(actionButton:GetName().."Count"):SetTextHeight(10);
							getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOM", 0, 0);																
							Trinity_UpdateActionbar_OnEvent(actionButton)
							
						elseif (dockFrame.config["btnType"] == "TrinityAnchorButton") then
						
							local element = getglobal(getglobal(dockFrame.config["btnType"]..v).config["element"])
							
							if (dockFrame:GetID() == TrinityMiscBars["bags"]) then	

								element:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\diamond.tga")
								getglobal(element:GetName().."NormalTexture"):SetWidth(37);
								getglobal(element:GetName().."NormalTexture"):SetHeight(37);
								getglobal(element:GetName().."NormalTexture"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture"):SetPoint("TOP",0,0);												
								element:SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\diamondHighlight.tga");			
								element:SetCheckedTexture("Interface\\Addons\\TrinityBars\\Images\\diamondChecked.tga");			
								element:SetPushedTexture("Interface\\Addons\\TrinityBars\\Images\\diamondPushed.tga");						
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
								getglobal(element:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\diamondSheen.tga");
								getglobal(element:GetName().."IconTexture"):ClearAllPoints();
								getglobal(element:GetName().."IconTexture"):SetPoint("TOPLEFT",8.5,-8.5);		
								getglobal(element:GetName().."IconTexture"):SetPoint("BOTTOMRIGHT",-8.5,8.5);
								getglobal(element:GetName().."IconTexture"):SetTexCoord(0,1,0,1);

							elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

								element:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\diamond.tga")
								getglobal(element:GetName().."NormalTexture2"):SetWidth(30);
								getglobal(element:GetName().."NormalTexture2"):SetHeight(30);			
								getglobal(element:GetName().."NormalTexture2"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture2"):SetPoint("TOP",0,0);																	
								getglobal(element:GetName().."Border"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\diamondBorder.tga");
								getglobal(element:GetName().."Border"):SetWidth(36);
								getglobal(element:GetName().."Border"):SetHeight(36);			
								element:SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\diamondHighlight.tga");			
								element:SetCheckedTexture("Interface\\Addons\\TrinityBars\\Images\\diamondChecked.tga");			
								element:SetPushedTexture("Interface\\Addons\\TrinityBars\\Images\\diamondPushed.tga");			
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
								getglobal(element:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\diamondSheen.tga");			
								getglobal(element:GetName().."Sheen"):SetWidth(30);
								getglobal(element:GetName().."Sheen"):SetHeight(30);											
								getglobal(element:GetName().."AutoCast"):Hide()
								getglobal(element:GetName().."AutoCastable"):SetTexture("");						
								getglobal(element:GetName().."AutoCastSim"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\diamondChecked.tga");						
								getglobal(element:GetName().."AutoCastSim"):SetAlpha(0);
								getglobal(element:GetName().."Icon"):ClearAllPoints();
								getglobal(element:GetName().."Icon"):SetPoint("TOPLEFT",7,-7);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMRIGHT",-7,7);										
								getglobal(element:GetName().."Cooldown"):ClearAllPoints();
								getglobal(element:GetName().."Cooldown"):SetPoint("TOPLEFT", getglobal(element:GetName().."Icon"), "TOPLEFT" , 0, 0);		
								getglobal(element:GetName().."Cooldown"):SetPoint("BOTTOMRIGHT", getglobal(element:GetName().."Icon"), "BOTTOMRIGHT" , 0, 0);								
								getglobal(element:GetName().."Cooldown"):SetFrameStrata("MEDIUM");
								getglobal(element:GetName().."Cooldown"):SetFrameLevel(3);		
								getglobal(element:GetName().."Cooldown"):SetScale(0.4)											
								getglobal(element:GetName().."HotKey"):SetTextHeight(10);
								getglobal(element:GetName().."HotKey"):SetPoint("TOPLEFT", -6, -6);
								getglobal(element:GetName().."Count"):SetTextHeight(10);
								getglobal(element:GetName().."Count"):SetPoint("BOTTOMRIGHT", -6, 5);				

							elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

								element:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\diamond.tga")
								getglobal(element:GetName().."NormalTexture"):SetWidth(30);
								getglobal(element:GetName().."NormalTexture"):SetHeight(30);			
								getglobal(element:GetName().."NormalTexture"):ClearAllPoints();
								getglobal(element:GetName().."NormalTexture"):SetPoint("TOP",0,0);												
								getglobal(element:GetName().."Border"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\diamondBorder.tga");
								getglobal(element:GetName().."Border"):SetWidth(36);
								getglobal(element:GetName().."Border"):SetHeight(36);			
								element:SetHighlightTexture("Interface\\Addons\\TrinityBars\\Images\\diamondHighlight.tga");			
								element:SetCheckedTexture("Interface\\Addons\\TrinityBars\\Images\\diamondChecked.tga");			
								element:SetPushedTexture("Interface\\Addons\\TrinityBars\\Images\\diamondPushed.tga");			
								element:CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
								getglobal(element:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityBars\\Images\\diamondSheen.tga");
								getglobal(element:GetName().."Sheen"):SetWidth(30);
								getglobal(element:GetName().."Sheen"):SetHeight(30);			
								getglobal(element:GetName().."Cooldown"):ClearAllPoints();
								getglobal(element:GetName().."Cooldown"):SetPoint("BOTTOMLEFT",12, 12);		
								getglobal(element:GetName().."Cooldown"):SetScale(0.5);
								getglobal(element:GetName().."Cooldown"):SetFrameStrata("LOW");
								getglobal(element:GetName().."Cooldown"):SetFrameLevel(1);
								getglobal(element:GetName().."Icon"):ClearAllPoints();
								getglobal(element:GetName().."Icon"):SetPoint("TOPLEFT",7,-7);		
								getglobal(element:GetName().."Icon"):SetPoint("BOTTOMRIGHT",-7,7);			
								if (not TrinityKeyBindingTextHidden) then
									getglobal(element:GetName().."HotKey"):Hide()
									getglobal(element:GetName().."HotKeyRound"):Show()
								end
								getglobal(element:GetName().."Count"):SetTextHeight(10);
								getglobal(element:GetName().."Count"):SetPoint("BOTTOMRIGHT", -6, 5);				
							end									
							
						end							
					end
				end
			end
		end
	end
	
	TrinityShapeshiftBar_UpdateState()

	TrinityPetActionBar_Update()	
	
	TrinityUpdateDocking(dockFrame);
end

function TrinityChangeBarType(frame)

	TrinityFunctionCounter("TrinityChangeBarType")	

end

function TrinityBars_IconDraggingFrame_OnUpdate(arg1)

	TrinityFunctionCounter("TrinityBars_IconDraggingFrame_OnUpdate")

	local pos;
	local xpos,ypos = GetCursorPosition();
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom();

	xpos = xmin-xpos/Minimap:GetEffectiveScale()+70;
	ypos = ypos/Minimap:GetEffectiveScale()-ymin-70;

	pos = math.deg(math.atan2(ypos,xpos));	
	
	xpos = 80*cos(pos);
	ypos = 80*sin(pos);	

	TrinityBarsMinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-xpos,ypos-55);
	TrinityBarsMinimapButton:SetUserPlaced(true);
	TrinityBarsButtonLoc = { 50-xpos, ypos-54 };
end

function TrinityHideKeyBindings()

	TrinityFunctionCounter("TrinityHideKeyBindings")
	
	if (TrinityKeyBindingTextHidden) then
		for i=1,120 do
			getglobal("TrinityActionButton"..i.."HotKey"):Hide();
			getglobal("TrinityActionButton"..i.."HotKeyRound"):Hide();
			
		end
		for i=1,10 do		
			getglobal("ShapeshiftButton"..i.."HotKey"):Hide();			
			getglobal("ShapeshiftButton"..i.."HotKeyRound"):Hide();			
		end
		
	else
		for i=1,120 do
			if (getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i).config["dock"]).config["style"] == 2 or
			    getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i).config["dock"]).config["style"] == 4) then
				getglobal("TrinityActionButton"..i.."HotKeyRound"):Show();
			else
				getglobal("TrinityActionButton"..i.."HotKey"):Show();
			end		
		end
		for i=1,10 do		
			if (getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i).config["dock"]).config["style"] == 2 or
			    getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i).config["dock"]).config["style"] == 4) then
				getglobal("ShapeshiftButton"..i.."HotKeyRound"):Show();			
			else
				getglobal("ShapeshiftButton"..i.."HotKey"):Show();			
			end
		end		
	end	
end

-- A function to determine where the mouse is located for the binding tool.
function TrinityProcessBindingOnUpdate(elapsed)

	TrinityFunctionCounter("TrinityProcessBindingOnUpdate")

	if (this.elapsedTime) then
		this.elapsedTime = this.elapsedTime + elapsed;
	else
		this.elapsedTime = elapsed;
	end
	
	if (this.reminder) then
		this.reminder = this.reminder + elapsed;
	else
		this.reminder = elapsed;
	end
	
	if (this.elapsedTime < 0.1) then
		return;
	end	
	
	if (this.reminder > 20) then
		UIErrorsFrame:AddMessage("Key Binding is Active.", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);												
		this.reminder = nil;
	end	
	
	this.elapsedTime = nil;	
	
	if (TrinityKeyBindButton == 0) then
	
		local obj = GetMouseFocus();
		local frame, id;
	
		if (obj and obj:GetName()) then
			frame = obj:GetName();
			id = obj:GetID();		
			if (string.find(frame, "TrinityActionButton")) then
				this:EnableKeyboard(true);				
				GameTooltip:AddLine("\nHit a key to bind it to |cff00ff00Action Button "..id.."|r", 1.0, 1.0, 1.0);
				GameTooltip:AddLine("Hit |cfff00000ESC|r to clear this button's current binding", 1.0, 1.0, 1.0);
				TrinityKeyBindButton = id;				
			end
		end			
	end
	
	if (not TrinityKeyBindSpell) then
	
		local obj = GetMouseFocus();
		local frame, id;
	
		if (obj and obj:GetName()) then
			frame = obj:GetName();
			id = obj:GetID();		
			if (string.find(frame, "TrinitySpellBinderButton")) then
				if (string.find(obj:GetParent():GetName(), "SpellButton") and getglobal(obj:GetParent():GetName().."IconTexture"):IsVisible()) then
					local spellid = SpellBook_GetSpellID(id);
					local spellName, subSpellName = GetSpellName(spellid, SpellBookFrame.bookType);
					local texture = GetSpellTexture(spellid, SpellBookFrame.bookType);					
					if (spellName) then
						this:EnableKeyboard(true);				
						if (subSpellName) then					
							GameTooltip:AddLine("\n Hit a key to bind it to |cff00ff00"..spellName.."("..subSpellName..")|r", 1.0, 1.0, 1.0);	
							GameTooltip:AddLine(" Hit |cfff00000ESC|r to clear this spell's binding", 1.0, 1.0, 1.0);																				
							TrinityKeyBindSpell = spellid..spellName.."("..subSpellName..")";
						else
							GameTooltip:AddLine("\n Hit a key to bind it to |cff00ff00"..spellName.."()|r", 1.0, 1.0, 1.0);	
							GameTooltip:AddLine(" Hit |cfff00000ESC|r to clear this spell's binding", 1.0, 1.0, 1.0);																				
							TrinityKeyBindSpell = spellid..spellName.."()";
						end
					end
				elseif (string.find(obj:GetParent():GetName(), "ShapeshiftButton")) then
			 		local _, formName, _ = GetShapeshiftFormInfo(obj:GetID()-12); 														
					this:EnableKeyboard(true);				
					GameTooltip:AddLine("\n Hit a key to bind it to |cff00ff00"..formName.."()|r", 1.0, 1.0, 1.0);	
					GameTooltip:AddLine(" Hit |cfff00000ESC|r to clear this form's binding", 1.0, 1.0, 1.0);																				
					TrinityKeyBindSpell = formName.."()";				
				end
			end
		end
	end
	
	GameTooltip:Show();
end

-- The main function to bind keys to buttons.
function TrinityProcessBinding(bindkey, modifier, spell)	

	TrinityFunctionCounter("TrinityProcessBinding")

	local key;
	local keytext;	
	local actionButton = getglobal("TrinityActionButton"..TrinityKeyBindButton);
	
	if (bindkey == "PRINTSCREEN") then
		return;
	end
	
	if (bindkey == "ESCAPE") then	
		if (spell) then
			key = TrinitySpellBindings[spell]
			keytext = TrinitySpellBindings[spell.."-HotKey"]
			TrinityClearSpellBinding(key, keytext)
		else
			key = actionButton.config["HotKey1"]
			TrinityClearBinding(actionButton, key, keytext)
			SetBindingClick(key, TrinityActionButton0:GetName());
		end
		
		TrinityUpdateBindings();
		
		return;
	end		
	
	if (modifier) then
		key = modifier..bindkey;
		
		if (string.find(bindkey, "BUTTON")) then			
			keytext = string.lower(string.gsub(modifier, "(%S)(%S+)", "%1"))..string.gsub(bindkey,"(%S+)(%d+)","m%2");			
		elseif (string.find(bindkey, "NUMPAD")) then
			keytext = string.lower(string.gsub(modifier, "(%S)(%S+)", "%1"))..string.gsub(bindkey,"NUMPAD","n");			
			keytext = string.gsub(keytext,"DIVIDE","/");
			keytext = string.gsub(keytext,"MULTIPLY","*");
			keytext = string.gsub(keytext,"MINUS","-");
			keytext = string.gsub(keytext,"PLUS","+");
			keytext = string.gsub(keytext,"DECIMAL",".");			
		elseif (string.find(bindkey, "MOUSEWHEEL")) then			
			keytext = string.lower(string.gsub(modifier, "(%S)(%S+)", "%1"))..string.gsub(bindkey,"MOUSEWHEEL","mw");			
			keytext = string.gsub(keytext,"UP","U"); 
			keytext = string.gsub(keytext,"DOWN","D");
		else
			keytext = string.lower(string.gsub(modifier, "(%S)(%S+)", "%1"))..bindkey;  
		end
	else
		key = bindkey;
		
		if (string.find(bindkey, "BUTTON")) then
			keytext = string.gsub(bindkey,"(%S+)(%d+)","m%2");			
		elseif (string.find(bindkey, "NUMPAD")) then			
			keytext = string.gsub(bindkey,"NUMPAD","n");			
			keytext = string.gsub(keytext,"DIVIDE","/");
			keytext = string.gsub(keytext,"MULTIPLY","*");
			keytext = string.gsub(keytext,"MINUS","-");
			keytext = string.gsub(keytext,"PLUS","+");
			keytext = string.gsub(keytext,"DECIMAL",".");			
		elseif (string.find(bindkey, "MOUSEWHEEL")) then			
			keytext = string.gsub(bindkey,"MOUSEWHEEL","mw");			
			keytext = string.gsub(keytext,"UP","U"); 
			keytext = string.gsub(keytext,"DOWN","D");
		else
			keytext = bindkey;
		end
	end
	
	TrinityClearSpellBinding(key, keytext)
	
	for i=1,120 do
		local button = getglobal("TrinityActionButton"..i);
		if (i~=actionButton:GetID()) then
			if (actionButton.config["dock"] == button.config["dock"]) then
				if (actionButton.config["header"] == button.config["header"]) then
					if (tonumber(actionButton.config["showstate"]) == tonumber(button.config["showstate"])) then
						if (key == button.config["HotKey1"]) then
							TrinityClearBinding(button, key, keytext)
						end
					elseif (actionButton.config["dockpos"] == button.config["dockpos"]) then
						if (not button.config["HotKey1"] or button.config["HotKey1"] == "") then
							TrinitySetBinding(button, key, keytext)
						end
					end
				elseif (actionButton.config["dockpos"] == button.config["dockpos"]) then
					if (not button.config["HotKey1"] or button.config["HotKey1"] == "") then
						TrinitySetBinding(button, key, keytext)			
					end
				end
			else
				if (key == button.config["HotKey1"]) then
					TrinityClearBinding(button, key, keytext)
				end
			end
		end
	end	
	
	SetBinding(key, nil);
	
	if (key and not spell) then	
		TrinitySetBinding(actionButton, key, keytext)			
	end
	
	if (spell) then	
		TrinitySpellBindings[spell] = key; 
		TrinitySpellBindings[spell.."-HotKey"] = keytext; 							
	end
	
	TrinityUpdateBindings();	
end

function TrinitySetBinding(button, key, keytext)

	TrinityFunctionCounter("TrinitySetBinding")

	local buttonHotkey = getglobal(button:GetName().."HotKey");
	local buttonHotkeyRound = getglobal(button:GetName().."HotKeyRound");			

	SetBindingClick(key, button:GetName());		
	TrinitySetStateBindings(button, key)
	
	buttonHotkey:SetText(keytext);
	buttonHotkeyRound:SetText(keytext);
	button.config["HotKey1"] = key;
	button.config["HotKeyText1"] = keytext;							
	
	
end

function TrinityClearBinding(button, key, keytext)

	TrinityFunctionCounter("TrinityClearBinding")

	local buttonHotkey = getglobal(button:GetName().."HotKey");
	local buttonHotkeyRound = getglobal(button:GetName().."HotKeyRound");			

	SetOverrideBinding(getglobal(button.config["header"]), false, key, nil);							
	TrinitySetStateBindings(button, nil)
	
	buttonHotkey:SetText("");
	buttonHotkeyRound:SetText("");
	button.config["HotKey1"] = "";
	button.config["HotKeyText1"] = "";
end

function TrinityClearSpellBinding(key, keytext)

	TrinityFunctionCounter("TrinityClearSpellBinding")

	SetBinding(key, nil);

	for k,v in pairs(TrinitySpellBindings) do
		if (v == key) then
			TrinitySpellBindings[k] = "";			
		end
		if (v == keytext) then
			TrinitySpellBindings[k] = "";
		end
	end
end

-- A function to initialize bindings at login and also to update all bindings after a new binding is made.
function TrinityClearBindingKeys()

	TrinityFunctionCounter("TrinityClearBindingKeys")

	for i=0,120 do	
		local actionButton = getglobal("TrinityActionButton"..i);
		if (actionButton.config["HotKey1"] and actionButton.config["HotKey1"] ~= "") then
			SetBinding(actionButton.config["HotKey1"], nil);			
		end
	end	
	for key, value in pairs(TrinitySpellBindings) do
		if (not string.find(key, "-HotKey")) then
			SetBinding(key, nil);			
		end
	end	
	
	SaveBindings(GetCurrentBindingSet());
end

function TrinityUpdateBindings()

	TrinityFunctionCounter("TrinityUpdateBindings")

	local dockFrame, actionButton, header, state

	if (not TrinityPlayerEnteredWorld) then	
		TrinityClearBindingKeys()
	end
	
	for i=1,120 do					
		actionButton = getglobal("TrinityActionButton"..i)
		key = actionButton.config["HotKey1"]			
		TrinitySetStateBindings(actionButton, key)					
	end		
	
	for k,v in pairs(TrinityDockFrames) do
	
		dockFrame = getglobal("TrinityDockFrame"..k)
		
		for key,value in pairs(dockFrame.headers) do			
			if (dockFrame.headers[key]["active"]) then					
				header = getglobal(dockFrame.headers[key]["name"])							
				state = header:GetAttribute("state-"..string.lower(key)) or 0;
				header:SetAttribute("state-"..string.lower(key), state+1);
				header:SetAttribute("state-"..string.lower(key), state);							
				SecureStateHeader_Refresh(header, state);							
				if (dockFrame.config["battle"]) then
					state = 1;
					SecureStateHeader_Refresh(header, state);							
				end							
			end
		end
	end
	
	TrinityStorageHeader:SetAttribute("state", 100);
	TrinityStorageHeader:SetAttribute("state", 99);							
	SecureStateHeader_Refresh(TrinityStorageHeader, 99);		

	for key, value in pairs(TrinitySpellBindings) do
		if (not string.find(key, "-HotKey")) then
			SetBindingSpell(value, key);			
		end
	end
	
 	for i=1,GetNumShapeshiftForms() do 		 		
 		local _, formName, _ = GetShapeshiftFormInfo(i); 		 		
 		getglobal("ShapeshiftButton"..i.."HotKey"):SetText();								
 		getglobal("ShapeshiftButton"..i.."HotKeyRound"):SetText();								
		formName = formName.."()-HotKey";
		for k,v in pairs(TrinitySpellBindings) do
			if (k == formName) then
				getglobal("ShapeshiftButton"..i.."HotKey"):SetText(v);								
				getglobal("ShapeshiftButton"..i.."HotKeyRound"):SetText(v);								
			end
		end 		
 	end		 	
 	
 	TrinitySaveButtonState();
end

-- A function to set which state a button will show based on the button header's state.
function TrinitySetStateBindings(actionButton, key)

	TrinityFunctionCounter("TrinitySetStateBindings")
	
	if (key) then
		SetBindingClick(key, actionButton:GetName());
	end

	if (tostring(actionButton:GetAttribute("showstates")) == "0") then
		actionButton:SetAttribute("bindings-zero", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "1") then
		actionButton:SetAttribute("bindings-one", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "2") then
		actionButton:SetAttribute("bindings-two", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "3") then
		actionButton:SetAttribute("bindings-three", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "4") then
		actionButton:SetAttribute("bindings-four", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "5") then
		actionButton:SetAttribute("bindings-five", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "6") then
		actionButton:SetAttribute("bindings-six", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "7") then
		actionButton:SetAttribute("bindings-seven", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "8") then
		actionButton:SetAttribute("bindings-eight", key);
	end
	if (tostring(actionButton:GetAttribute("showstates")) == "9") then
		actionButton:SetAttribute("bindings-nine", key);
	end	
	--if (tostring(actionButton:GetAttribute("showstates")) == "STORED") then
	--	if (key) then
	--		SetBindingClick(key, actionButton:GetName());
	--	end
	--end		
end

function TrinityPetButtonOnUpdate(elapsed)

	TrinityFunctionCounter("TrinityPetButtonOnUpdate")

	local autocast = getglobal(this:GetName().."AutoCastSim");
	local _, _, _, _, _, _, autoCastEnabled = GetPetActionInfo(this:GetID());	

	if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 2 or getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 4) then
		if (autoCastEnabled) then	
			local dockFrame = getglobal("TrinityDockFrame"..TrinityMiscBars["pet"])
	
			if (not dockFrame.dir) then
				dockFrame.dir = 0;
			end

			if (not dockFrame.roundtimer) then
				dockFrame.roundtimer = 0;
			else
				dockFrame.roundtimer = dockFrame.roundtimer + elapsed;
			end	
		
			if (dockFrame.dir == 1) then
				if ((1-(dockFrame.roundtimer/2)) >= 0) then
					autocast:SetAlpha(1-(dockFrame.roundtimer/2));		
					end
				if ((1-(dockFrame.roundtimer/2)) <= 0) then
					dockFrame.dir = 0;
					dockFrame.roundtimer = 0;
				end
			elseif (dockFrame.dir == 0) then
				if ((dockFrame.roundtimer/2) <= 1) then
					autocast:SetAlpha((dockFrame.roundtimer/2));		
				end
				if ((dockFrame.roundtimer/2) >= 1) then
					dockFrame.dir = 1;
					dockFrame.roundtimer = 0;
				end
			end
		end
	else
		autocast:SetAlpha(0);		
	end
end

function TrinityUpdateXPRep(statusbar, event, message)

	TrinityFunctionCounter("TrinityUpdateXPRep")

	if (not TrinityPlayerEnteredWorld) then
		return;
	end

	local currXP = UnitXP("player");
	local nextXP = UnitXPMax("player");
	local restedXP = GetXPExhaustion();
	local name, standingID, barMin, barMax, barValue, isHeader;
	local repLevel = "Unknown";

	if (event == "PLAYER_XP_UPDATE" or "PLAYER_ENTERING_WORLD") then

		local percentXP = (currXP/nextXP)*100;
		local restedLevels = GetXPExhaustion();
		local bubbles = currXP/(nextXP/20);	

		bubbles = string.gsub(bubbles,"(%d*)(%.)(%d*)","%1");

		if (restedXP ~= nil) then
			restedLevels = restedLevels/nextXP;
			restedLevels = string.gsub(restedLevels,"(%d*)(%.)(%d%d)(%d*)","%1%2%3");
			TrinityXPFrameInfo[3] = restedXP.." - "..restedLevels.." rested level(s)";
		else
			TrinityXPFrameInfo[3] = "No rested experience";
		end	

		percentXP = string.gsub(percentXP,"(%d*)(%.)(%d*)","%1");

		TrinityXPFrameInfo[2] = percentXP.."%";
		TrinityXPFrameInfo[1] = currXP.."/"..nextXP.." - "..bubbles.." (bubbles)";
		
		TrinityXPFrame.nextXP = nextXP;
		TrinityXPFrame.currXP = currXP;
		TrinityXPFrame.restedXP = restedXP;
	end
	
	if (event == "UPDATE_FACTION" or "CHAT_MSG_COMBAT_FACTION_CHANGE") then
	
		if (GetNumFactions() > 0) then
			TrinityReputationIndex = {}
			for i=1, GetNumFactions() do
				name, _, standingID, barMin, barMax, barValue, _, _, isHeader, _ = GetFactionInfo(i);
				if (not isHeader and barMax and barMax ~= 0) then
					TrinityReputationIndex[i] = name;
					if (TrinityReputationMonitor == 0 and name) then
						TrinityReputationMonitor = i;
						TrinityReputationSelect = i;
					end
				end

				if (TrinityReputationSelect == -1) then
					if (message) then
						if (string.find(message, name)) then
							TrinityReputationMonitor = i;
						end
					end
				else
					if (TrinityReputationSelect ~= 0) then
						TrinityReputationMonitor = TrinityReputationSelect;
					end
				end
			end			
			
			if (TrinityReputationMonitor) then
			
				name, _, standingID, barMin, barMax, barValue, _, _, isHeader, _ = GetFactionInfo(TrinityReputationMonitor);						

				if (standingID == 0) then
					repLevel = "Unknown";
				elseif (standingID == 1) then
					repLevel = "Hated";
				elseif (standingID == 2) then
					repLevel = "Hostile";
				elseif (standingID == 3) then
					repLevel = "Unfriendly";
				elseif (standingID == 4) then
					repLevel = "Neutral";
				elseif (standingID == 5) then
					repLevel = "Friendly";
				elseif (standingID == 6) then
					repLevel = "Honored";
				elseif (standingID == 7) then
					repLevel = "Revered";
				elseif (standingID == 8) then
					repLevel = "Exalted";
				else
					repLevel = "Unknown";
				end

				if (TrinityReputationIndex[TrinityReputationMonitor]) then					
					TrinityXPFrameInfo[4] = TrinityReputationIndex[TrinityReputationMonitor].." - "..repLevel.." ("..math.floor(((barValue-barMin)/(barMax-barMin))*100).."%)";        	
					TrinityXPFrameInfo[5] = TrinityReputationIndex[TrinityReputationMonitor].." - "..(barValue-barMin).."/"..(barMax-barMin);						
					TrinityXPFrame.repMax = barMax-barMin;
					TrinityXPFrame.repCurr = barValue-barMin;
					TrinityXPFrame.standingID = standingID;
					TrinityXPFrame.repLevel = repLevel;
				end
			end
		end
	end
	
	TrinityUpdateXPBar()
end

function TrinityXPBarOnClick(arg1)

	TrinityFunctionCounter("TrinityXPBarOnClick")

	TrinityXPTextIndex = TrinityXPTextIndex + 1;
	if ( TrinityXPTextIndex > getn(TrinityXPFrameInfo)) then
		TrinityXPTextIndex = 1;
	end							
	
	TrinityUpdateXPBar()
end

function TrinityUpdateXPBar()

	TrinityFunctionCounter("TrinityUpdateXPBar")

	TrinityXPFrameXPBarText:SetText(TrinityXPFrameInfo[TrinityXPTextIndex])
	
	if (TrinityXPTextIndex < 4) then
		if (TrinityXPFrame.restedXP ~= nil) then
			TrinityXPFrameBar:SetStatusBarColor(0.0, 0.39, 0.88, 1.0);
		else
			TrinityXPFrameBar:SetStatusBarColor(0.58, 0.0, 0.55, 1.0);
		end	

		if (TrinityXPFrame.nextXP) then
			TrinityXPFrameBar:SetMinMaxValues(0, TrinityXPFrame.nextXP);
		end
		if (TrinityXPFrame.currXP) then
			TrinityXPFrameBar:SetValue(TrinityXPFrame.currXP);	
		end
	else

		if (TrinityXPFrame.standingID == 0) then
			TrinityXPFrameBar:SetStatusBarColor(0.4, 0.4, 0.4, 1.0);
		elseif (TrinityXPFrame.standingID == 1) then
			TrinityXPFrameBar:SetStatusBarColor(0.8, 0.3, 0.22, 1.0);
		elseif (TrinityXPFrame.standingID == 2) then
			TrinityXPFrameBar:SetStatusBarColor(0.8, 0.3, 0.22, 1.0);
		elseif (TrinityXPFrame.standingID == 3) then
			TrinityXPFrameBar:SetStatusBarColor(0.75, 0.27, 0, 1.0);
		elseif (TrinityXPFrame.standingID == 4) then
			TrinityXPFrameBar:SetStatusBarColor(0.9, 0.7, 0, 1.0);
		elseif (TrinityXPFrame.standingID == 5) then
			TrinityXPFrameBar:SetStatusBarColor(0.0, 0.6, 0.1, 1.0);
		elseif (TrinityXPFrame.standingID == 6) then
			TrinityXPFrameBar:SetStatusBarColor(0.0, 0.6, 0.1, 1.0);
		elseif (TrinityXPFrame.standingID == 7) then
			TrinityXPFrameBar:SetStatusBarColor(0.0, 0.39, 0.88, 1.0);
		elseif (TrinityXPFrame.standingID == 8) then
			TrinityXPFrameBar:SetStatusBarColor(0.58, 0.0, 0.55, 1.0);
		else
			TrinityXPFrameBar:SetStatusBarColor(0.4, 0.4, 0.4, 1.0);
		end	

		if (TrinityXPFrame.repMax) then
			TrinityXPFrameBar:SetMinMaxValues(0, TrinityXPFrame.repMax);
		end
		if (TrinityXPFrame.repCurr) then
			TrinityXPFrameBar:SetValue(TrinityXPFrame.repCurr);					
		end
	end	
end

function TrinityRepDropDown_OnLoad()

	TrinityFunctionCounter("TrinityRepDropDown_OnLoad")
	
	if (TrinityReputationSelect == 0) then
		TrinityReputationSelect = TrinityReputationMonitor;
	end
	UIDropDownMenu_Initialize(TrinityXPFrameRepDropDown, TrinityRepDropDown_Initialize, "MENU");	
end

function TrinityRepDropDown_Initialize()

	TrinityFunctionCounter("TrinityRepDropDown_Initialize")

	local info = UIDropDownMenu_CreateInfo();
	local checked;
	
	info.text = "Auto Select";
	info.func = TrinitySelectRepFaction;
	if (TrinityReputationSelect == -1) then
		checked = 1;			
	else
		checked = nil;
	end
	info.value = -1
	info.checked = checked;
	UIDropDownMenu_AddButton(info);	

	for k,v in pairs(TrinityReputationIndex) do
		info.text = v;
		info.func = TrinitySelectRepFaction;
		if (k == TrinityReputationSelect) then
			checked = 1;			
		else
			checked = nil;
		end
		info.value = k
		info.checked = checked;
		UIDropDownMenu_AddButton(info);
	end
end

function TrinitySelectRepFaction()

	TrinityFunctionCounter("TrinitySelectRepFaction")
	
	TrinityReputationSelect = this.value
	TrinityUpdateXPRep(TrinityXPFrameBar, "UPDATE_FACTION", nil);	
end

-- Blizzard functions hooked and modified

local SavedUpdateTalentButton = UpdateTalentButton;
function TrinityUpdateTalentButton()

	TrinityFunctionCounter("TrinityUpdateTalentButton")

	if ( UnitLevel("player") < 10 ) then
		TalentMicroButton:Hide();
	else	
		TalentMicroButton:Show();		
	end
end
UpdateTalentButton = TrinityUpdateTalentButton;

SavedCastingBarFrame_OnUpdate = CastingBarFrame_OnUpdate;
function TrinityCastingBarFrame_OnUpdate()

	TrinityFunctionCounter("TrinityCastingBarFrame_OnUpdate")

	local barSpark = getglobal(this:GetName().."Spark");
	local barFlash = getglobal(this:GetName().."Flash");
	local barText = getglobal(this:GetName().."Text");			

	local timeLeft = nil;
	if ( this.casting ) then
		timeLeft = this.maxValue - this:GetValue();
	
	elseif ( this.channeling ) then
		timeLeft = this.duration + this:GetValue() - this.endTime;
	
	end
	
	-- Casting bar timer code thanks to Luinil of Suramar server	
	if ( timeLeft ) then
		timeleft = (timeLeft < 0.1) and 0.01 or timeLeft;
		local displayName = TrinityCastingBarTimer.castingInfo[this.unit];
		if not ( displayName ) then
			local _, text;
			if ( this.casting ) then
				_, _, text = UnitCastingInfo(this.unit);
			elseif ( this.channeling ) then
				_, _, text = UnitChannelInfo(this.unit);
			end
			if ( text ) then
				displayName = text.." - %0.1fs";
				TrinityCastingBarTimer.castingInfo[this.unit] = displayName;
			else
				displayName = (barText:GetText() or "").." - %0.1fs";
			end
		end
		barText:SetText( format(displayName, timeLeft) );
		if (this:GetOrientation() == "VERTICAL") then
			barText:SetText(string.gsub(barText:GetText(), ".", "%1\n"))
		end				
	end		

	if ( this.casting ) then
		local status = GetTime();
		if ( status > this.maxValue ) then
			status = this.maxValue;
		end
		if ( status == this.maxValue ) then
			this:SetValue(this.maxValue);
			CastingBarFrame_FinishSpell(barSpark, barFlash);
			return;
		end
		this:SetValue(status);
		if ( barFlash ) then
			barFlash:Hide();
		end
		if (this:GetName() == "TrinityCastingBar") then
			if (getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]).config["shape"] == 1) then			
				local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetParent():GetHeight();
				if ( sparkPosition < 0 ) then
					sparkPosition = 0;
				end		
				if ( barSpark ) then
					barSpark:SetPoint("CENTER", this, "BOTTOM", 0, sparkPosition);
				end			
		
			else
				local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetParent():GetWidth();
				if ( sparkPosition < 0 ) then
					sparkPosition = 0;
				end
				if ( barSpark ) then
					barSpark:SetPoint("CENTER", this, "LEFT", sparkPosition, 2);
				end			
			end
		else
			local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetWidth();
			if ( sparkPosition < 0 ) then
				sparkPosition = 0;
			end
			if ( barSpark ) then
				barSpark:SetPoint("CENTER", this, "LEFT", sparkPosition, 2);
			end
		end

	elseif ( this.channeling ) then
		local time = GetTime();
		if ( time > this.endTime ) then
			time = this.endTime;
		end
		if ( time == this.endTime ) then
			CastingBarFrame_FinishSpell(barSpark, barFlash);
			return;
		end
		local barValue = this.startTime + (this.endTime - time);
		this:SetValue( barValue );
		if ( barFlash ) then
			barFlash:Hide();
		end
	elseif ( GetTime() < this.holdTime ) then
		return;
	elseif ( this.flash ) then
		local alpha = 0;
		if ( barFlash ) then
			alpha = barFlash:GetAlpha() + CASTING_BAR_FLASH_STEP;
		end
		if ( alpha < 1 ) then
			if ( barFlash ) then
				barFlash:SetAlpha(alpha);
			end
		else
			if ( barFlash ) then
				barFlash:SetAlpha(1.0);
			end
			this.flash = nil;
		end
	elseif ( this.fadeOut ) then
		local alpha = this:GetAlpha() - CASTING_BAR_ALPHA_STEP;
		if ( alpha > 0 ) then
			this:SetAlpha(alpha);
		else
			this.fadeOut = nil;
			this:Hide();
		end
	end
end
CastingBarFrame_OnUpdate = TrinityCastingBarFrame_OnUpdate;

local SavedShapeshiftBar_UpdateState = ShapeshiftBar_UpdateState;
function TrinityShapeshiftBar_UpdateState()

	TrinityFunctionCounter("TrinityShapeshiftBar_UpdateState")

	if (TrinityPlayerEnteredWorld) then
		local numForms = GetNumShapeshiftForms();
		for i=1, NUM_SHAPESHIFT_SLOTS do
			button = getglobal("ShapeshiftButton"..i);
			icon = getglobal("ShapeshiftButton"..i.."Icon");
			if ( i <= numForms ) then
				texture, name, isActive, isCastable = GetShapeshiftFormInfo(i);
				icon:SetTexture(texture);		
				icon:SetTexCoord(0,1,0,1);
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["style"] == 3) then
					icon:SetTexCoord(0.08,0.92,0.08,0.92);
				end
				
				cooldown = getglobal("ShapeshiftButton"..i.."Cooldown");
				
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["style"] == 1) then
					--Cooldown stuffs				
					if ( texture ) then
						cooldown:Show();
					else
						cooldown:Hide();
					end		
				end
	
				start, duration, enable = GetShapeshiftFormCooldown(i);
				CooldownFrame_SetTimer(cooldown, start, duration, enable);
				
				if ( isActive ) then
					ShapeshiftBarFrame.lastSelected = button:GetID();
					button:SetChecked(1);
				else
					button:SetChecked(0);
				end
	
				if ( isCastable ) then
					icon:SetVertexColor(1.0, 1.0, 1.0);
				else
					icon:SetVertexColor(0.4, 0.4, 0.4);
				end
			end
		end
	end
end
ShapeshiftBar_UpdateState = TrinityShapeshiftBar_UpdateState;

SavedPetActionBarFrame_OnUpdate = PetActionBarFrame_OnUpdate;
function TrinityPetActionBarFrame_OnUpdate(elapsed)

	TrinityFunctionCounter("TrinityPetActionBarFrame_OnUpdate")
	--do nothing!
end
PetActionBarFrame_OnUpdate = TrinityPetActionBarFrame_OnUpdate

function TrinityTogglePetButtonGrid(dockFrame)

	TrinityFunctionCounter("TrinityTogglePetButtonGrid")

	if (TrinityDockFrameEditorLeft:GetParent() == getglobal("TrinityDockFrame"..TrinityMiscBars["pet"])) then
		dockFrame.config["showgrid"] = TrinityDockFrameEditorLeftShowGrid:GetChecked();
		TrinitySaveButtonState();

		for i=1,NUM_PET_ACTION_SLOTS do
			button = getglobal("PetActionButton"..i);
			local name, _, _, _, _, _, _ = GetPetActionInfo(i);
			if (TrinityDockFrameEditorLeftShowGrid:GetChecked()) then		
				if (button:GetParent():GetAttribute("showstates") ~= "STORED") then
					button:Show()
				else
					if (not name) then
						button:Hide()
					end
				end
			else
				if (not name) then
					button:Hide()
				end
			end
		end
	end
end

function TrinityPetActionBar_Update()

	TrinityFunctionCounter("TrinityPetActionBar_Update")

	if (TrinityPlayerEnteredWorld) then
		for i=1, NUM_PET_ACTION_SLOTS, 1 do
			petActionButton = getglobal("PetActionButton"..i);
			petActionButtonIcon = getglobal("PetActionButton"..i.."Icon");
			petAutoCastableTexture = getglobal("PetActionButton"..i.."AutoCastable");
			petAutoCastModel = getglobal("PetActionButton"..i.."AutoCast");
			local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
			if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 1 or
			    getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 3) then
				if ( autoCastAllowed ) then
					petAutoCastableTexture:Show();
				else
					petAutoCastableTexture:Hide();
				end
				if ( autoCastEnabled ) then
					petAutoCastModel:Show();
				else
					petAutoCastModel:Hide();				
				end				
			else
				petAutoCastableTexture:Hide();
				petAutoCastModel:Hide();				
			end

			petActionButtonIcon:SetTexCoord(0,1,0,1);

			if ( texture ) then
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 1) then
					petActionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
				elseif (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 2) then
					petActionButton:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButton.tga");
				elseif (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 4) then
					petActionButton:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\diamond.tga");					
				end
			else
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 1 or getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 3) then
					petActionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
				elseif (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 2) then
					petActionButton:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\RoundButton.tga");				
				elseif (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 4) then
					petActionButton:SetNormalTexture("Interface\\Addons\\TrinityBars\\Images\\diamond.tga");				
				end
			end

			if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 3) then
				petActionButtonIcon:SetTexCoord(0.08,0.92,0.08,0.92);
			end		
		end
	end
end

function TrinityBackpackUpdate(id)

	TrinityFunctionCounter("TrinityBackpackUpdate")
	
end

function TrinityUIParent_ManageFramePositions()

	TrinityFunctionCounter("TrinityUIParent_ManageFramePositions")

	if (TrinityPlayerEnteredWorld) then
		if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["style"] == 2) then
			for i=1, GetNumShapeshiftForms() do
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(32);
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(32);	
			end	
		end
		
		if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["style"] == 4) then
			for i=1, GetNumShapeshiftForms() do
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(30);
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(30);	
			end	
		end		
	end
end

-- set certain unneeded values to nil to avoid blocked action errors
UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomLeft"] = nil;
UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarRight"] = nil;
UIPARENT_MANAGED_FRAME_POSITIONS["ShapeshiftBarFrame"] = nil;
UIPARENT_MANAGED_FRAME_POSITIONS["PETACTIONBAR_YPOS"] = nil;

function TrinitySaveButtonState()

	TrinityFunctionCounter("TrinitySaveButtonState")

	local dockFrame, actionButton, anchorButton;
	
	TrinityBarsSavedState["docks"] = {}

	for k,v in pairs(TrinityDockFrames) do		
		if (TrinityDockFrames[k]) then		
			dockFrame = getglobal("TrinityDockFrame"..k);			
			TrinityBarsSavedState["docks"][k] = { dockFrame.headers, dockFrame.config, dockFrame:GetCenter() };
		end
	end	

	if (TrinityBarsSavedState["buttons"]) then	
		for i=1,120 do
			actionButton = getglobal("TrinityActionButton"..i);					
			TrinityBarsSavedState["buttons"][i] = { actionButton.config }			
		end
	end	
	
	if (TrinityBarsSavedState["anchors"]) then	
		for i=1,37 do
			anchorButton = getglobal("TrinityAnchorButton"..i);					
			TrinityBarsSavedState["anchors"][i] = { anchorButton.config }			
		end
	end		
	
	if (TrinityBarsSavedState["storage"]) then
		TrinityBarsSavedState["storage"] = { TrinityStorageHeader.data };		
	end
	
	TrinitySavedVersion = TrinityCurrentVersion;
end

function TrinityLoadSV()

	TrinityFunctionCounter("TrinityLoadSV")

	local dockFrame, actionButton, anchorButton
	local normalHeader, actionbarHeader, stanceHeader, stealthHeader, altHeader, ctrlHeader, shiftHeader, anchorHeader;

	if (TrinityBarsSavedState["docks"]) then		
		for k,v in pairs(TrinityBarsSavedState["docks"]) do
			if (TrinityBarsSavedState["docks"][k]) then
				dockFrame = TrinityCreateDockFrame(k)				
				dockFrame.headers = TrinityBarsSavedState["docks"][k][1];
				dockFrame.config = TrinityBarsSavedState["docks"][k][2];
				dockFrame.centerx = TrinityBarsSavedState["docks"][k][3];
				dockFrame.centery = TrinityBarsSavedState["docks"][k][4];
				
				for key,value in pairs(dockFrame.headers) do					
					if (dockFrame.headers[key]["active"]) then						
						if (key == "Normal") then	
							normalHeader = TrinityCreateNormalHeader(dockFrame)
						elseif (key == "Actionbar") then
							actionbarHeader = TrinityCreateActionbarHeader(dockFrame)
						elseif (key == "Stance") then
							stanceHeader = TrinityCreateStanceHeader(dockFrame)
						elseif (key == "Stealth") then
							stealthHeader = TrinityCreateStealthHeader(dockFrame)
						elseif (key == "Alt") then
							altHeader = TrinityCreateAltHeader(dockFrame)
						elseif (key == "Ctrl") then
							ctrlHeader = TrinityCreateCtrlHeader(dockFrame)
						elseif (key == "Shift") then
							shiftHeader = TrinityCreateShiftHeader(dockFrame)
						elseif (key == "Anchor") then
							anchorHeader = TrinityCreateAnchorHeader(dockFrame)							
						end
					end
					
					-- New Vars
					if (not dockFrame.headers[key]["stateRef"]) then
						dockFrame.headers[key]["stateRef"] = 0;
					end
					if (not dockFrame.config["battle"]) then
						dockFrame.config["battle"] = nil;
					end										

					-- New Vars					
				end

				for key,value in pairs(dockFrame.headers) do					
					if (dockFrame.headers[key]["active"]) then						
					
						if (key == "Normal") then	
							if (getglobal(dockFrame.headers[key]["parent"])) then
								normalHeader:SetParent(dockFrame.headers[key]["parent"])								
								normalHeader:SetAttribute("showstates", tostring(dockFrame.headers[key]["showstate"]));
							end
						elseif (key == "Actionbar") then
							if (dockFrame.headers[key]["parent"]) then
								getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", actionbarHeader);
								actionbarHeader:SetAttribute("showstates", tostring(dockFrame.headers[key]["showstate"]));
								actionbarHeader:SetAttribute("useparent-unit*", true);
							end							
						elseif (key == "Stance") then
							if (dockFrame.headers[key]["parent"]) then
								getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", stanceHeader);
								stanceHeader:SetAttribute("showstates", tostring(dockFrame.headers[key]["showstate"]));
								stanceHeader:SetAttribute("useparent-unit*", true);
							end							
						elseif (key == "Stealth") then
							if (dockFrame.headers[key]["parent"]) then
								getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", stealthHeader);
								stealthHeader:SetAttribute("showstates", tostring(dockFrame.headers[key]["showstate"]));
								stealthHeader:SetAttribute("useparent-unit*", true);
							end							
						elseif (key == "Alt") then
							if (dockFrame.headers[key]["parent"]) then
								getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", altHeader);
								altHeader:SetAttribute("showstates", tostring(dockFrame.headers[key]["showstate"]));
								altHeader:SetAttribute("useparent-unit*", true);
							end							
						elseif (key == "Ctrl") then
							if (dockFrame.headers[key]["parent"]) then
								getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", ctrlHeader);
								ctrlHeader:SetAttribute("showstates", tostring(dockFrame.headers[key]["showstate"]));
								ctrlHeader:SetAttribute("useparent-unit*", true);
							end							
						elseif (key == "Shift") then
							if (dockFrame.headers[key]["parent"]) then
								getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", shiftHeader);
								shiftHeader:SetAttribute("showstates", tostring(dockFrame.headers[key]["showstate"]));
								shiftHeader:SetAttribute("useparent-unit*", true);
							end			
						elseif (key == "Anchor") then
							if (dockFrame.headers[key]["parent"]) then
								getglobal(dockFrame.headers[key]["parent"]):SetAttribute("addchild", anchorHeader);
								anchorHeader:SetAttribute("showstates", tostring(dockFrame.headers[key]["showstate"]));
								anchorHeader:SetAttribute("useparent-unit*", true);
							end										
						end
					end
				end								
			end
		end
	end
	
	if (TrinityBarsSavedState["buttons"]) then		
		for i=1,getn(TrinityBarsSavedState["buttons"]) do					
			if (TrinityBarsSavedState["buttons"][i]) then				
				actionButton = TrinityCreateActionButton(i, TrinityBarsSavedState["buttons"][i][1]["dock"], TrinityBarsSavedState["buttons"][i][1]["showstate"], getglobal(TrinityBarsSavedState["buttons"][i][1]["header"]))						
				actionButton.config = TrinityBarsSavedState["buttons"][i][1];
				if (not actionButton.config["style"]) then
					actionButton.config["style"] = 1;
				end
			end
		end
	end	
	
	if (TrinityBarsSavedState["anchors"]) then		
		for i=1,getn(TrinityBarsSavedState["anchors"]) do					
			if (TrinityBarsSavedState["anchors"][i]) then
				anchorButton = TrinityCreateAnchorButton(i, TrinityBarsSavedState["anchors"][i][1]["dock"], TrinityBarsSavedState["anchors"][i][1]["showstate"], getglobal(TrinityBarsSavedState["anchors"][i][1]["header"]))						
				anchorButton.config = TrinityBarsSavedState["anchors"][i][1];
			end
		end
	end		
	
	if (TrinityBarsSavedState["storage"]) then		
		TrinityStorageHeader.data = TrinityBarsSavedState["storage"][1]
	end
	
	for k,v in pairs(TrinityStorageHeader.data["buttonIndex"]) do
		if (v == 1) then
			getglobal("TrinityActionButton"..k):ClearAllPoints();
			getglobal("TrinityActionButton"..k):SetClampedToScreen(false)
			getglobal("TrinityActionButton"..k):SetPoint("CENTER", "TrinityStorageHeader", "CENTER");
		end
	end
	
	TrinityStorageHeader.data["anchorCount"] = 0;
	for k,v in pairs(TrinityStorageHeader.data["anchorIndex"]) do
		if (getglobal("TrinityAnchorButton"..k)) then
			if (getglobal("TrinityAnchorButton"..k):GetAttribute("showstates") == "STORED") then
				TrinityStorageHeader.data["anchorIndex"][k] = 1;
				v = 1;
			else
				TrinityStorageHeader.data["anchorIndex"][k] = 0;
				v = 0;		
			end
			if (v == 1) then
				getglobal("TrinityAnchorButton"..k):ClearAllPoints();
				getglobal("TrinityAnchorButton"..k):SetClampedToScreen(false)
				getglobal("TrinityAnchorButton"..k):SetPoint("CENTER", "TrinityStorageHeader", "CENTER");
				TrinityStorageHeader.data["anchorCount"] = TrinityStorageHeader.data["anchorCount"] + 1;
			end
		end
	end	
	
	TrinitySavedVersion = TrinityCurrentVersion;
end

function TrinityFunctionCounter(functionName)
	
	if (TrinityDebugActive) then
		if (TrinityDebug[functionName]) then
			TrinityDebug[functionName] = TrinityDebug[functionName] + 1;
		else
			TrinityDebug[functionName] = 1;
		end
	end
end

function TrinitySlashHandler(msg)

	local commands = {};
	
	if ((not msg) or (strlen(msg) <= 0)) then		
		return;
	end
	
	string.gsub(msg, "(%S+)", function (cmd) table.insert(commands, cmd) end);	
	
	if (commands[1] == "on") then
	
	end

end